// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// Լ 
int putchar_0(char data);					// COM1 ۽
int getchar_0(void);						// COM1 

//  
char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// PortE 
// PORTE.5(OUT) : GLCD Reset
// PortE.7(IN)  : TSC2003 Interrupt PULL UP(external) 
	PORTE=0x20;						// Ʈ  reg             
	DDRE=0x20;                                              // Ʈ  reg(0Է,1)

//  ʱȭ(COM1)
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x33;

// External SRAM page configuration: 
//              -              / 0000h - FFFFh
// Lower page wait state(s): None
// Upper page wait state(s): 1r/w
	MCUCR=0xC0;
	XMCRA=0x02;

// Analog Comparator 
	ACSR=0x80;
	SFIOR=0x00;

	fdevopen(putchar_0,getchar_0,0);
// Global enable interrupts
	sei();
}

// =============================== COM1 ͷƮ ===========================
// [μ] void
// ----------------------------------------------------------------------------
SIGNAL(SIG_UART0_RECV)
{
char status,data;

	status=UCSR0A;
	data=UDR0;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

}

// ============================== COM1 1Ʈ ۽ =========================
// [μ] char data
// item1:  
// --------------------------------------------------------------------------
int putchar_0(char data)
{
	if(data == '\n'){
		while((UCSR0A & DATA_REGISTER_EMPTY) == 0);
		UDR0 = '\r';
	}
	while((UCSR0A & DATA_REGISTER_EMPTY) == 0);
	UDR0 = data;
	return(0);
}

// ============================== COM1 1Ʈ  =========================
// [μ] void
// []  
// --------------------------------------------------------------------------
int getchar_0(void)
{
	while((UCSR0A & RX_COMPLETE) == 0);
	return(UDR0);
}
