// ======================= ׷ LCD  α׷ ============================
//  : ABG128064A
// -----------------------------------------------------------------------------
// Ʈ
#include "eng8x16.fnt"
#include "han16x16.fnt"
// ϼ ->  ȯ ̺
#include "hconvtbl.inc"

// LCD ּ 
#define	LCD_CS1			0x04				// a3=0,a2=1
#define	LCD_CS2			0x08				// a3=1,a2=0
#define	LCD_CS_ALL		0x0c				// a3=1,a2=1

//  
#define 	_BLACK		0
#define 	_WHITE		15

// Լ 
void Clrscr(void);						// ü ȭ 
void Cleardevice(void);						// ü ȭ 
void Gotoxy(int x,int y);					// ׷ ǥ 
void Gotoxyt(int x,int y);					// ؽƮ ǥ 

void Setcolor(char color);					// ڻ (_WHITE,_BLACK)

void Putch(unsigned c); 					// ڸ 
void Putchxy(int x,int y,unsigned c);				// ׷ ǥ  
void Putchxyt(int x,int y,unsigned c);				// ؽƮ ǥ  

void Puts(const char *str);					// ڿ 
void Putsxy(int x,int y,const char *str);			// ׷ ǥ ڿ 
void Putsxyt(int x,int y,const char *str);			// ؽƮ ǥ ڿ 

void Puts_f(const char flash *str);				// CODE ڿ 
void Putsxy_f(int x,int y,const char flash *str);		// ׷ ǥ CODE ڿ 
void Putsxyt_f(int x,int y,const char flash *str);		// ؽƮ ǥ CODE ڿ 

void Line(int x1,int y1,int x2,int y2);				// ׷ǥ  ׸
void Rectangle(int x1,int y1,int x2,int y2);			// ׷ ǥ ڽ ׸
void Rectanglefill(int x1,int y1,int x2,int y2);		// ä ڽ ׸
void Circle(int xx,int yy,int radius);				//  ׸
void Ellipse(int xx,int yy,int a0,int b0);			// Ÿ ׸

void Putpixel(int x,int y,char color);				// ȭ鿡  (,,÷(_WHITE,BLACK))
void Putpixelb(int x,int y,unsigned char datac,char color);	// ȭ鿡 Ʈ 

void symmetry4(int xx,int yy,int x,int y);
void _Plotcircle(int xx,int yy,int x,int y);

void _Putch(unsigned int c);					// 1Ʈ  
void *_GetHanImage(unsigned c);					// ѱ Ʈ ε
void _memor(unsigned char *s1,unsigned char flash *s2, int len);// ѱ Ʈ 
unsigned char* _GetAscImage(int c);		        	//  Ʈ  ε
void Han_Conv(char *buf);					// ϼ(SRAM)  (SRAM) ȯ
void Han_Conv_f(char flash *buf);				// ϼ(FLASH) (SRAM) ȯ

// LCD H/W 
void Lcd_Init(void);						// GLCD Init
void GLCD_Busy(int port);					// LCD Busy Check
void GLCD_Command(int port,unsigned char uch);			// COMMAND Write
void GLCD_Dwrite(int port,unsigned char uch);			// DATA Write
unsigned char GLCD_Dread(int port);				// DATA 

//  
// ==== LCD  ====
// A0 : RS
// A1 : R/W
// A2 : CS1
// A3 : CS2
// ------------------
unsigned char *GLCD_DATA_RD = (unsigned char*)0x8003;		// Lcd Data Read (A3=0,A2=0,A1=1,A0=1)
unsigned char *GLCD_DATA_WR = (unsigned char*)0x8001;		// Lcd Data Write(A3=0,A2=0,A1=0,A0=1)
unsigned char *GLCD_CMD_RD  = (unsigned char*)0x8002;		// Lcd Instruction Register Read(A3=0,A2=0,A1=1,A0=0)
unsigned char *GLCD_CMD_WR  = (unsigned char*)0x8000;		// Lcd Instruction Register Write(A3=0,A2=0,A1=0,A0=0)

int _screen_color = _WHITE;					// ڻ 
int _screen_curx = 0;						// X ǥ 
int _screen_cury = 0;						// Yǥ 

static unsigned char ib[32];					// ѱ  
static unsigned char ascii_fbuf[20];                            //    
static unsigned char han_conv_buf[101];				// ѱ    

// =============================== LCD ȭ  ===============================
// [μ] void
// [] 128*64
// -----------------------------------------------------------------------------
void Clrscr(void)
{
	Cleardevice();						// ȭ 
}

// =============================== LCD ȭ  ===============================
// [μ] void
// [] 128*64
// -----------------------------------------------------------------------------
void Cleardevice(void)
{
int i,j,page,y;

	page = 0xb8;						// page address 0
	y = 0x40;						// Y address 0
	for(i = 0 ; i < 8; i++){				// page(0-7)
		GLCD_Command(LCD_CS_ALL,page);			// page set
		GLCD_Command(LCD_CS_ALL,y);			// Y address set
		for(j = 0; j < 64; j++){			// Y adress(0 - 63)
			GLCD_Dwrite(LCD_CS_ALL,0x00);		// data 0 write		
		}
		page++;						// page++
	}
	_screen_curx = _screen_cury = 0;
}

// ============================= ׷ ǥ  ==============================
// [μ] int x,int y
// Item1: x pos(0 - 127)
// Item2: y pos(0 - 63)
// -----------------------------------------------------------------------------
void Gotoxy(int x,int y)
{
	if(x >= 0 && x < 128){					// X ʰ ˻
		if(y >= 0 && y < 64){				// Y ʰ ˻
			_screen_curx = x;
			_screen_cury = y;
		}
	}
}

// ======================= ȭ鿡 ؽƮ ǥ  ===========================
// [μ] int x,int y
// Item1  x pos(1 - 16)
// Item2  y pos(1 - 4)
// [] _screen_curx,_screen_cury
// -----------------------------------------------------------------------------
void Gotoxyt(int x,int y)
{
int x1 = (x-1) * 8,y1;

	y1 = (y-1) * 16;
	if(x1 >= 0 && x1 < 128){
		if(y1 >= 0 && y1 < 64){
			_screen_curx = x1;
			_screen_cury = y1;
		}
	}
}

// =============================== ڻ  ===============================
// [μ] char color
// Item1: ڻ(_WHITE,_BLACK)
// -----------------------------------------------------------------------------
void Setcolor(char color)
{
	_screen_color = color;					// ڻ 
}

// ============================== ѹڸ  Ѵ. ==========================
// [μ] unsigned c
// Item1:  (ѱ ڵ )
// -----------------------------------------------------------------------------
void Putch(unsigned c)
{
	_Putch(c&0xff);						// 1Ʈ ڸ ǥ
}

// ================  ׷ ǥ ѹڸ  Ѵ. ===================
// [μ] int x
//	  int y
//	  unsigned c
// Item1:    ġ(0 - 127)
// Item2:    ġ(0 - 63)
// Item3:  ((ѱ ڵ )
// -----------------------------------------------------------------------------
void Putchxy(int x,int y,unsigned c)
{
	Gotoxy(x,y);						// Base Cursor Point Set
	Putch(c);						// 1Ʈ ڸ ǥ
}

// ===================  ؽƮ ǥ ѹڸ  Ѵ. ================
//  [μ] int x
//	   int y
//	   unsigned c
//  Item1:    ġ(1 - 16)
//  Item2:    ġ(1 - 4)
//  Item3:  (ѱ ڵ )
// -----------------------------------------------------------------------------
void Putchxyt(int x,int y,unsigned c)
{
	Gotoxyt(x,y);						// Base Cursor Point Set
	Putch(c);						// 1Ʈ ڸ ǥ
}

// ====================  Ŀ ġ  ڿ  Ѵ. ==================
//  [μ] const char *str
//  Item1:  ڿ(ѿ)
// -----------------------------------------------------------------------------
void Puts(const char *str)
{
unsigned char byte1st = 0,c;
unsigned datau,i = 0;

	Han_Conv((char*)str);					// ϼ  ȯ
	while((c = han_conv_buf[i++]) != 0){			// ҽ Han_Conv() 
//	while((c = *str++) != 0){				// 쿡 ϼ->  
		if(byte1st){
			datau = ((unsigned)byte1st << 8) | (unsigned)c;
			_Putch(datau);				// ѱ ڸ ǥ
			byte1st = 0;                    	
		}                                       	
		else if(c & 0x80){                      	
			byte1st = c;				// ѱ Ÿ 
		}                                       	
		else{                                   	
			if(c == 0x0a){				//  ǵ
				_Putch(0x0d);           	
				_Putch(0x0a);           	
			}                               	
			else _Putch(c); 			//  ڸ ǥ
		}
	}
}

// ================  Ŀ ġ  FLASH ڿ  Ѵ. ================
//  [μ] const char *str
//  Item1:  ڿ FLASH(ѿ)
// -----------------------------------------------------------------------------
void Puts_f(const char flash *str)
{
unsigned char byte1st = 0,c;
unsigned datau,i = 0;

	Han_Conv_f((char flash*)str);				// ϼ  ȯ
	while((c = han_conv_buf[i++]) != 0){			// ҽ Han_Conv() 
//	while((c = *str++) != 0){				// 쿡 ϼ->  
		if(byte1st){
			datau = ((unsigned)byte1st << 8) | (unsigned)c;
			_Putch(datau);				// ѱ ڸ ǥ
			byte1st = 0;                    	
		}                                       	
		else if(c & 0x80){                      	
			byte1st = c;				// ѱ Ÿ 
		}                                       	
		else{                                   	
			if(c == 0x0a){				//  ǵ
				_Putch(0x0d);           	
				_Putch(0x0a);           	
			}                               	
			else _Putch(c); 			//  ڸ ǥ
		}
	}
}

// ==================  ׷ ġ  ڿ  Ѵ. ==================
//  [μ] int x
//	   int x
//	   const char *str
//  Item1: Ŀ  ǥ(0 - 127)
//  Item2: Ŀ  ǥ(0 - 63)
//  Item3:  ڿ(ѿ)
// -----------------------------------------------------------------------------
void Putsxy(int x,int y,const char *str)
{
	Gotoxy(x,y);						// Ŀ ġ 
	Puts(str);						// ڿ ǥ
}

// ================  ׷ ġ FLASH ڿ  Ѵ. ===============
//  [μ] int x
//	   int x
//	   const char flash *str
//  Item1: Ŀ  ǥ(0 - 127)
//  Item2: Ŀ  ǥ(0 - 63)
//  Item3:  ڿ FLASH(ѿ)
// -----------------------------------------------------------------------------
void Putsxy_f(int x,int y,const char flash *str)
{
	Gotoxy(x,y);						// Ŀ ġ 
	Puts_f(str);						// ڿ ǥ
}

// ================  ؽƮ ġ  ڿ  Ѵ. ====================
//  [μ] int x
//	   int y
//	   const char *str
//  Item1: Ŀ  ǥ(1 - 16)
//  Item2: Ŀ  ǥ(1 - 4)
//  Item3:  ڿ(ѿ)
// -----------------------------------------------------------------------------
void Putsxyt(int x,int y,const char *str)
{
	Gotoxyt(x,y);						// Ŀ ġ 
	Puts(str);						// ڿ ǥ
}

// ===============  ؽƮ ġ FLASH ڿ  Ѵ. ================
//  [μ] int x
//	   int y
//	   const char flash *str
//  Item1: Ŀ  ǥ(1 - 16)
//  Item2: Ŀ  ǥ(1 - 4)
//  Item3:  ڿ FLASH(ѿ)
// -----------------------------------------------------------------------------
void Putsxyt_f(int x,int y,const char flash *str)
{
	Gotoxyt(x,y);						// Ŀ ġ 
	Puts_f(str);						// ڿ ǥ
}

// ============== ׷ LCD  ġ   ׸ ==============
// [μ] int x1
//	  int y1
//	  int x2
//	  int y2
// Item1:  xǥ
// Item2:  yǥ
// Item3:  xǥ
// Item4:  yǥ
// -----------------------------------------------------------------------------
void Line(int x1,int y1,int x2,int y2)
{
int i,vdx,vdy,vix,viy,vinc,plot,plotx,ploty,x = 0,y = 0;

	vdx = x2 - x1;						// vdx = x2 - x1
	vdy = y2 - y1;						// vdy = y2 - y1
	vix = abs(vdx);						// vix = |vdx|
	viy = abs(vdy); 					// vix = |vdx|
	if(vix > viy) vinc = vix;				// vinc = vix ? viy;
	else vinc = viy;

	plotx = x1;
	ploty = y1;
	Putpixel(plotx,ploty,_screen_color);
	for(i = 0; i <= vinc; i++){
		x += vix;
		y += viy;
		plot = 0;
		if(x > vinc){
			x -= vinc;
			if(vdx > 0) plotx++;
			if(vdx < 0) plotx--;
			plot = 1;
		}
		if(y > vinc){
			y -= vinc;
			if(vdy > 0) ploty++;
			if(vdy < 0) ploty--;
			plot = 1;
		}
		if(plot)Putpixel(plotx,ploty,_screen_color);
	}
}

// ================================== ڽ ׸ ==============================
// [μ] int x1
//	  int y1
//	  int x2
//	  int y2
// Item1:  xǥ
// Item2:  yǥ
// Item3:  xǥ
// Item4:  yǥ
// -----------------------------------------------------------------------------
void Rectangle(int x1,int y1,int x2,int y2)
{
	Line(x1,y1,x2,y1);
	Line(x1,y1,x1,y2);
	Line(x1,y2,x2,y2);
	Line(x2,y1,x2,y2);
}

// ============================== ä ڽ ׸ ===========================
// [μ] int x1
//	  int y1
//	  int x2
//	  int y2
// Item1:  xǥ
// Item2:  yǥ
// Item3:  xǥ
// Item4:  yǥ
// -----------------------------------------------------------------------------
void Rectanglefill(int x1,int y1,int x2,int y2)
{
	for( ; y1 <= y2; y1++) Line(x1,y1,x2,y1);
}

// ===============================  ׸ ===================================
// [μ] int xx
//	  int yy
//	  float radius
// Item1:  xǥ
// Item2:  yǥ
// Item3: 
// -----------------------------------------------------------------------------
void Circle(int xx,int yy,int radius)
{
int y = radius,d = 3-(y*2),x = 0;

	while(x < y){
		Putpixel(xx+x,yy+y,_screen_color);
		_Plotcircle(xx,yy,x,y);				// Ī Ŵ
		if(d < 0) d += (x*4+6);
		else{
			d += ((x-y)*4+10);
			y--;
		}
		x++;
	}
	if(x == y) Putpixel(xx+x,yy+y,_screen_color);
}

// ====================== ׸⿡ Ǵ Ī Լ ========================
void _Plotcircle(int xx,int yy,int x,int y)
{
	Putpixel(xx-x,yy+y,_screen_color);
	Putpixel(xx+x,yy-y,_screen_color);
	Putpixel(xx-x,yy-y,_screen_color);
	Putpixel(xx-y,yy+x,_screen_color);
	Putpixel(xx+y,yy-x,_screen_color);
	Putpixel(xx-y,yy-x,_screen_color);
	Putpixel(xx+y,yy+x,_screen_color);
}

// ================================== Ÿ ׸ ===============================
// [μ] int xx
//	  int yy
//	  int a0
//	  int b0
// Item1:  xǥ
// Item2:  yǥ
// Item3:  ݰ
// Item4:  ݰ
// -----------------------------------------------------------------------------
void Ellipse(int xx,int yy,int a0,int b0)
{
int x = 0,y = b0;
long a = a0,b = b0,a2 = a*a,a22 = 2*a2,b2 = b*b,b22 = 2*b2,d,dx,dy;

	d = b2-a2*b+a2/4L;
	dx=0L;
	dy=a22*b;
	while(dx < dy){
		symmetry4(xx,yy,x,y);
		if(d > 0){
			y--;
			dy-=a22;
			d-=dy;
		}
		x++;
		dx+=b22;
		d+=b2+dx;
	}
	d+=(3*(a2-b2)/2L-(dx+dy))/2L;
	while(y >= 0){
		symmetry4(xx,yy,x,y);
		if(d < 0){
			x++;
			dx+=b22;
			d+=dx;
		}
		y--;
		dy-=a22;
		d+=a2-dy;
	}
}

// ======================= Ÿ ׸⿡ Ǵ Ī Լ =====================
void symmetry4(int xx,int yy,int x,int y)
{
	Putpixel(xx-x,yy+y,_screen_color);
	Putpixel(xx+x,yy-y,_screen_color);
	Putpixel(xx-x,yy-y,_screen_color);
	Putpixel(xx+x,yy+y,_screen_color);
}

// =============================== ȭ鿡   ============================
// [μ] int x,int y,int color
// Item1:  ũ(0 - 127)
// Item2:  ũ(0 - 63)
// Item3: (_WHITE,_BLACK)
// -----------------------------------------------------------------------------
void Putpixel(int x,int y,char color)
{
unsigned char uch;
int page,port = LCD_CS1,x_addr = x;
int mask_data = 0x01;

// port  y address 
	if(x >= 64){
		x_addr = x - 64;				// X address 
		port = LCD_CS2;					// LCD CS2  
	}
// page  BITġ 
	page = y >> 3;						// page = y / 8
	mask_data = mask_data << (y & 0x07);			// mask_data = 1 << (y%8)		

// DD RAM ġ 
	GLCD_Command(port,page | 0xb8);				// page set
	GLCD_Command(port,x_addr | 0x40);			// Y address set
//  
	uch = GLCD_Dread(port);					//   dummy
	uch = GLCD_Dread(port);					//  
	if(color == _BLACK){
		mask_data = ~mask_data;				// mask data  0000 0001 -> 1111 1110
		uch = uch & mask_data;				// ش BIT 
	}
	else uch |= mask_data;

// DD RAM ġ 
	GLCD_Command(port,page | 0xb8);				// page set
	GLCD_Command(port,x_addr | 0x40);			// Y address set
//  
	GLCD_Dwrite(port,uch);					//  write
}

// ========================= ȭ ι 1BYTE  =======================
// [μ] int x,int y,unsigned char data,char color
// item1:  ũ(0 - 319)
// item2:  ũ(0 - 239)
// item3: Ÿ
// item4: 
// ------------------------------------------------------------------------------
void Putpixelb(int x,int y,unsigned char datac,char color)
{
unsigned char uch;
int page,port = LCD_CS1,x_addr = x,s_cnt;
unsigned mask_data = 0xff,datau;

// port  y address 
	if(x >= 64){
		x_addr = x - 64;				// Y address 
		port = LCD_CS2;					// LCD CS2  
	}
// page  BITġ 
	page = y >> 3;						// page = y / 8
	s_cnt = y & 0x07;					// shift cnt = y%8		
	mask_data = mask_data << s_cnt;				// mask data  0111 1101 -> 1111 1010
	datau = datac << s_cnt;					// ǥ  

// DD RAM ġ 
	GLCD_Command(port,page | 0xb8);				// page set
	GLCD_Command(port,x_addr | 0x40);			// Y address set
	
//  
	uch = GLCD_Dread(port);					//   dummy
	uch = GLCD_Dread(port);					//  
	if(color == _BLACK) uch = uch & ~datau;			// NEW  & ~
	else{
		uch = uch & ~mask_data;				//  SKIP
		uch = uch | datau;				// NEW  OR 
	}
// DD RAM ġ 
	GLCD_Command(port,page | 0xb8);				// page set
	GLCD_Command(port,x_addr | 0x40);			// Y address set
//  
	GLCD_Dwrite(port,uch);					//  write
	if(s_cnt != 0){						// 1Byte  ǥ  ʰ
		datau = datau >> 8;				//   ε
		mask_data = mask_data >> 8;			//  ũ ε
// DD RAM+1 ġ 
		GLCD_Command(port,(page+1) | 0xb8);		// page+1 set
		GLCD_Command(port,x_addr | 0x40);		// Y address set
//  
		uch = GLCD_Dread(port);				//   dummy
		uch = GLCD_Dread(port);				//  
		if(color == _BLACK) uch = uch & ~datau;		// NEW  & ~
		else{
			uch = uch & ~mask_data;			//  SKIP
			uch = uch | datau;			// NEW  OR 
		}
// DD RAM+1 ġ 
		GLCD_Command(port,(page+1) | 0xb8);		// page+1 set
		GLCD_Command(port,x_addr | 0x40);		// Y address set
//  
		GLCD_Dwrite(port,uch);				//  write
	}
}

// ========================= Ʈ     =========================
// [μ] unsigned int	c
// Item1:  
// ------------------------------------------------------------------------------
void _Putch(unsigned int c)
{
unsigned char *image;
int ch,i,curx1 = _screen_curx,cury1 = _screen_cury;

	if(c & 0x8000){						// ѱ ڵ Ÿ
		image = _GetHanImage(c);			// ѱ  
		for(i = 0; i < 16; i++){
			ch = *image++;				// ѱ  
			Putpixelb(curx1,cury1,ch,_screen_color);
			if(curx1 < 127) curx1++;		// Ŀ   
		}
		cury1 = _screen_cury+8;				// Yǥ+8
		if(cury1 < 64){
			curx1 = _screen_curx;			// Xǥ 
			for(i = 0; i < 16; i++){
				ch = *image++;			// Data Read
				Putpixelb(curx1,cury1,ch,_screen_color);
				if(curx1 < 127) curx1++;	// Ŀ   
			}
		}
		_screen_curx += 16;				// Ŀ   
		if(_screen_curx >= 128){
			_screen_curx = 0;
			_screen_cury += 16;			// Ŀ   
			if(_screen_cury >= 64) _screen_cury = 0;
		}
	}
	else{							//  ڵ Ÿ
		if(c == 0x0a){
			_screen_cury += 16;			// Ŀ   
			if(_screen_cury >= 64) _screen_cury = 0;// Ŀ   ˻
		}
		else if(c == 0x0d) _screen_curx = 0;		// Carrage Return
		else{
			image = _GetAscImage(c);		//   
			for(i = 0; i < 8; i++){
				ch = *image++;			// Data Read
				Putpixelb(curx1,cury1,ch,_screen_color);
				if(curx1 < 127) curx1++;	// Ŀ   
			}
			cury1 = _screen_cury+8;			// Yǥ+8
			if(cury1 < 64){
				curx1 = _screen_curx;		// Xǥ 
				for(i = 0; i < 8; i++){
					ch = *image++;		// Data Read
					Putpixelb(curx1,cury1,ch,_screen_color);
					if(curx1 < 127) curx1++;// Ŀ   
				}
			}
			_screen_curx += 8;			// Ŀ   
			if(_screen_curx >= 128){
				_screen_curx = 0;
				_screen_cury += 16;		// Ŀ   
				if(_screen_cury >= 64) _screen_cury = 0;
			}
		}
	}
}

// ======================== ѱ Ʈ Ÿ   ======================
//  [μ] unsigned c
//  Item1: ȯ Ÿ
//   : ȯ  
// ------------------------------------------------------------------------------
void *_GetHanImage(unsigned c)
{
unsigned h, h1, h2, h3, type1, type2, type3, pos;

	static char idxtbl1[] = {				// ʼ ε ̺
		 0,  0,  1,  2,  3,  4,  5,  6,
		 7,  8,  9, 10, 11, 12, 13, 14,
		15, 16, 17, 18, 19,  0,  0,  0,
		 0,  0,  0,  0,  0,  0,  0,  0
	};
	static char idxtbl2[] = {				// ߼ ε ̺
		 0,  0,  0,  1,  2,  3,  4,  5,
		 0,  0,  6,  7,  8,  9, 10, 11,
		 0,  0, 12, 13, 14, 15, 16, 17,
		 0,  0, 18, 19, 20, 21,  0,  0
	};
	static char idxtbl3[] = {				//  ε ̺
		 0,  0,  1,  2,  3,  4,  5,  6,
		 7,  8,  9, 10, 11, 12, 13, 14,
		15, 16,  0, 17, 18, 19, 20, 21,
		22, 23, 24, 25, 26, 27,  0,  0
    };
	static char type1tbl_no[]  = {				// ߼  ʼ /ħ 
		0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3,
		3, 3, 1, 2, 4, 4, 4, 2, 1, 3, 0
	};
	static char type1tbl_yes[] = {				// ߼  ʼ /ħ 
		5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 7,
		7, 7, 6, 6, 7, 7, 7, 6, 6, 7, 5
	};
	static char type3tbl[] = {				// ߼   
		0, 0, 2, 0, 2, 1, 2, 1, 2, 3, 0,
		2, 1, 3, 3, 1, 2, 1, 3, 3, 1, 1
	};

	h1 = (c >> 10) & 0x1F;					// ʼ ڵ
	h2 = (c >> 5)  & 0x1F;					// ߼ ڵ
	h3 = c	       & 0x1F;					//  ڵ
                                        			
	h1 = idxtbl1[h1];					// ʼ ε ڵ
	h2 = idxtbl2[h2];					// ߼ ε ڵ
	h3 = idxtbl3[h3];					//  ε ڵ

	type1 = h3 ? type1tbl_yes[h2] : type1tbl_no[h2];
	type2 = ((h1 == 0 || h1 == 1 || h1 == 16) ? 0 : 1) + (h3 ? 2 : 0);
	type3 = type3tbl[h2];

	if(h1){
		h = h1-1;					// ʼ[8][19][32] -> ʼ[152][32]
		pos = type1*19;
		memcpyf(ib, HanFont1[pos+h], 32);
	}
	else memset(ib, 0, 32);
	if(h2){
		h = h2-1;
		pos = type2*21;
		_memor(ib, HanFont2[pos+h], 32);		// ߼[4][21][32] -> ߼[84][32]
	}
	if(h3){
		h = h3-1;
		pos = type3*27;
		_memor(ib, HanFont3[pos+h], 32);		// [4][27][32] -> [108][32]
	}
	return ib;
}

// ======================  ѱ Ʈ Ѵ. ==========================
//  [μ] unsigned char *s1
//	   unsigned char flash *s2
//	   int	len
//  Item1:  
//  Item2: ε 
//  Item3: 
// ------------------------------------------------------------------------------
void _memor(unsigned char *s1,unsigned char flash *s2, int len)
{
	do{	
		*s1++ |= *s2++;
	}while (--len);
}

// =======================  Ʈ  ε ===============================
//  [μ] char c
//  Item1: ȯ Ÿ
//   : ȯ  
// -----------------------------------------------------------------------------
unsigned char* _GetAscImage(int c)
{
int i;

        for(i = 0; i < 16; i++) ascii_fbuf[i] = AscFont16[c][i];
	return ascii_fbuf;
}

// ===================== ϼ ڵ带  ȯ.=========================
// [μ] char *buf
// Item1: ȯ ڿ 
//  : ȯ   -> han_conv_buf[101]
// -----------------------------------------------------------------------------
void Han_Conv(char *buf)
{
unsigned char temp[2];
int  i,j,len;
unsigned lpos,code;

	len = strlen(buf);
	for(i = j = 0; i < len; i++){
		temp[0] = buf[i];
		if(temp[0] >= 0xb0 && temp[0] <= 0xc8){
			temp[1] = buf[++i];
			if(temp[1] >= 0xa1 && temp[1] <= 0xfe){
				lpos = (unsigned)(((unsigned)temp[0]-0xb0)*94 + ((unsigned)temp[1]-0xa1));
				code = Conv_Tbl[lpos];		// Data Read
				han_conv_buf[j++] = (char)(code >> 8);
				han_conv_buf[j++] = (char)(code & 0xff);
			}
		}
		else if(temp[0] == 0xa3){
			temp[1] = buf[++i];
			han_conv_buf[j++] = 0xda;
			if(temp[1] >= 0xa1 && temp[1] <= 0xbf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xc0 && temp[1] <= 0xdf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xe0 && temp[1] <= 0xee) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xef && temp[1] <= 0xfd) han_conv_buf[j++] = temp[1] - 0x5e;
		}
		else if(temp[0] == 0xa1){
			temp[1] = buf[++i];
			if(temp[1] == 0xa1){
				han_conv_buf[j++] = 0xd9;
				han_conv_buf[j++] = 0x31;
			}
			else{
				han_conv_buf[j++] = temp[0];
				han_conv_buf[j++] = temp[1];
			}
		}
		else han_conv_buf[j++] = temp[0];
	}
	han_conv_buf[j] = 0;					// ڿ  ǥ
}

// =============== ϼ(FLASH) ڵ带 (SRAM) ȯ.==================
// [μ] char flash *buf
// Item1: ȯ ڿ  FLASH
//  : ȯ   -> han_conv_buf[101]
// -----------------------------------------------------------------------------
void Han_Conv_f(char flash *buf)
{
unsigned char temp[2];
int  i,j,len;
unsigned lpos,code;

	len = strlenf(buf);
	for(i = j = 0; i < len; i++){
		temp[0] = buf[i];
		if(temp[0] >= 0xb0 && temp[0] <= 0xc8){
			temp[1] = buf[++i];
			if(temp[1] >= 0xa1 && temp[1] <= 0xfe){
				lpos = (unsigned)(((unsigned)temp[0]-0xb0)*94 + ((unsigned)temp[1]-0xa1));
				code = Conv_Tbl[lpos];		// Data Read
				han_conv_buf[j++] = (char)(code >> 8);
				han_conv_buf[j++] = (char)(code & 0xff);
			}
		}
		else if(temp[0] == 0xa3){
			temp[1] = buf[++i];
			han_conv_buf[j++] = 0xda;
			if(temp[1] >= 0xa1 && temp[1] <= 0xbf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xc0 && temp[1] <= 0xdf) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xe0 && temp[1] <= 0xee) han_conv_buf[j++] = temp[1] - 0x70;
			else if(temp[1] >= 0xef && temp[1] <= 0xfd) han_conv_buf[j++] = temp[1] - 0x5e;
		}
		else if(temp[0] == 0xa1){
			temp[1] = buf[++i];
			if(temp[1] == 0xa1){
				han_conv_buf[j++] = 0xd9;
				han_conv_buf[j++] = 0x31;
			}
			else{
				han_conv_buf[j++] = temp[0];
				han_conv_buf[j++] = temp[1];
			}
		}
		else han_conv_buf[j++] = temp[0];
	}
	han_conv_buf[j] = 0;					// ڿ  ǥ
}

// ============================ ׷ LCD ʱȭ ==============================
// [μ] void
// [] 128*64
// -----------------------------------------------------------------------------
void Lcd_Init(void)
{
// ׷ LCD 
	PORTE &= 0xdf;						// PORTE.5(RST\) = 0
	delay_ms(200);						// reset ð 
	PORTE |= 0x20;						// PORTE.5(RST\) = 1

	GLCD_Command(LCD_CS_ALL,0x3f);				// ȭ ǥ ON
	GLCD_Command(LCD_CS_ALL,0xc0);				// DISPLAY START LINE 0

	Cleardevice();						// LCD Clear
}

// =================================== BUSY Check ============================
// [μ] int port
// Item1: LCD CS(CS1,CS2,ALL)
// ---------------------------------------------------------------------------
void GLCD_Busy(int port)
{
unsigned char i,ch;

	ch = GLCD_CMD_RD[port] & 0x80;				// BUSY Check :: D7(1:busy,0:ready)
	while(ch == 0x80){
		ch = GLCD_CMD_RD[port] & 0x80;
		for(i = 0; i < 2; i++);
	}
}

// ============================== COMMAND  write =======================
// [μ] int port,unsigned char uch
// Item1: LCD CS(CS1,CS2,ALL)
// Item2: 
// ---------------------------------------------------------------------------
void GLCD_Command(int port,unsigned char uch)
{
	GLCD_Busy(port);					// BUSY Check
	GLCD_CMD_WR[port] = uch;				//   write
}

// ===================================  write ==========================
// [μ] int port,unsigned char uch
// Item1: LCD CS(CS1,CS2,ALL)
// Item2: 
// ---------------------------------------------------------------------------
void GLCD_Dwrite(int port,unsigned char uch)
{
	GLCD_Busy(port);					// BUSY Check
	GLCD_DATA_WR[port] = uch;				//  write
}

// ===================================  read ===========================
// [μ] int port
// Item1: LCD CS(CS1,CS2,ALL)
// [] (0-0xff)
// ---------------------------------------------------------------------------
unsigned char GLCD_Dread(int port)
{
	GLCD_Busy(port);					// BUSY Check
	return(GLCD_DATA_RD[port]);				//  read
}
