
;CodeVisionAVR C Compiler V1.25.3 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega128
;Program type           : Application
;Clock frequency        : 16.000000 MHz
;Memory model           : Medium
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : No
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega128
	#pragma AVRPART MEMORY PROG_FLASH 131072
	#pragma AVRPART MEMORY EEPROM 4096
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __GETBRPF
	OUT  RAMPZ,R22
	ELPM R@0,Z
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "test.vec"
	.INCLUDE "test.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
	LDI  R29,BYTE3(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	OUT  RAMPZ,R29
	ELPM R24,Z+
	ELPM R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	ELPM R26,Z+
	ELPM R27,Z+
	ELPM R0,Z+
	ELPM R1,Z+
	ELPM R28,Z+
	ELPM R29,Z+
	MOVW R22,R30
	IN   R29,RAMPZ
	MOVW R30,R0
	OUT  RAMPZ,R28
__GLOBAL_INI_LOOP:
	ELPM R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500
;       1 // ======================== Atmega128 ׷ LCD ׽Ʈ α׷ ==============
;       2 //  CPU : ATmega128-16M - 128*64 ׷ LCD
;       3 //     ¥ : 2006-
;       4 //      : Ver1.0
;       5 //    : www.cpuplaza.com
;       6 // Ϸ : CodeVisionAVR
;       7 //      : serial 19200,N,8,1
;       8 // ----------------------------------------------------------------------------
;       9 // ⺻ 
;      10 #include <mega128.h>							// CPU  
;      11 
;      12 #include <stdio.h>
;      13 #include <stdlib.h>
;      14 #include <ctype.h>
;      15 #include <float.h>
;      16 #include <math.h>
;      17 #include <string.h>
;      18 #include <delay.h>
;      19 
;      20 //  
;      21 #include "cpusetup.inc"							// cpu  ͷƮ  ƾ
;      22 // =================================== CPUʱȭ ͷƮ ===================
;      23 //      : CPU  ϰ ͷƮ  ƾ .
;      24 // ----------------------------------------------------------------------------
;      25 //   
;      26 #define RXB8 1
;      27 #define TXB8 0
;      28 #define UPE 2
;      29 #define OVR 3
;      30 #define FE 4
;      31 #define UDRE 5
;      32 #define RXC 7
;      33 
;      34 #define FRAMING_ERROR (1<<FE)
;      35 #define PARITY_ERROR (1<<UPE)
;      36 #define DATA_OVERRUN (1<<OVR)
;      37 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      38 #define RX_COMPLETE (1<<RXC)
;      39 
;      40 // Լ 
;      41 int putchar_0(char data);					// COM1 ۽
;      42 int getchar_0(void);						// COM1 
;      43 
;      44 //  
;      45 char com1_rx_data,com1_rx_eflg = 0;				// COM1   ͷƮ  /÷
;      46 
;      47 // ===================================== CPUʱȭ ============================
;      48 // [μ] void
;      49 // ----------------------------------------------------------------------------
;      50 void cpu_setup(void)
;      51 {

	.CSEG
_cpu_setup:
;      52 // PortE 
;      53 // PORTE.5(OUT) : GLCD Reset
;      54 // PortE.7(IN)  : TSC2003 Interrupt PULL UP(external)
;      55 	PORTE=0x20;						// Ʈ  reg
	LDI  R30,LOW(32)
	OUT  0x3,R30
;      56 	DDRE=0x20;                                              // Ʈ  reg(0Է,1)
	OUT  0x2,R30
;      57 
;      58 //  ʱȭ(COM1)
;      59 // 19200Bps, 8Data, 1 Stop, No Parity
;      60 	UCSR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;      61 	UCSR0B=0x98;
	LDI  R30,LOW(152)
	OUT  0xA,R30
;      62 	UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  149,R30
;      63 	UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  144,R30
;      64 	UBRR0L=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
;      65 
;      66 // External SRAM page configuration:
;      67 //              -              / 0000h - FFFFh
;      68 // Lower page wait state(s): None
;      69 // Upper page wait state(s): 1r/w
;      70 	MCUCR=0xC0;
	LDI  R30,LOW(192)
	OUT  0x35,R30
;      71 	XMCRA=0x02;
	LDI  R30,LOW(2)
	STS  109,R30
;      72 
;      73 // Analog Comparator 
;      74 	ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;      75 	SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;      76 
;      77 // Global enable interrupts
;      78 #asm("sei")
	sei
;      79 }
	RET
;      80 
;      81 // =============================== COM1 ͷƮ ===========================
;      82 // [μ] void
;      83 // ----------------------------------------------------------------------------
;      84 #pragma savereg-
;      85 interrupt [USART0_RXC] void uart0_rx_isr(void)
;      86 {
_uart0_rx_isr:
;      87 char status,data;
;      88 #asm
;      89 	push r26
	push r26
;      90 	push r27
	push r27
;      91 	push r30
	push r30
;      92 	push r31
	push r31
;      93 	in   r26,sreg
	in   r26,sreg
;      94 	push r26
	push r26
;      95 #endasm
;      96 
;      97 	status=UCSR0A;
	ST   -Y,R17
	ST   -Y,R16
;	status -> R17
;	data -> R16
	IN   R17,11
;      98 	data=UDR0;
	IN   R16,12
;      99 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
;     100 		com1_rx_data = data;
	MOV  R5,R16
;     101 		com1_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R4,R30
;     102 	}
;     103 
;     104 #asm
_0x3:
;     105 	pop  r26
	pop  r26
;     106 	out  sreg,r26
	out  sreg,r26
;     107 	pop  r31
	pop  r31
;     108 	pop  r30
	pop  r30
;     109 	pop  r27
	pop  r27
;     110 	pop  r26
	pop  r26
;     111 #endasm
;     112 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;     113 #pragma savereg+
;     114 #include "glcd.inc"							// ׷ LCD
;     115 // ======================= ׷ LCD  α׷ ============================
;     116 //  : ABG128064A
;     117 // -----------------------------------------------------------------------------
;     118 // Ʈ
;     119 #include "eng8x16.fnt"
;     120 unsigned char flash AscFont16[128][16] =  {
;     121 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     122 	{240,   8,  40,   8,   8,  40,   8, 240,   7,   8,   9,  11,  11,   9,   8,   7},
;     123 	{240, 248, 216, 248, 248, 216, 248, 240,   7,  15,  14,  12,  12,  14,  15,   7},
;     124 	{  0, 224, 240, 240, 224, 240, 240, 224,   0,   1,   3,   7,  15,   7,   3,   1},
;     125 	{  0, 128, 192, 224, 240, 224, 192, 128,   0,   0,   1,   3,   7,   3,   1,   0},
;     126 	{192, 192, 240,  56,  56, 240, 192, 192,   1,   1,   9,  14,  14,   9,   1,   1},
;     127 	{192, 224, 240, 248, 248, 240, 224, 192,   0,   1,   9,  15,  15,   9,   1,   0},
;     128 	{  0,   0, 128, 192, 192, 128,   0,   0,   0,   0,   1,   3,   3,   1,   0,   0},
;     129 	{254, 254, 126,  62,  62, 126, 254, 254, 127, 127, 126, 124, 124, 126, 127, 127},
;     130 	{  0, 192,  96,  32,  32,  96, 192,   0,   0,   3,   6,   4,   4,   6,   3,   0},
;     131 	{254,  62, 158, 222, 222, 158,  62, 254, 127, 124, 121, 123, 123, 121, 124, 127},
;     132 	{  0,   0, 128, 192, 232, 184,  24, 120,   0,   7,  15,   8,   8,  15,   7,   0},
;     133 	{  0, 112, 248, 136, 136, 248, 112,   0,   0,   2,   2,  15,  15,   2,   2,   0},
;     134 	{112, 248, 136, 248, 248,   8, 248, 248,   0,   0,   0,  15,  15,   0,  15,  15},
;     135 	{  0,   0, 248, 248,  40,  40,  56,  56,  12,  14,  15,   7,   0,   0,   0,   0},
;     136 	{  0, 248, 248,  40,  40,  40, 248, 248,  28,  31,  15,   0,   0,  14,  15,   7},
;     137 	{128, 128, 128, 128, 128, 128, 128, 128,   7,   0,   0,   0,   0,   0,   0,   0},
;     138 	{  0, 248, 240, 224, 192, 192, 128,   0,   0,  15,   7,   3,   1,   1,   0,   0},
;     139 	{  0,   0, 128, 192, 192, 224, 240, 248,   0,   0,   0,   1,   1,   3,   7,  15},
;     140 	{  0,  32,  16, 248,  16,  32,   0,   0,   0,   2,   4,  15,   4,   2,   0,   0},
;     141 	{  0,   0, 248,   0,   0, 248,   0,   0,   0,   0,  13,   0,   0,  13,   0,   0},
;     142 	{  0, 128, 128, 128, 128, 128, 128, 128,   0,   0,   0,   0,   0,   0,   0,   7},
;     143 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   8,   8,   8,   8,   8,   8,   8},
;     144 	{  0,  32,  16, 248,  16,  32,   0,   0,   0,  18,  20,  31,  20,  18,   0,   0},
;     145 	{  0,  32,  16, 248,  16,  32,   0,   0,   0,   0,   0,  15,   0,   0,   0,   0},
;     146 	{  0,   0,   0, 248,   0,   0,   0,   0,   0,   2,   4,  15,   4,   2,   0,   0},
;     147 	{  0, 128, 128, 128, 128, 160, 192, 128,   0,   0,   0,   0,   0,   2,   1,   0},
;     148 	{  0, 128, 192, 160, 128, 128, 128, 128,   0,   0,   1,   2,   0,   0,   0,   0},
;     149 	{192,   0,   0,   0,   0,   0,   0,   0,   3,   2,   2,   2,   2,   2,   2,   2},
;     150 	{128, 192, 160, 128, 128, 160, 192, 128,   0,   1,   2,   0,   0,   2,   1,   0},
;     151 	{  0,   0, 128, 224, 240, 224, 128,   0,   0,   6,   7,   7,   7,   7,   7,   6},
;     152 	{  0,  48, 240, 240, 240, 240, 240,  48,   0,   0,   0,   3,   7,   3,   0,   0},
;     153 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     154 	{  0,   0, 112, 248, 112,   0,   0,   0,   0,   0,   0,  13,   0,   0,   0,   0},
;     155 	{  0,  28,  60,   0,   0,  60,  28,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     156 	{  0,  32, 248,  32,  32, 248,  32,   0,   0,   2,  15,   2,   2,  15,   2,   0},
;     157 	{  0, 112, 136, 136, 142, 136, 144,   0,   0,   4,   8,   8,  56,   8,   7,   0},
;     158 	{  0,  96,  96,   0,   0, 128,  64,   0,   0,   8,   4,   2,   1,  12,  12,   0},
;     159 	{  0,   0, 176, 104, 200,  72, 176,   0,   0,   7,   8,   8,   9,   7,  12,   0},
;     160 	{  0,   0,  32,  28,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     161 	{  0,   0, 224,  16,   8,   8,   0,   0,   0,   0,   3,   4,   8,   8,   0,   0},
;     162 	{  0,   0,   0,   8,   8,  16, 224,   0,   0,   0,   0,   8,   8,   4,   3,   0},
;     163 	{128, 160, 192, 224, 192, 160, 128,   0,   0,   2,   1,   3,   1,   2,   0,   0},
;     164 	{128, 128, 128, 240, 128, 128, 128,   0,   0,   0,   0,   7,   0,   0,   0,   0},
;     165 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  14,   0,   0,   0},
;     166 	{128, 128, 128, 128, 128, 128, 128, 128,   0,   0,   0,   0,   0,   0,   0,   0},
;     167 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  12,  12,   0,   0,   0},
;     168 	{  0,   0,   0,   0, 128,  64,  32,  16,   0,   4,   2,   1,   0,   0,   0,   0},
;     169 	{240,   8,   8, 136,  72,  40, 240,   0,   7,  10,   9,   8,   8,   8,   7,   0},
;     170 	{  0,  32,  16, 248,   0,   0,   0,   0,   8,   8,   8,  15,   8,   8,   8,   0},
;     171 	{ 16,   8,   8, 136,  72,  72,  48,   0,  12,  10,   9,   8,   8,   8,  12,   0},
;     172 	{ 16,   8, 136, 136, 136, 136, 240,   0,   4,   8,   8,   8,   8,   8,   7,   0},
;     173 	{128,  64,  32,  16,   8, 248,   0,   0,   1,   1,   1,   1,   9,  15,   9,   0},
;     174 	{248, 136, 136, 136, 136, 136,   8,   0,   4,   8,   8,   8,   8,   8,   7,   0},
;     175 	{224, 144, 136, 136, 136, 128,   0,   0,   7,   8,   8,   8,   8,   8,   7,   0},
;     176 	{ 24,   8,   8,   8, 136,  72,  56,   0,   0,   0,   0,  15,   0,   0,   0,   0},
;     177 	{112, 136, 136, 136, 136, 136, 112,   0,   7,   8,   8,   8,   8,   8,   7,   0},
;     178 	{112, 136, 136, 136, 136, 136, 240,   0,   0,   8,   8,   8,   8,   4,   3,   0},
;     179 	{  0,   0,   0,  48,   0,   0,   0,   0,   0,   0,   0,   6,   0,   0,   0,   0},
;     180 	{  0,   0,   0,  48,   0,   0,   0,   0,   0,   0,   8,   6,   0,   0,   0,   0},
;     181 	{  0, 128,  64,  32,  16,   8,   0,   0,   0,   0,   1,   2,   4,   8,   0,   0},
;     182 	{  0,  64,  64,  64,  64,  64,  64,   0,   0,   2,   2,   2,   2,   2,   2,   0},
;     183 	{  0,   0,   8,  16,  32,  64, 128,   0,   0,   0,   8,   4,   2,   1,   0,   0},
;     184 	{ 48,   8,   8,   8, 136,  72,  48,   0,   0,   0,   0,   0,  13,   0,   0,   0},
;     185 	{240,   8,   8, 200,  72,  72, 240,   0,   7,   8,   8,  11,  10,  10,   1,   0},
;     186 	{192,  32,  16,   8,  16,  32, 192,   0,  15,   1,   1,   1,   1,   1,  15,   0},
;     187 	{  8, 248, 136, 136, 136, 136, 112,   0,   8,  15,   8,   8,   8,   8,   7,   0},
;     188 	{224,  16,   8,   8,   8,   8,  48,   0,   3,   4,   8,   8,   8,   8,   6,   0},
;     189 	{  8, 248,   8,   8,   8,  16, 224,   0,   8,  15,   8,   8,   8,   4,   3,   0},
;     190 	{  8, 248, 136, 136, 200,   8,  56,   0,   8,  15,   8,   8,   9,   8,  14,   0},
;     191 	{  8, 248, 136, 136, 200,   8,  24,   0,   8,  15,   8,   8,   1,   0,   0,   0},
;     192 	{224,  16,   8,   8,   8,   8,  48,   0,   3,   4,   8,   9,   9,   5,  15,   0},
;     193 	{248, 128, 128, 128, 128, 128, 248,   0,  15,   0,   0,   0,   0,   0,  15,   0},
;     194 	{  0,   0,   8, 248,   8,   0,   0,   0,   0,   0,   8,  15,   8,   0,   0,   0},
;     195 	{  0,   0,   0,   0,   8, 248,   8,   0,   0,   6,   8,   8,   8,   7,   0,   0},
;     196 	{  0, 248, 128,  64,  32,  16,   8,   0,   0,  15,   0,   1,   2,   4,   8,   0},
;     197 	{  8, 248,   8,   0,   0,   0,   0,   0,   8,  15,   8,   8,   8,   8,  14,   0},
;     198 	{248,  16,  32, 192,  32,  16, 248,   0,  15,   0,   0,   0,   0,   0,  15,   0},
;     199 	{248,  32,  64, 128,   0,   0, 248,   0,  15,   0,   0,   0,   1,   2,  15,   0},
;     200 	{224,  16,   8,   8,   8,  16, 224,   0,   3,   4,   8,   8,   8,   4,   3,   0},
;     201 	{  8, 248, 136, 136, 136, 136, 112,   0,   8,  15,   8,   0,   0,   0,   0,   0},
;     202 	{240,   8,   8,   8,   8,   8, 240,   0,   3,   4,   4,   4,   5,   6,  11,   0},
;     203 	{  8, 248, 136, 136, 136, 136, 112,   0,   8,  15,   8,   0,   1,   2,  12,   0},
;     204 	{ 48,  72,  72, 136, 136,   8,  48,   0,   6,   8,   8,   8,   8,   9,   6,   0},
;     205 	{ 24,   8,   8, 248,   8,   8,  24,   0,   0,   0,   8,  15,   8,   0,   0,   0},
;     206 	{248,   0,   0,   0,   0,   0, 248,   0,   7,   8,   8,   8,   8,   8,   7,   0},
;     207 	{248,   0,   0,   0,   0,   0, 248,   0,   3,   4,   8,   8,   8,   4,   3,   0},
;     208 	{248,   0,   0, 192,   0,   0, 248,   0,  15,   4,   2,   1,   2,   4,  15,   0},
;     209 	{ 24,  32,  64, 128,  64,  32,  24,   0,  12,   2,   1,   0,   1,   2,  12,   0},
;     210 	{ 24,  32,  64, 128,  64,  32,  24,   0,   0,   8,   8,  15,   8,   8,   0,   0},
;     211 	{ 24,   8,   8, 136,  72,  40,  24,   0,  12,  10,   9,   8,   8,   8,  12,   0},
;     212 	{  0,   0, 248,   8,   8,   8,   0,   0,   0,   0,  15,   8,   8,   8,   0,   0},
;     213 	{ 16,  32,  64, 128,   0,   0,   0,   0,   0,   0,   0,   0,   1,   2,   4,   8},
;     214 	{  0,   0,   8,   8,   8, 248,   0,   0,   0,   0,   8,   8,   8,  15,   0,   0},
;     215 	{  0,  16,   8,   4,   2,   4,   8,  16,   0,   0,   0,   0,   0,   0,   0,   0},
;     216 	{  0,   0,   0,   0,   0,   0,   0,   0,  32,  32,  32,  32,  32,  32,  32,  32},
;     217 	{  0,   0,   0,   6,  14,   8,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     218 	{  0,  64,  64,  64,  64, 128,   0,   0,   6,   9,   9,   9,   1,  15,   8,   0},
;     219 	{  8, 248,  64,  64,  64, 128,   0,   0,   8,  15,   0,   8,   8,   8,   7,   0},
;     220 	{128,  64,  64,  64,  64,  64, 128,   0,   7,   8,   8,   8,   8,   8,   4,   0},
;     221 	{  0, 128,  64,  72,  72, 248,   0,   0,   7,   8,   8,   8,   0,  15,   8,   0},
;     222 	{128,  64,  64,  64,  64,  64, 128,   0,   7,   9,   9,   9,   9,   9,   5,   0},
;     223 	{128, 240, 136, 136, 136,  48,   0,   0,   8,  15,   8,   8,   0,   0,   0,   0},
;     224 	{128,  64,  64,  64,   0, 192,  64,   0,  19,  36,  36,  36,  36,  31,   0,   0},
;     225 	{  8, 248, 128, 128,  64,  64, 128,   0,   8,  15,   0,   0,   0,   0,  15,   0},
;     226 	{  0,   0,  64,  64, 216,   0,   0,   0,   0,   0,   8,   8,  15,   8,   0,   0},
;     227 	{  0,   0,   0,  64,  64, 216,   0,   0,  24,  32,  32,  32,  32,  31,   0,   0},
;     228 	{  0,   8, 248,   0,   0, 128,  64,   0,   0,   8,  15,   1,   3,   4,   8,   0},
;     229 	{  0,   0,   8,   8, 248,   0,   0,   0,   0,   0,   8,   8,  15,   8,   0,   0},
;     230 	{128,  64,  64, 128,  64,  64, 128,   0,  15,   0,   0,  15,   0,   0,  15,   0},
;     231 	{ 64, 192, 128,  64,  64,  64, 128,   0,   0,  15,   0,   0,   0,   0,  15,   0},
;     232 	{128,  64,  64,  64,  64,  64, 128,   0,   7,   8,   8,   8,   8,   8,   7,   0},
;     233 	{ 64, 192, 192,  64,  64,  64, 128,   0,  32,  63,  36,  36,   4,   4,   3,   0},
;     234 	{128,  64,  64,  64,  64, 192,  64,   0,   3,   4,   4,  36,  36,  63,  32,   0},
;     235 	{ 64, 192, 128,  64,  64,  64, 128,   0,   8,  15,   8,   8,   0,   0,   1,   0},
;     236 	{128,  64,  64,  64,  64,  64, 128,   0,   4,   9,   9,   9,  10,  10,   4,   0},
;     237 	{ 64,  64,  64, 248,  64,  64,   0,   0,   0,   0,   0,  15,   8,   8,   4,   0},
;     238 	{192,   0,   0,   0,   0, 192,   0,   0,   7,   8,   8,   8,   0,  15,   8,   0},
;     239 	{192,   0,   0,   0,   0,   0, 192,   0,   1,   2,   4,   8,   4,   2,   1,   0},
;     240 	{192,   0,   0,   0,   0,   0, 192,   0,   7,   8,   8,   6,   8,   8,   7,   0},
;     241 	{ 64, 128,   0,   0,   0, 128,  64,   0,   8,   4,   3,   2,   3,   4,   8,   0},
;     242 	{192,   0,   0,   0,   0,   0, 192,   0,   3,  36,  36,  36,  36,  20,  15,   0},
;     243 	{192,  64,  64,  64,  64, 192,  64,   0,   8,   8,  12,  10,   9,   8,  12,   0},
;     244 	{  0, 128, 128, 240,   8,   8,   8,   0,   0,   0,   0,   7,   8,   8,   8,   0},
;     245 	{  0,   0,   0, 120,   0,   0,   0,   0,   0,   0,   0,  15,   0,   0,   0,   0},
;     246 	{  0,   8,   8,   8, 240, 128, 128,   0,   0,   8,   8,   8,   7,   0,   0,   0},
;     247 	{  0,  16,  24,   8,  24,  16,  24,   8,   0,   0,   0,   0,   0,   0,   0,   0},
;     248 	{  0, 128,  64,  32,  64, 128,   0,   0,   7,   4,   4,   4,   4,   4,   7,   0}
;     249 };
;     250 
;     251 #include "han16x16.fnt"
;     252 unsigned char flash HanFont1[152][32] = {
;     253 	{  0,   4,   4,   4,   4, 196,  60,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   8,   8,   4,   3,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     254 	{  0,   4,   4, 132, 124,   4, 132, 124,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,  12,   3,   0,  12,   3,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     255 	{  0, 252,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,   8,   8,   8,   8,   0,   0,   0,   0,   0,   0,   0,   0},
;     256 	{  0, 252,   4,   4,   4,   4,   4,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,   8,   8,   8,   8,   0,   0,   0,   0,   0,   0,   0,   0},
;     257 	{  0, 252,   4,   4, 252,   4,   4,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,  15,   8,   8,   8,   0,   0,   0,   0,   0,   0,   0,   0},
;     258 	{  0, 196,  68,  68,  68,  68,  68, 124,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,   8,   8,   8,   8,   0,   0,   0,   0,   0,   0,   0,   0},
;     259 	{  0, 252,   4,   4,   4,   4,   4, 252,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,   8,   8,   8,  15,   0,   0,   0,   0,   0,   0,   0,   0},
;     260 	{  0, 252,  64,  64,  64,  64,  64, 252,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,   8,   8,   8,  15,   0,   0,   0,   0,   0,   0,   0,   0},
;     261 	{  0, 252,  64,  64, 252, 252,  64,  64, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,  15,  15,   8,   8,  15,   0,   0,   0,   0,   0,   0,   0},
;     262 	{  0,   0,   0, 192, 124, 192,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  12,   3,   0,   0,   0,   3,  12,   0,   0,   0,   0,   0,   0,   0,   0},
;     263 	{  0,   0, 128, 252, 128, 128, 124, 128,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  14,   1,   0,  15,   0,   0,   1,  14,   0,   0,   0,   0,   0,   0,   0},
;     264 	{  0, 240,   8,   4,   4,   4,   8, 240,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   3,   4,   8,   8,   8,   4,   3,   0,   0,   0,   0,   0,   0,   0,   0},
;     265 	{  0,   4,   4, 196, 124, 196,   4,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  12,   3,   0,   0,   0,   3,  12,   0,   0,   0,   0,   0,   0,   0,   0},
;     266 	{  4,   4, 252,   4,   4,   4, 252,   4,   4,   0,   0,   0,   0,   0,   0,   0 ,  12,   3,   1,   3,  12,   3,   1,   1,  14,   0,   0,   0,   0,   0,   0,   0},
;     267 	{  0,   4, 132, 228,  62, 228, 132,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  14,   3,   0,   0,   0,   3,  14,   0,   0,   0,   0,   0,   0,   0,   0},
;     268 	{  0,  68,  68,  68,  68, 196,  60,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   8,   8,   4,   3,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     269 	{  0, 252,  68,  68,  68,  68,  68,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,  15,   8,   8,   8,   8,   8,   8,   0,   0,   0,   0,   0,   0,   0,   0},
;     270 	{  0,   4, 252,   4,   4,   4, 252,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   8,  15,   8,   8,   8,  15,   8,   0,   0,   0,   0,   0,   0,   0,   0},
;     271 	{  0, 200,  40,  24,  28,  24,  40, 200,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   3,   4,   8,   8,   8,   4,   3,   0,   0,   0,   0,   0,   0,   0,   0},
;     272 	{  0,   0,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4, 252,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     273 	{  0,   0,   4,   4,   4,   4, 252,   0,   0,   4,   4,   4,   4, 252,   0,   0 ,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     274 	{  0,   0, 252,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0},
;     275 	{  0,   0, 252,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0},
;     276 	{  0,   0, 252,   4,   4,   4,   4,   0, 252,   4,   4,   4,   4,   4,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   0,   1,   1,   1,   1,   1,   1,   0,   0},
;     277 	{  0,   0, 228,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,  60,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0},
;     278 	{  0,   0, 252,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4, 252,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0},
;     279 	{  0,   0, 252,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32, 252,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0},
;     280 	{  0,   0, 252,  32,  32,  32,  32, 252, 252,  32,  32,  32,  32, 252,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0},
;     281 	{  0,   0, 128, 128,  64,  32,  16,  28,  16,  32,  64, 128, 128,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     282 	{  0,   0,   0, 128,  64, 124,  64, 128, 128,  64, 124,  64, 128,   0,   0,   0 ,   0,   0,   1,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     283 	{  0,   0, 112, 136,   4,   4,   4,   4,   4,   4,   4,   4, 136, 112,   0,   0 ,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0},
;     284 	{  0,   0,   4,   4, 132,  68,  36,  60,  36,  68, 132,   4,   4,   0,   0,   0 ,   0,   0,   1,   1,   0,   0,   0,   0,   0,   0,   0,   1,   1,   0,   0,   0},
;     285 	{  0,   0,   4, 132,  68, 124,  68, 196,  68,  68, 124,  68, 132,   4,   0,   0 ,   0,   0,   1,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     286 	{  0,   0,   8,   8, 136,  72,  40,  60,  40,  72, 136,   8,   8,   0,   0,   0 ,   0,   0,   1,   1,   0,   0,   0,   0,   0,   0,   0,   1,   1,   0,   0,   0},
;     287 	{  0,   0,   4,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36, 252,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     288 	{  0,   0, 252,  36,  36,  36,  36,  36,  36,  36,  36,  36,  36,   4,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0},
;     289 	{  0,   0,   4,   4, 252,   4,   4,   4,   4,   4,   4, 252,   4,   4,   0,   0 ,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0},
;     290 	{  0,   0,   8, 232,  24,  24,  24,  28,  28,  24,  24,  24, 232,   8,   0,   0 ,   0,   0,   0,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0},
;     291 	{  0,   0,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4,   4, 124,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     292 	{  0,   0,   4,   4,   4,   4, 124,   0,   0,   4,   4,   4,   4, 124,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     293 	{  0,   0, 124,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,  64,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     294 	{  0,   0, 124,  68,  68,  68,  68,  68,  68,  68,  68,  68,  68,  68,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     295 	{  0,   0, 124,  68,  68,  68,  68,   0, 124,  68,  68,  68,  68,  68,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     296 	{  0,   0, 116,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  92,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     297 	{  0,   0, 124,  68,  68,  68,  68,  68,  68,  68,  68,  68,  68, 124,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     298 	{  0,   0, 124,  80,  80,  80,  80,  80,  80,  80,  80,  80,  80, 124,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     299 	{  0,   0, 124,  80,  80,  80,  80, 124, 124,  80,  80,  80,  80, 124,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     300 	{  0,   0,  64,  64,  32,  16,   8,  12,   8,  16,  32,  64,  64,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     301 	{  0,   0,  64,  32,  16,  28,  16,  96,  32,  16,  28,  16,  32,  64,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     302 	{  0,   0,  16,  40,  68,  68,  68,  68,  68,  68,  68,  68,  40,  16,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     303 	{  0,   0,  68,  68,  36,  20,  12,   4,  12,  20,  36,  68,  68,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     304 	{  0,   0,  68,  36,  20,  28,  20, 100,  36,  20,  28,  20,  36,  68,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     305 	{  0,   0,  36,  36,  20,  20,  12,   6,  12,  20,  20,  36,  36,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     306 	{  0,   0,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20, 124,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     307 	{  0,   0, 124,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,  84,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     308 	{  0,   0,  68,  68, 124,  68,  68,  68,  68,  68,  68, 124,  68,  68,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     309 	{  0,   0,   8,  40,  88,  88,  88,  92,  92,  88,  88,  88,  40,   8,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     310 	{  0,   4,   4,   4,   4,   4,   4,   4, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0},
;     311 	{  0,   4,   4,   4, 252,   4,   4,   4, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   1,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0},
;     312 	{  0, 252,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0},
;     313 	{  0, 252,   4,   4,   4,   4,   4,   4,   4,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0},
;     314 	{  0, 252,   4,   4,   0, 252,   4,   4,   4,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0},
;     315 	{  0, 228,  36,  36,  36,  36,  36,  36,  60,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0},
;     316 	{  0, 252,   4,   4,   4,   4,   4,   4, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0},
;     317 	{  0, 252,  32,  32,  32,  32,  32,  32, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0},
;     318 	{  0, 252,  32,  32, 252, 252,  32,  32, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0},
;     319 	{  0,   0, 128,  64, 124,  64, 128,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   0},
;     320 	{  0, 128, 124,  64, 128, 128, 124, 128,   0,   0,   0,   0,   0,   0,   0,   0 ,   1,   0,   0,   1,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0},
;     321 	{  0, 112, 136,   4,   4,   4,   4, 136, 112,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     322 	{  0,   4, 132,  68, 124,  68, 132,   4,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   0},
;     323 	{  0,   4, 132, 252, 132,   4, 252, 132, 132,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   0,   0,   0,   1,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0},
;     324 	{  0,   8, 136,  72, 124,  72, 136,   8,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   0},
;     325 	{  0,  36,  36,  36,  36,  36,  36,  36, 252,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0},
;     326 	{  0, 252,  36,  36,  36,  36,  36,  36,   4,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0},
;     327 	{  0,   4, 252,   4,   4,   4,   4, 252,   4,   0,   0,   0,   0,   0,   0,   0 ,   0,   1,   1,   1,   1,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0},
;     328 	{  0, 100, 148,  12,  14,  14,  12, 148, 100,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   1,   1,   1,   1,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     329 	{  0,   4,   4,   4,   4,   4,   4,   4, 124,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     330 	{  0,   4,   4,   4, 124,   4,   4,   4, 124,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     331 	{  0, 124,  64,  64,  64,  64,  64,  64,  64,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     332 	{  0, 124,  68,  68,  68,  68,  68,  68,  68,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     333 	{  0, 124,  68,  68,  64, 124,  68,  68,  68,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     334 	{  0, 116,  84,  84,  84,  84,  84,  84,  92,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     335 	{  0, 124,  68,  68,  68,  68,  68,  68, 124,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     336 	{  0, 124,  80,  80,  80,  80,  80,  80, 124,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     337 	{  0, 124,  80,  80, 124, 124,  80,  80, 124,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     338 	{  0,  64,  32,  16,  28,  16,  32,  64,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     339 	{  0,  64,  32,  28,  80,  32,  32,  28,  32,  64,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     340 	{  0,  56,  68,  68,  68,  68,  68,  56,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     341 	{  0,  68,  36,  20,  28,  20,  36,  68,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     342 	{  0,  68,  36,  60, 100,  36,  60,  36,  68,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     343 	{  0,  72,  40,  24,  12,  24,  40,  72,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     344 	{  0,  20,  20,  20,  20,  20,  20,  20, 124,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     345 	{  0, 124,  84,  84,  84,  84,  84,  84,  68,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     346 	{  0,  68, 124,  68,  68,  68,  68, 124,  68,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     347 	{  0,   8,  56,  72,  76,  76,  72,  56,   8,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     348 	{  0, 130, 130,  66,  66,  50,  14,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     349 	{  0,   2, 130,  66,  62,   2, 130,  66,  62,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     350 	{  0, 254, 128, 128, 128, 128, 128, 128, 128,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     351 	{  0, 254, 130, 130, 130, 130, 130, 130, 130,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     352 	{  0, 254, 130, 130,   0, 254, 130, 130, 130,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     353 	{  0, 242, 146, 146, 146, 146, 146, 146, 158,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     354 	{  0, 254, 130, 130, 130, 130, 130, 130, 254,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     355 	{  0, 254, 144, 144, 144, 144, 144, 144, 254,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     356 	{  0, 254, 144, 144, 254, 254, 144, 144, 254,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     357 	{  0, 128,  64,  32,  62,  32,  64, 128,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     358 	{128,  64,  62, 160, 192,  64,  62,  64, 128,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     359 	{  0,  56,  68, 130, 130, 130, 130,  68,  56,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     360 	{  0, 130,  66,  34,  62,  34,  66, 130,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     361 	{  0, 130,  66, 126,  66, 130,  66, 126,  66, 130,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     362 	{  0, 132,  68,  36,  62,  36,  68, 132,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     363 	{  0, 146, 146, 146,  82,  82,  50,  30,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     364 	{  0, 254, 146, 146, 146, 146, 146, 146, 130,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     365 	{  0, 130, 254, 130, 130, 130, 130, 254, 130,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     366 	{  0,   4, 116, 140, 142, 142, 140, 116,   4,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     367 	{  0,   0,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,  62,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     368 	{  0,   0,   2,   2,   2,   2,   2,  62,   0,   2,   2,   2,   2,  62,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     369 	{  0,   0,  62,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     370 	{  0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     371 	{  0,   0,  62,  34,  34,  34,  34,   0,  62,  34,  34,  34,  34,  34,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     372 	{  0,   0,  58,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  46,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     373 	{  0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  62,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     374 	{  0,   0,  62,  40,  40,  40,  40,  40,  40,  40,  40,  40,  40,  62,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     375 	{  0,   0,  62,  40,  40,  40,  40,  62,  62,  40,  40,  40,  40,  62,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     376 	{  0,   0,   0,  32,  32,  16,  24,  14,   8,  16,  16,  32,  32,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     377 	{  0,   0,  32,  16,  30,  16,  32,  32,  32,  32,  16,  30,  16,  32,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     378 	{  0,   0,   0,  28,  34,  34,  34,  34,  34,  34,  34,  34,  28,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     379 	{  0,   0,  34,  34,  18,  18,  10,  14,  10,  18,  18,  34,  34,  34,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     380 	{  0,   0,  34,  18,  30,  18,  50,  34,  34,  50,  18,  30,  18,  34,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     381 	{  0,   0,  36,  36,  20,  20,  28,  14,  12,  20,  20,  20,  36,  36,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     382 	{  0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  62,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     383 	{  0,   0,  62,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     384 	{  0,   0,  34,  34,  62,  34,  34,  34,  34,  34,  34,  62,  34,  34,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     385 	{  0,   0,   4,  28,  44,  36,  36,  38,  38,  36,  36,  44,  28,   4,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     386 	{  0,   2,   2,   2,   2,   2,   2,   2,  30,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     387 	{  0,   2,   2,   2,  30,   2,   2,   2,  30,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     388 	{  0,  30,  16,  16,  16,  16,  16,  16,  16,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     389 	{  0,   0,  30,  18,  18,  18,  18,  18,  18,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     390 	{  0,  30,  18,  18,  16,  30,  18,  18,  18,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     391 	{  0,  58,  42,  42,  42,  42,  42,  42,  46,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     392 	{  0,  30,  18,  18,  18,  18,  18,  18,  30,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     393 	{  0,  30,  20,  20,  20,  20,  20,  20,  30,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     394 	{  0,  30,  20,  20,  30,  30,  20,  20,  30,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     395 	{  0,  16,  16,   8,  14,   8,  16,  16,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     396 	{  0,  16,   8,   6,   8,  16,   8,   6,   8,  16,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     397 	{  0,   0,  12,  18,  18,  18,  18,  12,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     398 	{  0,  18,  18,  10,  14,  10,  18,  18,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     399 	{  0,  18,  18,  14,  18,  18,  14,  18,  18,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     400 	{  0,  20,  20,  28,  14,  28,  20,  20,   0,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     401 	{  0,  10,  10,  10,  10,  10,  42,  42,  30,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     402 	{  0,  62,  42,  42,  42,  42,  42,  42,  34,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     403 	{  0,  18,  30,  18,  18,  18,  18,  30,  18,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     404 	{  0,   4,  28,  36,  38,  38,  36,  28,   4,   0,   0,   0,   0,   0,   0,   0 ,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}
;     405 };
;     406 
;     407 unsigned char flash HanFont2[84][32] = {
;     408 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64,  64,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0,   0,   0},
;     409 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0,  63,   0,   0},
;     410 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16,  16,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   1,   1,   1,   0},
;     411 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   1,   1,  63,   0,   0},
;     412 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  64,  64,  64, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0},
;     413 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  64,  64, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,  63,   0,   0},
;     414 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,  63,   0,   0},
;     415 	{  0,   0,   0,   0,   0,   0,   0,   0,  16,  16,  16, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,  63,   0,  63,   0,   0},
;     416 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,  16,  16,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  16,   0},
;     417 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  63,   0,   0,   0},
;     418 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64, 254,   0,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,   0,  63,   0,   0,  63,   0,   0},
;     419 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  16,  63,   0,   0},
;     420 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,  16,  30,  16,  16,  16,  16,   0},
;     421 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   2,   2,   2,   2,   2,   2,  62,   2,   2,   2,   2,   2,   2,   2,   0},
;     422 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   2,   2,   2,   2,  62,   2,   2,  10,  10,  10,  10,  10,  63,   0,   0},
;     423 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0, 254,   0,   0 ,  0,   2,   2,   2,   2,  62,   2,   2,  10,  10,  10,  63,   0,  63,   0,   0},
;     424 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   2,   2,   2,   2,  62,   2,   2,   2,   2,   2,   2,   2,  63,   0,   0},
;     425 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   2,   2,   2,  62,   2,   2,   2,   2,   2,   2,  62,   2,   2,   2,   0},
;     426 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,   0},
;     427 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  63,   0,   0},
;     428 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0},
;     429 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0,   0},
;     430 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0,  63,   0,   0},
;     431 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16,  16,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   1,   1,   1,   0},
;     432 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   1,   1,  63,   0,   0},
;     433 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  64,  64,  64,  64, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0},
;     434 	{  0,   0,   0,   0,   0,   0,   0,   0,  64,  64,  64, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,  63,   0,   0},
;     435 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,   1,   1,  63,   0,   0},
;     436 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   1,  63,   0,  63,   0,   0},
;     437 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,  16,  16,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  16,   0},
;     438 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64,  64,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  63,   0,   0,   0},
;     439 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  64, 254,   0,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  63,   0,  63,   0,   0},
;     440 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,  16,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  16,  63,   0,   0},
;     441 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,  16,  16,  16,  30,  16,  16,  16,  16,  16,  16,  30,  16,  16,  16,   0},
;     442 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   2,   2,   2,   2,   2,   2,  62,   2,   2,   2,   2,   2,   2,   2,   0},
;     443 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   2,   2,   2,   2,  62,   2,   2,  10,  10,  10,  10,  10,  63,   0,   0},
;     444 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0, 254,   0,   0 ,  0,   2,   2,   2,   2,  62,   2,   2,  10,  10,  10,  63,   0,  63,   0,   0},
;     445 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   2,   2,   2,   2,  62,   2,   2,   2,   2,   2,   2,   2,  63,   0,   0},
;     446 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   2,   2,   2,  62,   2,   2,   2,   2,   2,  62,   2,   2,   2,   2,   0},
;     447 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,   0},
;     448 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  16,  63,   0,   0},
;     449 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  63,   0,   0},
;     450 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16,  16,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     451 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     452 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  40,  40,  40,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     453 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  40,  40, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     454 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     455 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     456 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  40,  40,  40,  40, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     457 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  40,  40, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     458 	{  0, 128, 128, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     459 	{  0, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 254,  16,  16,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0},
;     460 	{  0, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 254,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   1,   0,   0},
;     461 	{  0, 128, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     462 	{  0, 128, 128, 128, 128, 192, 128, 128, 128, 128, 192, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     463 	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   0},
;     464 	{  0,  64,  64,  64, 192,  64,  64,  64,  64, 192, 192, 192, 192, 254,   0,   0 ,  0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     465 	{  0,  64,  64,  64, 192,  64,  64,  64, 192, 192, 192, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   1,   0,   1,   0,   0},
;     466 	{  0,  64,  64,  64,  64, 192,  64,  64,  64,  64,  64,  64,  64, 254,   0,   0 ,  0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     467 	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0},
;     468 	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     469 	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     470 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     471 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16,  16,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     472 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     473 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  40,  40,  40,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     474 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,  40,  40, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     475 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16,  16,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     476 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  16,  16, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     477 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  40,  40,  40,  40, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     478 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,  40,  40, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     479 	{  0, 128, 128, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     480 	{  0, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 254,  16,  16,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0},
;     481 	{  0, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 254,  16, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   1,   0,   0},
;     482 	{  0, 128, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 128, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     483 	{  0, 128, 128, 128, 192, 128, 128, 128, 128, 128, 128, 192, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     484 	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   0},
;     485 	{  0,  64,  64,  64,  64, 192,  64,  64,  64, 192, 192, 192, 192, 254,   0,   0 ,  0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     486 	{  0,  64,  64,  64,  64, 192,  64,  64, 192, 192, 192, 254,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   1,   0,   1,   0,   0},
;     487 	{  0,  64,  64,  64,  64, 192,  64,  64,  64,  64,  64,  64,  64, 254,   0,   0 ,  0,   0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     488 	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   1,   0,   0,   0,   0,   0,   0,   1,   0,   0,   0,   0},
;     489 	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0},
;     490 	{  0, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 128, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   1,   0,   0},
;     491 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 254,   0,   0 ,  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0}
;     492 };
;     493 
;     494 unsigned char flash HanFont3[108][32] = {
;     495 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,   2,   2,   2,   2,   2,   2,   2,   2,  62,   0,   0,   0},
;     496 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,   2,   2,   2,  62,   2,   2,   2,   2,  62,   0,   0,   0},
;     497 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,   2,   2,   2,   2,  62,  32,  16,  30,  48,  32,   0,   0},
;     498 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  32,  32,  32,  32,  32,  32,  32,  32,  32,   0,   0,   0},
;     499 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  32,  32,  32,  32,  50,  18,  30,  50,  34,   0,   0,   0},
;     500 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  32,  32,  32,   4,  60,  46,  46,  60,   4,   0,   0,   0},
;     501 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,   0,   0,   0},
;     502 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  42,  42,  42,  42,  46,   0,   0,   0},
;     503 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  46,   2,   2,   2,   2,  62,   0,   0,   0},
;     504 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  46,  62,  34,  34,  34,  62,   0,   0,   0},
;     505 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  46,  62,  40,  40,  40,  62,   0,   0,   0},
;     506 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  46,  32,  48,  30,  48,  32,   0,   0,   0},
;     507 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  62,  62,  42,  42,  42,   0,   0,   0},
;     508 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  62,  34,  62,  34,  62,  34,   0,   0,   0},
;     509 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  46,   4,  60,  46,  46,  60,   4,   0,   0,   0},
;     510 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  62,   0,   0,   0},
;     511 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  40,  40,  40,  40,  40,  40,  40,  40,  62,   0,   0,   0},
;     512 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  40,  40,  40,  62,  32,  48,  30,  48,  32,   0,   0,   0},
;     513 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  32,  32,  16,   8,  14,   8,  16,  32,  32,   0,   0,   0,   0},
;     514 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  32,  16,  30,  16,  32,  32,  48,  30,  16,  32,   0,   0,   0},
;     515 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  28,  34,  34,  34,  34,  34,  34,  28,   0,   0,   0,   0},
;     516 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  34,  34,  18,  10,   6,  10,  18,  34,  34,   0,   0,   0,   0},
;     517 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  34,  34,  18,  10,   7,  10,  18,  34,  34,   0,   0,   0,   0},
;     518 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  62,   0,   0,   0},
;     519 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  42,  42,  42,  42,  42,  42,  42,  42,  42,   0,   0,   0},
;     520 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  34,  34,  62,  34,  34,  34,  34,  62,  34,  34,   0,   0,   0},
;     521 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,  30,  38,  34,  35,  34,  34,  38,  30,   2,   0,   0,   0},
;     522 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,   2,   2,   2,   2,   2,   2,   2,   2,   2,  62,   0,   0},
;     523 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,   2,   2,   2,   2,  62,   2,   2,   2,   2,  62,   0,   0},
;     524 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,   2,   2,   2,  62,  32,  32,  48,  30,  48,  32,   0,   0},
;     525 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  32,  32,  32,  32,  32,  32,  32,  32,  32,   0,   0},
;     526 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  32,  32,  32,  32,  34,  18,  30,  50,  34,   0,   0},
;     527 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  32,  32,  32,   4,  60,  46,  46,  60,   4,   0,   0},
;     528 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,   0,   0},
;     529 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  42,  42,  42,  42,  42,  42,  46,   0,   0},
;     530 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  42,  46,   2,   2,   2,   2,  62,   0,   0},
;     531 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  42,  46,  62,  34,  34,  34,  62,   0,   0},
;     532 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  42,  46,  62,  40,  40,  40,  62,   0,   0},
;     533 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  42,  46,  32,  48,  30,  48,  32,   0,   0},
;     534 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  42,  46,  62,  42,  42,  42,  42,   0,   0},
;     535 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  46,  34,  62,  34,  34,  62,  34,   0,   0},
;     536 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  58,  42,  42,  46,   4,  60,  46,  46,  60,   4,   0,   0},
;     537 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  62,   0,   0},
;     538 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  40,  40,  40,  40,  40,  40,  40,  40,  62,   0,   0},
;     539 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  40,  40,  40,  62,  32,  48,  30,  48,  32,   0,   0},
;     540 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  32,  32,  16,   8,  14,   8,  16,  32,  32,  32,   0,   0},
;     541 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  32,  32,  16,  30,  16,  32,  32,  48,  30,  16,  32,   0,   0},
;     542 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  28,  34,  34,  34,  34,  34,  34,  34,  34,  28,   0,   0},
;     543 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  34,  34,  18,  10,   6,   6,  10,  18,  34,  34,   0,   0},
;     544 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  36,  36,  20,  12,   6,   6,  12,  20,  36,  36,   0,   0},
;     545 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  62,   0,   0},
;     546 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  62,  42,  42,  42,  42,  42,  42,  42,  42,  42,   0,   0},
;     547 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,  34,  34,  62,  34,  34,  34,  34,  62,  34,  34,   0,   0},
;     548 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   0,   2,  30,  38,  34,  35,  34,  34,  38,  30,   2,   0,   0},
;     549 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,  62,   0,   0},
;     550 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,   2,   2,   2,   2,  62,   2,   2,   2,   2,  62,   0,   0},
;     551 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   2,   2,   2,   2,   2,  62,  32,  48,  30,  48,  32,   0,   0},
;     552 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,   0,   0},
;     553 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  32,  32,  32,  32,  32,  34,  50,  30,  50,  34,   0,   0},
;     554 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  32,  32,  32,  36,  60,  44,  46,  44,  60,   4,   0,   0},
;     555 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,   0,   0},
;     556 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  42,  42,  42,  42,  42,  46,   0,   0},
;     557 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  46,   2,   2,   2,   2,  62,   0,   0},
;     558 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  46,  62,  34,  34,  34,  62,   0,   0},
;     559 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  62,  62,  40,  40,  40,  62,   0,   0},
;     560 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  46,  32,  48,  30,  48,  32,   0,   0},
;     561 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  42,  62,  62,  42,  42,  42,  42,   0,   0},
;     562 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  46,  34,  62,  34,  34,  62,  34,   0,   0},
;     563 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  58,  42,  42,  42,  46,   4,  60,  46,  46,  60,   4,   0,   0},
;     564 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,  62,   0,   0},
;     565 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  40,  40,  40,  40,  40,  40,  40,  40,  40,  62,   0,   0},
;     566 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  40,  40,  40,  40,  62,  32,  48,  30,  48,  32,   0,   0},
;     567 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  32,  32,  16,  16,   8,  14,   8,  16,  16,  32,  32,   0,   0},
;     568 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  32,  16,  30,  16,  48,  32,  32,  48,  30,  16,  32,   0,   0},
;     569 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  28,  34,  34,  34,  34,  34,  34,  34,  34,  34,  28,   0,   0},
;     570 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  34,  34,  18,  18,  10,   6,  10,  18,  18,  34,  34,   0,   0},
;     571 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  36,  36,  20,  20,  12,   6,  12,  20,  20,  36,  36,   0,   0},
;     572 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  62,   0,   0},
;     573 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  62,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,   0,   0},
;     574 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,  34,  34,  62,  34,  34,  34,  34,  34,  62,  34,  34,   0,   0},
;     575 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   0,   4,  60,  36,  36,  36,  38,  36,  36,  36,  60,   4,   0,   0},
;     576 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,   2,  62,   0,   0},
;     577 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   2,   2,   2,   2,   2,  62,   2,   2,   2,   2,   2,  62,   0,   0},
;     578 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   2,   2,   2,   2,   2,  62,  32,  32,  48,  30,  48,  32,   0,   0},
;     579 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,  32,   0,   0},
;     580 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  32,  32,  32,  32,  32,  32,  34,  50,  30,  50,  34,   0,   0},
;     581 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  32,  32,  32,  32,   4,  60,  46,  46,  46,  60,   4,   0,   0},
;     582 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,   0,   0},
;     583 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  46,   0,   0},
;     584 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  42,  46,   2,   2,   2,   2,   2,  62,   0,   0},
;     585 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  46,   0,  62,  34,  34,  34,  34,  62,   0,   0},
;     586 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  46,   0,  62,  40,  40,  40,  40,  62,   0,   0},
;     587 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  42,  46,  32,  32,  48,  30,  48,  32,   0,   0},
;     588 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  42,  46,   0,  62,  42,  42,  42,  42,   0,   0},
;     589 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  46,  34,  62,  34,  34,  34,  62,  34,   0,   0},
;     590 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  58,  42,  42,  42,  42,  46,   4,  60,  36,  38,  36,  60,   4,   0},
;     591 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  62,   0,   0},
;     592 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  40,  40,  40,  40,  40,  40,  40,  40,  40,  40,  62,   0,   0},
;     593 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  40,  40,  40,  40,  62,  32,  32,  48,  30,  48,  32,   0,   0},
;     594 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  32,  32,  16,  16,   8,  14,   8,  16,  16,  32,  32,  32,   0,   0},
;     595 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  32,  16,  30,  16,  48,  32,  32,  48,  16,  30,  16,  32,   0,   0},
;     596 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  28,  34,  34,  34,  34,  34,  34,  34,  34,  34,  34,  28,   0,   0},
;     597 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  34,  34,  18,  18,  10,   6,  10,  18,  18,  34,  34,  34,   0,   0},
;     598 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  36,  36,  20,  20,  12,   6,  12,  20,  20,  36,  36,  36,   0,   0},
;     599 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  10,  62,   0,   0},
;     600 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  62,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,  42,   0,   0},
;     601 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,  34,  34,  62,  34,  34,  34,  34,  34,  34,  62,  34,  34,   0,   0},
;     602 	{  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0 ,  0,   0,   4,  60,  36,  36,  36,  38,  36,  36,  36,  36,  60,   4,   0,   0}
;     603 };
;     604 // ϼ ->  ȯ ̺
;     605 #include "hconvtbl.inc"
;     606 unsigned flash Conv_Tbl[2354] =
;     607 {
;     608 	    34913u,34914u,34917u,34920u,34921u,34922u,34923u,34929u,34931u,34932u,
;     609 	    34933u,34934u,34935u,34936u,34937u,34939u,34940u,34941u,34945u,34946u,
;     610 	    34949u,34953u,34961u,34963u,34965u,34966u,34967u,34977u,34978u,34981u,
;     611 	    34985u,34997u,34999u,35009u,35013u,35017u,35041u,35042u,35045u,35048u,
;     612 	    35049u,35051u,35057u,35059u,35061u,35062u,35063u,35064u,35067u,35068u,
;     613 	    35069u,35137u,35141u,35145u,35153u,35155u,35157u,35158u,35159u,35169u,
;     614 	    35170u,35171u,35173u,35176u,35177u,35185u,35187u,35189u,35190u,35191u,
;     615 	    35195u,35201u,35205u,35209u,35219u,35221u,35233u,35234u,35237u,35240u,
;     616 	    35241u,35243u,35245u,35248u,35249u,35251u,35253u,35255u,35256u,35265u,
;     617 	    35266u,35269u,35273u,35275u,
;     618 	    35281u,35283u,35285u,35287u,35297u,35301u,35305u,35313u,35318u,35319u,
;     619 	    35393u,35394u,35397u,35401u,35409u,35411u,35413u,35415u,35425u,35429u,
;     620 	    35433u,35443u,35445u,35457u,35458u,35461u,35464u,35465u,35466u,35467u,
;     621 	    35472u,35473u,35475u,35477u,35479u,35480u,35489u,35490u,35493u,35497u,
;     622 	    35510u,35511u,35521u,35541u,35553u,35554u,35557u,35561u,35569u,35571u,
;     623 	    35573u,35649u,35653u,35657u,35681u,35682u,35685u,35688u,35689u,35690u,
;     624 	    35697u,35699u,35701u,35703u,35713u,35745u,35746u,35749u,35752u,35753u,
;     625 	    35755u,35761u,35763u,35765u,35767u,35768u,35772u,35937u,35938u,35939u,
;     626 	    35941u,35945u,35947u,35953u,35955u,35957u,35958u,35959u,35963u,35969u,
;     627 	    35970u,35973u,35977u,35985u,
;     628 	    35987u,35989u,35990u,35991u,36001u,36002u,36009u,36065u,36066u,36067u,
;     629 	    36069u,36073u,36081u,36083u,36085u,36086u,36087u,36161u,36162u,36165u,
;     630 	    36177u,36181u,36183u,36193u,36197u,36201u,36213u,36214u,36219u,36225u,
;     631 	    36257u,36258u,36261u,36263u,36265u,36273u,36275u,36277u,36279u,36280u,
;     632 	    36281u,36289u,36290u,36297u,36297u,36311u,36321u,36322u,36343u,36417u,
;     633 	    36421u,36425u,36433u,36435u,36439u,36449u,36481u,36482u,36485u,36489u,
;     634 	    36496u,36497u,36499u,36501u,36503u,36504u,36513u,36521u,36534u,36535u,
;     635 	    36545u,36546u,36549u,36553u,36561u,36563u,36566u,36577u,36581u,36585u,
;     636 	    36593u,36595u,36673u,36705u,36706u,36709u,36711u,36713u,36715u,36720u,
;     637 	    36721u,36723u,36725u,36727u,
;     638 	    36731u,36769u,36770u,36773u,36777u,36785u,36787u,36789u,36791u,36961u,
;     639 	    36962u,36963u,36965u,36968u,36969u,36970u,36971u,36977u,36979u,36981u,
;     640 	    36982u,36983u,36984u,36985u,36987u,36989u,36993u,36994u,36997u,37001u,
;     641 	    37009u,37011u,37013u,37014u,37015u,37025u,37026u,37029u,37033u,37041u,
;     642 	    37047u,37089u,37090u,37092u,37093u,37097u,37099u,37100u,37105u,37107u,
;     643 	    37109u,37110u,37111u,37117u,37185u,37186u,37189u,37193u,37201u,37203u,
;     644 	    37205u,37206u,37207u,37217u,37218u,37221u,37225u,37233u,37235u,37238u,
;     645 	    37239u,37242u,37249u,37253u,37281u,37282u,37285u,37289u,37291u,37297u,
;     646 	    37299u,37301u,37303u,37308u,37309u,37313u,37317u,37321u,37334u,37441u,
;     647 	    37445u,37449u,37457u,37459u,
;     648 	    37461u,37473u,37474u,37477u,37481u,37491u,37493u,37495u,37505u,37506u,
;     649 	    37509u,37512u,37513u,37521u,37523u,37525u,37527u,37537u,37558u,37569u,
;     650 	    37601u,37605u,37609u,37617u,37619u,37697u,37698u,37705u,37713u,37715u,
;     651 	    37719u,37729u,37730u,37733u,37737u,37738u,37739u,37745u,37747u,37749u,
;     652 	    37751u,37752u,37756u,37761u,37765u,37769u,37793u,37794u,37797u,37801u,
;     653 	    37801u,37809u,37811u,37813u,37815u,37820u,37985u,37986u,37987u,37989u,
;     654 	    37992u,37993u,37994u,37995u,37996u,38000u,38001u,38003u,38005u,38006u,
;     655 	    38007u,38008u,38009u,38013u,38017u,38018u,38021u,38025u,38033u,38035u,
;     656 	    38037u,38038u,38039u,38049u,38113u,38114u,38115u,38117u,38120u,38121u,
;     657 	    38123u,38124u,38129u,38131u,
;     658 	    38133u,38135u,38137u,38140u,38209u,38210u,38213u,38217u,38225u,38227u,
;     659 	    38229u,38230u,38231u,38241u,38245u,38249u,38262u,38263u,38273u,38277u,
;     660 	    38305u,38306u,38309u,38312u,38313u,38315u,38317u,38321u,38323u,38325u,
;     661 	    38327u,38329u,38331u,38337u,38341u,38345u,38369u,38390u,38465u,38469u,
;     662 	    38473u,38481u,38483u,38485u,38497u,38529u,38530u,38533u,38537u,38545u,
;     663 	    38547u,38549u,38551u,38561u,38582u,38593u,38615u,38625u,38629u,38633u,
;     664 	    38643u,38645u,38647u,38721u,38725u,38729u,38737u,38743u,38753u,38754u,
;     665 	    38757u,38760u,38761u,38763u,38769u,38771u,38773u,38775u,38785u,38817u,
;     666 	    38818u,38821u,38824u,38825u,38833u,38835u,38837u,38838u,38839u,38840u,
;     667 	    39009u,39010u,39013u,39017u,
;     668 	    39025u,39027u,39029u,39030u,39031u,39037u,39041u,39042u,39045u,39049u,
;     669 	    39057u,39059u,39061u,39062u,39063u,39137u,39138u,39141u,39145u,39147u,
;     670 	    39148u,39153u,39155u,39157u,39158u,39159u,39165u,39233u,39234u,39237u,
;     671 	    39241u,39249u,39251u,39253u,39254u,39255u,39265u,39286u,39329u,39330u,
;     672 	    39333u,39337u,39351u,39361u,39369u,39393u,39489u,39493u,39553u,39554u,
;     673 	    39557u,39561u,39568u,39569u,39575u,39617u,39649u,39653u,39657u,39665u,
;     674 	    39667u,39671u,39777u,39778u,39781u,39784u,39785u,39793u,39795u,39797u,
;     675 	    39809u,39813u,39817u,39825u,39827u,39841u,39845u,39849u,39857u,39859u,
;     676 	    39861u,39863u,40033u,40034u,40037u,40041u,40049u,40051u,40053u,40054u,
;     677 	    40055u,40056u,40060u,40061u,
;     678 	    40065u,40066u,40069u,40073u,40081u,40083u,40085u,40086u,40087u,40097u,
;     679 	    40098u,40101u,40117u,40119u,40161u,40162u,40165u,40169u,40177u,40179u,
;     680 	    40181u,40182u,40183u,40189u,40257u,40258u,40261u,40265u,40273u,40275u,
;     681 	    40277u,40279u,40289u,40290u,40293u,40297u,40305u,40307u,40309u,40310u,
;     682 	    40311u,40321u,40325u,40339u,40341u,40353u,40354u,40357u,40361u,40369u,
;     683 	    40371u,40373u,40375u,40385u,40389u,40407u,40438u,40513u,40517u,40521u,
;     684 	    40529u,40531u,40533u,40535u,40545u,40549u,40553u,40563u,40565u,40567u,
;     685 	    40577u,40578u,40581u,40585u,40593u,40595u,40597u,40599u,40609u,40630u,
;     686 	    40641u,40673u,40674u,40677u,40681u,40689u,40693u,40695u,40769u,40770u,
;     687 	    40773u,40777u,40785u,40787u,
;     688 	    40789u,40791u,40801u,40802u,40805u,40809u,40817u,40819u,40821u,40823u,
;     689 	    40824u,40827u,40828u,40865u,40866u,40869u,40873u,40881u,40883u,40885u,
;     690 	    40887u,41057u,41058u,41061u,41063u,41064u,41065u,41066u,41067u,41073u,
;     691 	    41075u,41077u,41079u,41080u,41083u,41085u,41089u,41090u,41093u,41097u,
;     692 	    41105u,41107u,41109u,41110u,41111u,41112u,41121u,41122u,41129u,41143u,
;     693 	    41185u,41186u,41189u,41193u,41195u,41201u,41203u,41205u,41207u,41208u,
;     694 	    41213u,41281u,41282u,41285u,41289u,41297u,41299u,41301u,41302u,41303u,
;     695 	    41313u,41314u,41317u,41321u,41333u,41334u,41335u,41337u,41345u,41377u,
;     696 	    41378u,41380u,41381u,41385u,41387u,41393u,41395u,41397u,41399u,41409u,
;     697 	    41413u,41430u,41431u,41537u,
;     698 	    41541u,41545u,41555u,41557u,41559u,41569u,41573u,41577u,41587u,41589u,
;     699 	    41601u,41602u,41603u,41605u,41608u,41609u,41610u,41611u,41617u,41619u,
;     700 	    41621u,41623u,41627u,41629u,41633u,41637u,41641u,41651u,41653u,41665u,
;     701 	    41697u,41701u,41705u,41793u,41797u,41801u,41809u,41813u,41825u,41829u,
;     702 	    41833u,41841u,41845u,41889u,41890u,41893u,41896u,41897u,41899u,41905u,
;     703 	    41907u,41909u,41910u,41911u,41913u,41915u,42081u,42082u,42083u,42084u,
;     704 	    42085u,42088u,42089u,42090u,42091u,42092u,42097u,42099u,42101u,42103u,
;     705 	    42107u,42113u,42114u,42117u,42121u,42129u,42131u,42133u,42134u,42135u,
;     706 	    42139u,42145u,42146u,42149u,42163u,42209u,42210u,42213u,42216u,42217u,
;     707 	    42219u,42225u,42227u,42229u,
;     708 	    42231u,42232u,42305u,42306u,42309u,42312u,42313u,42321u,42323u,42325u,
;     709 	    42326u,42327u,42337u,42338u,42341u,42345u,42355u,42357u,42358u,42359u,
;     710 	    42363u,42369u,42373u,42401u,42402u,42403u,42405u,42409u,42417u,42419u,
;     711 	    42421u,42423u,42433u,42437u,42454u,42465u,42486u,42561u,42562u,42565u,
;     712 	    42569u,42577u,42579u,42593u,42597u,42625u,42626u,42629u,42632u,42633u,
;     713 	    42634u,42635u,42641u,42643u,42645u,42647u,42651u,42652u,42657u,42665u,
;     714 	    42678u,42689u,42721u,42722u,42725u,42729u,42743u,42817u,42821u,42825u,
;     715 	    42833u,42837u,42839u,42849u,42850u,42853u,42857u,42865u,42867u,42869u,
;     716 	    42913u,42914u,42917u,42921u,42923u,42929u,42931u,42933u,42935u,42936u,
;     717 	    42937u,43105u,43106u,43109u,
;     718 	    43113u,43115u,43121u,43123u,43125u,43126u,43127u,43133u,43137u,43138u,
;     719 	    43141u,43145u,43153u,43155u,43157u,43158u,43159u,43169u,43170u,43185u,
;     720 	    43233u,43234u,43237u,43240u,43241u,43249u,43253u,43254u,43255u,43329u,
;     721 	    43351u,43361u,43362u,43377u,43379u,43381u,43382u,43383u,43425u,43426u,
;     722 	    43429u,43433u,43441u,43443u,43447u,43585u,43617u,43639u,43649u,43650u,
;     723 	    43653u,43657u,43665u,43669u,43671u,43841u,43863u,43873u,43877u,43881u,
;     724 	    43889u,43891u,43937u,43938u,43941u,43945u,43953u,43955u,43957u,43959u,
;     725 	    44129u,44130u,44132u,44133u,44136u,44137u,44138u,44139u,44145u,44147u,
;     726 	    44149u,44150u,44151u,44155u,44161u,44162u,44165u,44169u,44177u,44179u,
;     727 	    44181u,44182u,44183u,44193u,
;     728 	    44194u,44197u,44201u,44209u,44211u,44213u,44215u,44225u,44229u,44233u,
;     729 	    44241u,44247u,44257u,44258u,44259u,44260u,44261u,44264u,44265u,44267u,
;     730 	    44268u,44273u,44275u,44277u,44278u,44279u,44284u,44353u,44354u,44357u,
;     731 	    44361u,44369u,44371u,44373u,44374u,44375u,44385u,44386u,44389u,44393u,
;     732 	    44401u,44403u,44405u,44406u,44407u,44417u,44421u,44425u,44439u,44449u,
;     733 	    44450u,44451u,44453u,44457u,44459u,44465u,44467u,44469u,44471u,44475u,
;     734 	    44481u,44482u,44485u,44489u,44503u,44513u,44517u,44521u,44529u,44533u,
;     735 	    44534u,44609u,44613u,44617u,44625u,44627u,44629u,44641u,44642u,44645u,
;     736 	    44649u,44657u,44659u,44661u,44663u,44673u,44674u,44677u,44680u,44681u,
;     737 	    44689u,44691u,44693u,44695u,
;     738 	    44697u,44699u,44700u,44705u,44726u,44737u,44738u,44741u,44745u,44753u,
;     739 	    44759u,44769u,44770u,44773u,44777u,44785u,44787u,44789u,44791u,44865u,
;     740 	    44866u,44873u,44881u,44885u,44887u,44897u,44898u,44901u,44905u,44906u,
;     741 	    44913u,44915u,44917u,44919u,44961u,44962u,44965u,44968u,44969u,44976u,
;     742 	    44977u,44979u,44981u,44983u,44988u,45153u,45154u,45156u,45157u,45161u,
;     743 	    45169u,45171u,45174u,45175u,45181u,45185u,45186u,45189u,45193u,45201u,
;     744 	    45203u,45206u,45207u,45239u,45281u,45282u,45285u,45289u,45291u,45297u,
;     745 	    45299u,45302u,45303u,45377u,45381u,45385u,45385u,45473u,45474u,45477u,
;     746 	    45480u,45481u,45483u,45489u,45491u,45495u,45505u,45506u,45509u,45526u,
;     747 	    45537u,45558u,45633u,45637u,
;     748 	    45641u,45649u,45651u,45665u,45697u,45698u,45701u,45705u,45713u,45715u,
;     749 	    45719u,45729u,45750u,45761u,45793u,45797u,45911u,45921u,45922u,45925u,
;     750 	    45929u,45931u,45936u,45937u,45939u,45953u,45957u,45961u,45969u,45985u,
;     751 	    45986u,45989u,45993u,46001u,46003u,46005u,46007u,46177u,46178u,46181u,
;     752 	    46182u,46183u,46185u,46186u,46187u,46192u,46193u,46195u,46197u,46198u,
;     753 	    46199u,46203u,46204u,46209u,46210u,46213u,46217u,46225u,46227u,46229u,
;     754 	    46230u,46231u,46241u,46242u,46245u,46249u,46252u,46257u,46259u,46261u,
;     755 	    46263u,46267u,46269u,46273u,46277u,46281u,46291u,46305u,46306u,46309u,
;     756 	    46310u,46312u,46313u,46314u,46315u,46321u,46323u,46324u,46325u,46326u,
;     757 	    46327u,46328u,46330u,46332u,
;     758 	    46401u,46402u,46405u,46409u,46417u,46419u,46421u,46423u,46433u,46434u,
;     759 	    46435u,46437u,46441u,46443u,46444u,46449u,46451u,46452u,46453u,46454u,
;     760 	    46455u,46459u,46460u,46461u,46465u,46469u,46473u,46481u,46483u,46485u,
;     761 	    46486u,46497u,46498u,46501u,46505u,46506u,46507u,46509u,46512u,46513u,
;     762 	    46515u,46517u,46519u,46521u,46529u,46530u,46533u,46537u,46545u,46547u,
;     763 	    46549u,46550u,46551u,46561u,46562u,46565u,46577u,46581u,46583u,46657u,
;     764 	    46658u,46661u,46665u,46673u,46675u,46677u,46679u,46689u,46690u,46693u,
;     765 	    46697u,46705u,46707u,46709u,46711u,46721u,46722u,46725u,46729u,46730u,
;     766 	    46731u,46737u,46739u,46741u,46743u,46753u,46754u,46757u,46761u,46769u,
;     767 	    46771u,46774u,46775u,46785u,
;     768 	    46786u,46789u,46793u,46801u,46803u,46807u,46817u,46818u,46821u,46825u,
;     769 	    46833u,46835u,46837u,46839u,46913u,46914u,46917u,46921u,46929u,46931u,
;     770 	    46933u,46935u,46937u,46945u,46946u,46949u,46953u,46959u,46961u,46963u,
;     771 	    46965u,46967u,46968u,46969u,46970u,46971u,46972u,46973u,46977u,46981u,
;     772 	    46985u,46993u,46997u,47009u,47010u,47013u,47017u,47018u,47019u,47024u,
;     773 	    47025u,47027u,47029u,47030u,47031u,47032u,47036u,47201u,47202u,47205u,
;     774 	    47207u,47208u,47209u,47211u,47217u,47219u,47221u,47222u,47223u,47224u,
;     775 	    47233u,47234u,47237u,47241u,47249u,47251u,47253u,47254u,47255u,47265u,
;     776 	    47266u,47269u,47271u,47273u,47281u,47287u,47297u,47301u,47305u,47329u,
;     777 	    47330u,47333u,47337u,47339u,
;     778 	    47345u,47347u,47349u,47351u,47352u,47425u,47426u,47429u,47433u,47441u,
;     779 	    47443u,47445u,47447u,47457u,47461u,47465u,47473u,47475u,47478u,47479u,
;     780 	    47489u,47521u,47522u,47525u,47529u,47531u,47537u,47539u,47541u,47543u,
;     781 	    47544u,47545u,47549u,47553u,47554u,47561u,47571u,47573u,47575u,47585u,
;     782 	    47606u,47607u,47681u,47685u,47689u,47697u,47699u,47701u,47703u,47713u,
;     783 	    47714u,47717u,47735u,47745u,47746u,47749u,47753u,47754u,47755u,47761u,
;     784 	    47763u,47765u,47767u,47777u,47798u,47809u,47841u,47842u,47845u,47849u,
;     785 	    47857u,47859u,47861u,47937u,47941u,47945u,47953u,47969u,47970u,47973u,
;     786 	    47977u,47985u,47987u,47989u,47991u,48033u,48034u,48037u,48040u,48041u,
;     787 	    48043u,48049u,48051u,48053u,
;     788 	    48055u,48056u,48059u,48060u,48225u,48226u,48229u,48231u,48233u,48236u,
;     789 	    48241u,48243u,48245u,48246u,48247u,48257u,48258u,48261u,48265u,48273u,
;     790 	    48275u,48277u,48278u,48279u,48289u,48293u,48311u,48353u,48354u,48357u,
;     791 	    48361u,48369u,48371u,48373u,48374u,48375u,48449u,48471u,48481u,48502u,
;     792 	    48545u,48546u,48549u,48553u,48561u,48563u,48565u,48567u,48569u,48577u,
;     793 	    48578u,48585u,48598u,48609u,48630u,48705u,48709u,48713u,48721u,48723u,
;     794 	    48759u,48769u,48770u,48773u,48777u,48785u,48787u,48791u,48801u,48822u,
;     795 	    48823u,48865u,48961u,48993u,49009u,49013u,49015u,49057u,49058u,49061u,
;     796 	    49065u,49073u,49075u,49079u,49080u,49085u,49249u,49250u,49253u,49255u,
;     797 	    49257u,49265u,49267u,49269u,
;     798 	    49270u,49271u,49272u,49281u,49282u,49285u,49289u,49297u,49299u,49301u,
;     799 	    49302u,49303u,49313u,49317u,49319u,49321u,49329u,49335u,49377u,49378u,
;     800 	    49381u,49385u,49393u,49395u,49397u,49398u,49399u,49473u,49474u,49477u,
;     801 	    49481u,49489u,49491u,49493u,49495u,49505u,49509u,49526u,49537u,49541u,
;     802 	    49559u,49569u,49570u,49573u,49577u,49585u,49587u,49589u,49591u,49601u,
;     803 	    49605u,49609u,49623u,49729u,49733u,49737u,49745u,49747u,49749u,49751u,
;     804 	    49761u,49777u,49793u,49794u,49797u,49801u,49809u,49811u,49813u,49815u,
;     805 	    49825u,49846u,49857u,49861u,49889u,49893u,49897u,49905u,49907u,49909u,
;     806 	    49911u,49985u,49989u,49993u,50001u,50007u,50017u,50018u,50021u,50025u,
;     807 	    50033u,50035u,50037u,50039u,
;     808 	    50081u,50082u,50085u,50088u,50089u,50090u,50097u,50099u,50101u,50103u,
;     809 	    50273u,50274u,50277u,50281u,50289u,50291u,50293u,50295u,50305u,50306u,
;     810 	    50309u,50313u,50321u,50323u,50325u,50326u,50327u,50337u,50338u,50359u,
;     811 	    50401u,50402u,50405u,50408u,50409u,50417u,50419u,50421u,50422u,50423u,
;     812 	    50497u,50498u,50501u,50505u,50513u,50515u,50517u,50519u,50529u,50533u,
;     813 	    50537u,50545u,50547u,50549u,50550u,50551u,50561u,50593u,50594u,50597u,
;     814 	    50601u,50609u,50611u,50613u,50615u,50625u,50626u,50629u,50633u,50641u,
;     815 	    50647u,50657u,50679u,50753u,50761u,50785u,50817u,50818u,50821u,50825u,
;     816 	    50833u,50835u,50837u,50839u,50849u,50853u,50857u,50871u,50881u,50903u,
;     817 	    50913u,50914u,50917u,50921u,
;     818 	    50929u,50931u,50933u,50935u,51009u,51013u,51017u,51025u,51041u,51042u,
;     819 	    51045u,51049u,51057u,51059u,51063u,51105u,51106u,51109u,51113u,51121u,
;     820 	    51123u,51125u,51127u,51297u,51298u,51301u,51305u,51306u,51313u,51315u,
;     821 	    51317u,51318u,51319u,51329u,51330u,51333u,51337u,51345u,51347u,51349u,
;     822 	    51350u,51351u,51361u,51383u,51425u,51426u,51429u,51433u,51435u,51441u,
;     823 	    51443u,51445u,51446u,51447u,51521u,51522u,51525u,51529u,51537u,51539u,
;     824 	    51541u,51543u,51553u,51557u,51574u,51585u,51589u,51617u,51618u,51621u,
;     825 	    51625u,51633u,51635u,51637u,51639u,51644u,51649u,51653u,51681u,51777u,
;     826 	    51781u,51797u,51799u,51809u,51841u,51842u,51845u,51849u,51857u,51859u,
;     827 	    51861u,51863u,51873u,51894u,
;     828 	    51905u,51937u,51938u,51941u,51945u,51953u,51955u,51959u,52033u,52037u,
;     829 	    52041u,52049u,52055u,52065u,52066u,52069u,52072u,52073u,52075u,52081u,
;     830 	    52083u,52085u,52097u,52101u,52105u,52113u,52115u,52129u,52130u,52133u,
;     831 	    52137u,52145u,52147u,52149u,52151u,52321u,52322u,52323u,52325u,52329u,
;     832 	    52331u,52337u,52339u,52341u,52342u,52343u,52347u,52353u,52354u,52357u,
;     833 	    52361u,52369u,52371u,52373u,52374u,52375u,52385u,52386u,52449u,52450u,
;     834 	    52453u,52457u,52465u,52467u,52469u,52470u,52471u,52545u,52546u,52549u,
;     835 	    52553u,52561u,52563u,52565u,52567u,52577u,52581u,52585u,52593u,52595u,
;     836 	    52598u,52599u,52609u,52617u,52627u,52629u,52641u,52642u,52645u,52649u,
;     837 	    52657u,52659u,52661u,52663u,
;     838 	    52673u,52695u,52801u,52805u,52833u,52837u,52841u,52851u,52853u,52865u,
;     839 	    52866u,52869u,52872u,52873u,52875u,52881u,52883u,52885u,52887u,52897u,
;     840 	    52919u,52961u,52965u,52969u,52977u,52981u,53057u,53061u,53065u,53073u,
;     841 	    53077u,53079u,53089u,53093u,53097u,53105u,53107u,53109u,53153u,53154u,
;     842 	    53157u,53161u,53169u,53171u,53173u,53175u,53345u,53346u,53349u,53353u,
;     843 	    53358u,53361u,53363u,53365u,53367u,53377u,53378u,53381u,53385u,53393u,
;     844 	    53395u,53397u,53398u,53399u,53409u,53431u,53473u,53474u,53477u,53481u,
;     845 	    53483u,53489u,53491u,53493u,53495u,53569u,53570u,53573u,53577u,53585u,
;     846 	    53587u,53589u,53591u,53601u,53602u,53605u,53609u,53617u,53619u,53621u,
;     847 	    53622u,53623u,53633u,53637u,
;     848 	    53641u,53651u,53665u,53666u,53669u,53673u,53678u,53681u,53683u,53685u,
;     849 	    53687u,53691u,53697u,53698u,53701u,53705u,53717u,53719u,53729u,53730u,
;     850 	    53733u,53749u,53751u,53825u,53826u,53829u,53833u,54195u,53845u,53847u,
;     851 	    53857u,53861u,53865u,53875u,53877u,53889u,53890u,53893u,53897u,53902u,
;     852 	    53905u,53909u,53911u,53921u,53925u,53929u,53937u,53943u,53953u,53954u,
;     853 	    53957u,53961u,53975u,53985u,53986u,53989u,53993u,54001u,54003u,54005u,
;     854 	    54007u,54081u,54082u,54085u,54089u,54097u,54101u,54103u,54113u,54114u,
;     855 	    54117u,54119u,54120u,54121u,54122u,54129u,54131u,54133u,54135u,54139u,
;     856 	    54145u,54149u,54153u,54161u,54163u,54167u,54177u,54178u,54181u,54185u,
;     857 	    54193u,54195u,54197u,54199u
;     858 };
;     859 
;     860 
;     861 // LCD ּ 
;     862 #define	LCD_CS1			0x04				// a3=0,a2=1
;     863 #define	LCD_CS2			0x08				// a3=1,a2=0
;     864 #define	LCD_CS_ALL		0x0c				// a3=1,a2=1
;     865 
;     866 //  
;     867 #define 	_BLACK		0
;     868 #define 	_WHITE		15
;     869 
;     870 // Լ 
;     871 void Clrscr(void);						// ü ȭ 
;     872 void Cleardevice(void);						// ü ȭ 
;     873 void Gotoxy(int x,int y);					// ׷ ǥ 
;     874 void Gotoxyt(int x,int y);					// ؽƮ ǥ 
;     875 
;     876 void Setcolor(char color);					// ڻ (_WHITE,_BLACK)
;     877 
;     878 void Putch(unsigned c); 					// ڸ 
;     879 void Putchxy(int x,int y,unsigned c);				// ׷ ǥ  
;     880 void Putchxyt(int x,int y,unsigned c);				// ؽƮ ǥ  
;     881 
;     882 void Puts(const char *str);					// ڿ 
;     883 void Putsxy(int x,int y,const char *str);			// ׷ ǥ ڿ 
;     884 void Putsxyt(int x,int y,const char *str);			// ؽƮ ǥ ڿ 
;     885 
;     886 void Puts_f(const char flash *str);				// CODE ڿ 
;     887 void Putsxy_f(int x,int y,const char flash *str);		// ׷ ǥ CODE ڿ 
;     888 void Putsxyt_f(int x,int y,const char flash *str);		// ؽƮ ǥ CODE ڿ 
;     889 
;     890 void Line(int x1,int y1,int x2,int y2);				// ׷ǥ  ׸
;     891 void Rectangle(int x1,int y1,int x2,int y2);			// ׷ ǥ ڽ ׸
;     892 void Rectanglefill(int x1,int y1,int x2,int y2);		// ä ڽ ׸
;     893 void Circle(int xx,int yy,int radius);				//  ׸
;     894 void Ellipse(int xx,int yy,int a0,int b0);			// Ÿ ׸
;     895 
;     896 void Putpixel(int x,int y,char color);				// ȭ鿡  (,,÷(_WHITE,BLACK))
;     897 void Putpixelb(int x,int y,unsigned char datac,char color);	// ȭ鿡 Ʈ 
;     898 
;     899 void symmetry4(int xx,int yy,int x,int y);
;     900 void _Plotcircle(int xx,int yy,int x,int y);
;     901 
;     902 void _Putch(unsigned int c);					// 1Ʈ  
;     903 void *_GetHanImage(unsigned c);					// ѱ Ʈ ε
;     904 void _memor(unsigned char *s1,unsigned char flash *s2, int len);// ѱ Ʈ 
;     905 unsigned char* _GetAscImage(int c);		        	//  Ʈ  ε
;     906 void Han_Conv(char *buf);					// ϼ(SRAM)  (SRAM) ȯ
;     907 void Han_Conv_f(char flash *buf);				// ϼ(FLASH) (SRAM) ȯ
;     908 
;     909 // LCD H/W 
;     910 void Lcd_Init(void);						// GLCD Init
;     911 void GLCD_Busy(int port);					// LCD Busy Check
;     912 void GLCD_Command(int port,unsigned char uch);			// COMMAND Write
;     913 void GLCD_Dwrite(int port,unsigned char uch);			// DATA Write
;     914 unsigned char GLCD_Dread(int port);				// DATA 
;     915 
;     916 //  
;     917 // ==== LCD  ====
;     918 // A0 : RS
;     919 // A1 : R/W
;     920 // A2 : CS1
;     921 // A3 : CS2
;     922 // ------------------
;     923 unsigned char *GLCD_DATA_RD = (unsigned char*)0x8003;		// Lcd Data Read (A3=0,A2=0,A1=1,A0=1)
;     924 unsigned char *GLCD_DATA_WR = (unsigned char*)0x8001;		// Lcd Data Write(A3=0,A2=0,A1=0,A0=1)
;     925 unsigned char *GLCD_CMD_RD  = (unsigned char*)0x8002;		// Lcd Instruction Register Read(A3=0,A2=0,A1=1,A0=0)
;     926 unsigned char *GLCD_CMD_WR  = (unsigned char*)0x8000;		// Lcd Instruction Register Write(A3=0,A2=0,A1=0,A0=0)
;     927 
;     928 int _screen_color = _WHITE;					// ڻ 

	.DSEG
__screen_color:
	.BYTE 0x2
;     929 int _screen_curx = 0;						// X ǥ 
__screen_curx:
	.BYTE 0x2
;     930 int _screen_cury = 0;						// Yǥ 
__screen_cury:
	.BYTE 0x2
;     931 
;     932 static unsigned char ib[32];					// ѱ  
_ib_G1:
	.BYTE 0x20
;     933 static unsigned char ascii_fbuf[20];                            //    
_ascii_fbuf_G1:
	.BYTE 0x14
;     934 static unsigned char han_conv_buf[101];				// ѱ    
_han_conv_buf_G1:
	.BYTE 0x65
;     935 
;     936 // =============================== LCD ȭ  ===============================
;     937 // [μ] void
;     938 // [] 128*64
;     939 // -----------------------------------------------------------------------------
;     940 void Clrscr(void)
;     941 {

	.CSEG
_Clrscr:
;     942 	Cleardevice();						// ȭ 
	RCALL _Cleardevice
;     943 }
	RET
;     944 
;     945 // =============================== LCD ȭ  ===============================
;     946 // [μ] void
;     947 // [] 128*64
;     948 // -----------------------------------------------------------------------------
;     949 void Cleardevice(void)
;     950 {
_Cleardevice:
;     951 int i,j,page,y;
;     952 
;     953 	page = 0xb8;						// page address 0
	SBIW R28,2
	CALL __SAVELOCR6
;	i -> R16,R17
;	j -> R18,R19
;	page -> R20,R21
;	y -> Y+6
	__GETWRN 20,21,184
;     954 	y = 0x40;						// Y address 0
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	STD  Y+6,R30
	STD  Y+6+1,R31
;     955 	for(i = 0 ; i < 8; i++){				// page(0-7)
	__GETWRN 16,17,0
_0xA:
	__CPWRN 16,17,8
	BRGE _0xB
;     956 		GLCD_Command(LCD_CS_ALL,page);			// page set
	CALL SUBOPT_0x0
	ST   -Y,R20
	RCALL _GLCD_Command
;     957 		GLCD_Command(LCD_CS_ALL,y);			// Y address set
	CALL SUBOPT_0x0
	LDD  R30,Y+8
	ST   -Y,R30
	RCALL _GLCD_Command
;     958 		for(j = 0; j < 64; j++){			// Y adress(0 - 63)
	__GETWRN 18,19,0
_0xD:
	__CPWRN 18,19,64
	BRGE _0xE
;     959 			GLCD_Dwrite(LCD_CS_ALL,0x00);		// data 0 write
	CALL SUBOPT_0x0
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _GLCD_Dwrite
;     960 		}
	__ADDWRN 18,19,1
	RJMP _0xD
_0xE:
;     961 		page++;						// page++
	__ADDWRN 20,21,1
;     962 	}
	__ADDWRN 16,17,1
	RJMP _0xA
_0xB:
;     963 	_screen_curx = _screen_cury = 0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL SUBOPT_0x1
	CALL SUBOPT_0x2
;     964 }
	CALL __LOADLOCR6
	RJMP _0x15F
;     965 
;     966 // ============================= ׷ ǥ  ==============================
;     967 // [μ] int x,int y
;     968 // Item1: x pos(0 - 127)
;     969 // Item2: y pos(0 - 63)
;     970 // -----------------------------------------------------------------------------
;     971 void Gotoxy(int x,int y)
;     972 {
_Gotoxy:
;     973 	if(x >= 0 && x < 128){					// X ʰ ˻
;	x -> Y+2
;	y -> Y+0
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,0
	BRLT _0x10
	CPI  R26,LOW(0x80)
	LDI  R30,HIGH(0x80)
	CPC  R27,R30
	BRLT _0x11
_0x10:
	RJMP _0xF
_0x11:
;     974 		if(y >= 0 && y < 64){				// Y ʰ ˻
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,0
	BRLT _0x13
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0x14
_0x13:
	RJMP _0x12
_0x14:
;     975 			_screen_curx = x;
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	CALL SUBOPT_0x2
;     976 			_screen_cury = y;
	LD   R30,Y
	LDD  R31,Y+1
	CALL SUBOPT_0x1
;     977 		}
;     978 	}
_0x12:
;     979 }
_0xF:
	ADIW R28,4
	RET
;     980 
;     981 // ======================= ȭ鿡 ؽƮ ǥ  ===========================
;     982 // [μ] int x,int y
;     983 // Item1  x pos(1 - 16)
;     984 // Item2  y pos(1 - 4)
;     985 // [] _screen_curx,_screen_cury
;     986 // -----------------------------------------------------------------------------
;     987 void Gotoxyt(int x,int y)
;     988 {
_Gotoxyt:
;     989 int x1 = (x-1) * 8,y1;
;     990 
;     991 	y1 = (y-1) * 16;
	CALL __SAVELOCR4
;	x -> Y+6
;	y -> Y+4
;	x1 -> R16,R17
;	y1 -> R18,R19
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,1
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CALL __MULW12
	MOVW R16,R30
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,1
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CALL __MULW12
	MOVW R18,R30
;     992 	if(x1 >= 0 && x1 < 128){
	SUBI R16,0
	SBCI R17,0
	BRLT _0x16
	__CPWRN 16,17,128
	BRLT _0x17
_0x16:
	RJMP _0x15
_0x17:
;     993 		if(y1 >= 0 && y1 < 64){
	SUBI R18,0
	SBCI R19,0
	BRLT _0x19
	__CPWRN 18,19,64
	BRLT _0x1A
_0x19:
	RJMP _0x18
_0x1A:
;     994 			_screen_curx = x1;
	__PUTWMRN __screen_curx,0,16,17
;     995 			_screen_cury = y1;
	__PUTWMRN __screen_cury,0,18,19
;     996 		}
;     997 	}
_0x18:
;     998 }
_0x15:
	CALL __LOADLOCR4
	RJMP _0x15F
;     999 
;    1000 // =============================== ڻ  ===============================
;    1001 // [μ] char color
;    1002 // Item1: ڻ(_WHITE,_BLACK)
;    1003 // -----------------------------------------------------------------------------
;    1004 void Setcolor(char color)
;    1005 {
_Setcolor:
;    1006 	_screen_color = color;					// ڻ 
;	color -> Y+0
	LD   R30,Y
	LDI  R31,0
	STS  __screen_color,R30
	STS  __screen_color+1,R31
;    1007 }
	ADIW R28,1
	RET
;    1008 
;    1009 // ============================== ѹڸ  Ѵ. ==========================
;    1010 // [μ] unsigned c
;    1011 // Item1:  (ѱ ڵ )
;    1012 // -----------------------------------------------------------------------------
;    1013 void Putch(unsigned c)
;    1014 {
_Putch:
;    1015 	_Putch(c&0xff);						// 1Ʈ ڸ ǥ
;	c -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	ANDI R31,HIGH(0xFF)
	CALL SUBOPT_0x3
;    1016 }
	ADIW R28,2
	RET
;    1017 
;    1018 // ================  ׷ ǥ ѹڸ  Ѵ. ===================
;    1019 // [μ] int x
;    1020 //	  int y
;    1021 //	  unsigned c
;    1022 // Item1:    ġ(0 - 127)
;    1023 // Item2:    ġ(0 - 63)
;    1024 // Item3:  ((ѱ ڵ )
;    1025 // -----------------------------------------------------------------------------
;    1026 void Putchxy(int x,int y,unsigned c)
;    1027 {
_Putchxy:
;    1028 	Gotoxy(x,y);						// Base Cursor Point Set
;	x -> Y+4
;	y -> Y+2
;	c -> Y+0
	CALL SUBOPT_0x4
	CALL SUBOPT_0x4
	CALL SUBOPT_0x5
;    1029 	Putch(c);						// 1Ʈ ڸ ǥ
	CALL _Putch
;    1030 }
	RJMP _0x160
;    1031 
;    1032 // ===================  ؽƮ ǥ ѹڸ  Ѵ. ================
;    1033 //  [μ] int x
;    1034 //	   int y
;    1035 //	   unsigned c
;    1036 //  Item1:    ġ(1 - 16)
;    1037 //  Item2:    ġ(1 - 4)
;    1038 //  Item3:  (ѱ ڵ )
;    1039 // -----------------------------------------------------------------------------
;    1040 void Putchxyt(int x,int y,unsigned c)
;    1041 {
_Putchxyt:
;    1042 	Gotoxyt(x,y);						// Base Cursor Point Set
;	x -> Y+4
;	y -> Y+2
;	c -> Y+0
	CALL SUBOPT_0x4
	CALL SUBOPT_0x4
	CALL SUBOPT_0x6
;    1043 	Putch(c);						// 1Ʈ ڸ ǥ
	CALL _Putch
;    1044 }
	RJMP _0x160
;    1045 
;    1046 // ====================  Ŀ ġ  ڿ  Ѵ. ==================
;    1047 //  [μ] const char *str
;    1048 //  Item1:  ڿ(ѿ)
;    1049 // -----------------------------------------------------------------------------
;    1050 void Puts(const char *str)
;    1051 {
_Puts:
;    1052 unsigned char byte1st = 0,c;
;    1053 unsigned datau,i = 0;
;    1054 
;    1055 	Han_Conv((char*)str);					// ϼ  ȯ
	CALL __SAVELOCR6
;	*str -> Y+6
;	byte1st -> R17
;	c -> R16
;	datau -> R18,R19
;	i -> R20,R21
	LDI  R17,0
	LDI  R20,0
	LDI  R21,0
	CALL SUBOPT_0x7
	RCALL _Han_Conv
;    1056 	while((c = han_conv_buf[i++]) != 0){			// ҽ Han_Conv() 
_0x1B:
	CALL SUBOPT_0x8
	BREQ _0x1D
;    1057 //	while((c = *str++) != 0){				// 쿡 ϼ->  
;    1058 		if(byte1st){
	CPI  R17,0
	BREQ _0x1E
;    1059 			datau = ((unsigned)byte1st << 8) | (unsigned)c;
	CALL SUBOPT_0x9
;    1060 			_Putch(datau);				// ѱ ڸ ǥ
;    1061 			byte1st = 0;
;    1062 		}
;    1063 		else if(c & 0x80){
	RJMP _0x1F
_0x1E:
	SBRS R16,7
	RJMP _0x20
;    1064 			byte1st = c;				// ѱ Ÿ 
	MOV  R17,R16
;    1065 		}
;    1066 		else{
	RJMP _0x21
_0x20:
;    1067 			if(c == 0x0a){				//  ǵ
	CPI  R16,10
	BRNE _0x22
;    1068 				_Putch(0x0d);
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	CALL SUBOPT_0x3
;    1069 				_Putch(0x0a);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP _0x161
;    1070 			}
;    1071 			else _Putch(c); 			//  ڸ ǥ
_0x22:
	MOV  R30,R16
	LDI  R31,0
_0x161:
	ST   -Y,R31
	ST   -Y,R30
	RCALL __Putch
;    1072 		}
_0x21:
_0x1F:
;    1073 	}
	RJMP _0x1B
_0x1D:
;    1074 }
	CALL __LOADLOCR6
	RJMP _0x15F
;    1075 
;    1076 // ================  Ŀ ġ  FLASH ڿ  Ѵ. ================
;    1077 //  [μ] const char *str
;    1078 //  Item1:  ڿ FLASH(ѿ)
;    1079 // -----------------------------------------------------------------------------
;    1080 void Puts_f(const char flash *str)
;    1081 {
_Puts_f:
;    1082 unsigned char byte1st = 0,c;
;    1083 unsigned datau,i = 0;
;    1084 
;    1085 	Han_Conv_f((char flash*)str);				// ϼ  ȯ
	CALL __SAVELOCR6
;	*str -> Y+6
;	byte1st -> R17
;	c -> R16
;	datau -> R18,R19
;	i -> R20,R21
	LDI  R17,0
	LDI  R20,0
	LDI  R21,0
	CALL SUBOPT_0xA
	RCALL _Han_Conv_f
;    1086 	while((c = han_conv_buf[i++]) != 0){			// ҽ Han_Conv() 
_0x24:
	CALL SUBOPT_0x8
	BREQ _0x26
;    1087 //	while((c = *str++) != 0){				// 쿡 ϼ->  
;    1088 		if(byte1st){
	CPI  R17,0
	BREQ _0x27
;    1089 			datau = ((unsigned)byte1st << 8) | (unsigned)c;
	CALL SUBOPT_0x9
;    1090 			_Putch(datau);				// ѱ ڸ ǥ
;    1091 			byte1st = 0;
;    1092 		}
;    1093 		else if(c & 0x80){
	RJMP _0x28
_0x27:
	SBRS R16,7
	RJMP _0x29
;    1094 			byte1st = c;				// ѱ Ÿ 
	MOV  R17,R16
;    1095 		}
;    1096 		else{
	RJMP _0x2A
_0x29:
;    1097 			if(c == 0x0a){				//  ǵ
	CPI  R16,10
	BRNE _0x2B
;    1098 				_Putch(0x0d);
	LDI  R30,LOW(13)
	LDI  R31,HIGH(13)
	CALL SUBOPT_0x3
;    1099 				_Putch(0x0a);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP _0x162
;    1100 			}
;    1101 			else _Putch(c); 			//  ڸ ǥ
_0x2B:
	MOV  R30,R16
	LDI  R31,0
_0x162:
	ST   -Y,R31
	ST   -Y,R30
	RCALL __Putch
;    1102 		}
_0x2A:
_0x28:
;    1103 	}
	RJMP _0x24
_0x26:
;    1104 }
	CALL __LOADLOCR6
	ADIW R28,10
	RET
;    1105 
;    1106 // ==================  ׷ ġ  ڿ  Ѵ. ==================
;    1107 //  [μ] int x
;    1108 //	   int x
;    1109 //	   const char *str
;    1110 //  Item1: Ŀ  ǥ(0 - 127)
;    1111 //  Item2: Ŀ  ǥ(0 - 63)
;    1112 //  Item3:  ڿ(ѿ)
;    1113 // -----------------------------------------------------------------------------
;    1114 void Putsxy(int x,int y,const char *str)
;    1115 {
_Putsxy:
;    1116 	Gotoxy(x,y);						// Ŀ ġ 
;	x -> Y+4
;	y -> Y+2
;	*str -> Y+0
	CALL SUBOPT_0x4
	CALL SUBOPT_0x4
	CALL SUBOPT_0x5
;    1117 	Puts(str);						// ڿ ǥ
	CALL _Puts
;    1118 }
	RJMP _0x160
;    1119 
;    1120 // ================  ׷ ġ FLASH ڿ  Ѵ. ===============
;    1121 //  [μ] int x
;    1122 //	   int x
;    1123 //	   const char flash *str
;    1124 //  Item1: Ŀ  ǥ(0 - 127)
;    1125 //  Item2: Ŀ  ǥ(0 - 63)
;    1126 //  Item3:  ڿ FLASH(ѿ)
;    1127 // -----------------------------------------------------------------------------
;    1128 void Putsxy_f(int x,int y,const char flash *str)
;    1129 {
_Putsxy_f:
;    1130 	Gotoxy(x,y);						// Ŀ ġ 
;	x -> Y+6
;	y -> Y+4
;	*str -> Y+0
	CALL SUBOPT_0x7
	CALL SUBOPT_0x7
	CALL _Gotoxy
;    1131 	Puts_f(str);						// ڿ ǥ
	CALL SUBOPT_0xB
;    1132 }
	RJMP _0x15F
;    1133 
;    1134 // ================  ؽƮ ġ  ڿ  Ѵ. ====================
;    1135 //  [μ] int x
;    1136 //	   int y
;    1137 //	   const char *str
;    1138 //  Item1: Ŀ  ǥ(1 - 16)
;    1139 //  Item2: Ŀ  ǥ(1 - 4)
;    1140 //  Item3:  ڿ(ѿ)
;    1141 // -----------------------------------------------------------------------------
;    1142 void Putsxyt(int x,int y,const char *str)
;    1143 {
_Putsxyt:
;    1144 	Gotoxyt(x,y);						// Ŀ ġ 
;	x -> Y+4
;	y -> Y+2
;	*str -> Y+0
	CALL SUBOPT_0x4
	CALL SUBOPT_0x4
	CALL SUBOPT_0x6
;    1145 	Puts(str);						// ڿ ǥ
	CALL _Puts
;    1146 }
_0x160:
	ADIW R28,6
	RET
;    1147 
;    1148 // ===============  ؽƮ ġ FLASH ڿ  Ѵ. ================
;    1149 //  [μ] int x
;    1150 //	   int y
;    1151 //	   const char flash *str
;    1152 //  Item1: Ŀ  ǥ(1 - 16)
;    1153 //  Item2: Ŀ  ǥ(1 - 4)
;    1154 //  Item3:  ڿ FLASH(ѿ)
;    1155 // -----------------------------------------------------------------------------
;    1156 void Putsxyt_f(int x,int y,const char flash *str)
;    1157 {
_Putsxyt_f:
;    1158 	Gotoxyt(x,y);						// Ŀ ġ 
;	x -> Y+6
;	y -> Y+4
;	*str -> Y+0
	CALL SUBOPT_0x7
	CALL SUBOPT_0x7
	CALL _Gotoxyt
;    1159 	Puts_f(str);						// ڿ ǥ
	CALL SUBOPT_0xB
;    1160 }
_0x15F:
	ADIW R28,8
	RET
;    1161 
;    1162 // ============== ׷ LCD  ġ   ׸ ==============
;    1163 // [μ] int x1
;    1164 //	  int y1
;    1165 //	  int x2
;    1166 //	  int y2
;    1167 // Item1:  xǥ
;    1168 // Item2:  yǥ
;    1169 // Item3:  xǥ
;    1170 // Item4:  yǥ
;    1171 // -----------------------------------------------------------------------------
;    1172 void Line(int x1,int y1,int x2,int y2)
;    1173 {
_Line:
;    1174 int i,vdx,vdy,vix,viy,vinc,plot,plotx,ploty,x = 0,y = 0;
;    1175 
;    1176 	vdx = x2 - x1;						// vdx = x2 - x1
	SBIW R28,16
	LDI  R24,4
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x2D*2)
	LDI  R31,HIGH(_0x2D*2)
	LDI  R22,BYTE3(_0x2D*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	x1 -> Y+28
;	y1 -> Y+26
;	x2 -> Y+24
;	y2 -> Y+22
;	i -> R16,R17
;	vdx -> R18,R19
;	vdy -> R20,R21
;	vix -> Y+20
;	viy -> Y+18
;	vinc -> Y+16
;	plot -> Y+14
;	plotx -> Y+12
;	ploty -> Y+10
;	x -> Y+8
;	y -> Y+6
	LDD  R26,Y+28
	LDD  R27,Y+28+1
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	SUB  R30,R26
	SBC  R31,R27
	MOVW R18,R30
;    1177 	vdy = y2 - y1;						// vdy = y2 - y1
	LDD  R26,Y+26
	LDD  R27,Y+26+1
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	SUB  R30,R26
	SBC  R31,R27
	MOVW R20,R30
;    1178 	vix = abs(vdx);						// vix = |vdx|
	ST   -Y,R19
	ST   -Y,R18
	CALL _abs
	STD  Y+20,R30
	STD  Y+20+1,R31
;    1179 	viy = abs(vdy); 					// vix = |vdx|
	ST   -Y,R21
	ST   -Y,R20
	CALL _abs
	STD  Y+18,R30
	STD  Y+18+1,R31
;    1180 	if(vix > viy) vinc = vix;				// vinc = vix ? viy;
	LDD  R26,Y+20
	LDD  R27,Y+20+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x2E
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	RJMP _0x163
;    1181 	else vinc = viy;
_0x2E:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
_0x163:
	STD  Y+16,R30
	STD  Y+16+1,R31
;    1182 
;    1183 	plotx = x1;
	LDD  R30,Y+28
	LDD  R31,Y+28+1
	STD  Y+12,R30
	STD  Y+12+1,R31
;    1184 	ploty = y1;
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	STD  Y+10,R30
	STD  Y+10+1,R31
;    1185 	Putpixel(plotx,ploty,_screen_color);
	CALL SUBOPT_0xC
	CALL SUBOPT_0xC
	CALL SUBOPT_0xD
;    1186 	for(i = 0; i <= vinc; i++){
	__GETWRN 16,17,0
_0x31:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	CP   R30,R16
	CPC  R31,R17
	BRGE PC+3
	JMP _0x32
;    1187 		x += vix;
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	CALL SUBOPT_0xE
	STD  Y+8,R30
	STD  Y+8+1,R31
;    1188 		y += viy;
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	CALL SUBOPT_0xF
	STD  Y+6,R30
	STD  Y+6+1,R31
;    1189 		plot = 0;
	LDI  R30,0
	STD  Y+14,R30
	STD  Y+14+1,R30
;    1190 		if(x > vinc){
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x33
;    1191 			x -= vinc;
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+8,R30
	STD  Y+8+1,R31
;    1192 			if(vdx > 0) plotx++;
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BRGE _0x34
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	STD  Y+12,R30
	STD  Y+12+1,R31
;    1193 			if(vdx < 0) plotx--;
_0x34:
	SUBI R18,0
	SBCI R19,0
	BRGE _0x35
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,1
	STD  Y+12,R30
	STD  Y+12+1,R31
;    1194 			plot = 1;
_0x35:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+14,R30
	STD  Y+14+1,R31
;    1195 		}
;    1196 		if(y > vinc){
_0x33:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x36
;    1197 			y -= vinc;
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	CALL SUBOPT_0x10
	STD  Y+6,R30
	STD  Y+6+1,R31
;    1198 			if(vdy > 0) ploty++;
	CLR  R0
	CP   R0,R20
	CPC  R0,R21
	BRGE _0x37
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,1
	STD  Y+10,R30
	STD  Y+10+1,R31
;    1199 			if(vdy < 0) ploty--;
_0x37:
	SUBI R20,0
	SBCI R21,0
	BRGE _0x38
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SBIW R30,1
	STD  Y+10,R30
	STD  Y+10+1,R31
;    1200 			plot = 1;
_0x38:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+14,R30
	STD  Y+14+1,R31
;    1201 		}
;    1202 		if(plot)Putpixel(plotx,ploty,_screen_color);
_0x36:
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SBIW R30,0
	BREQ _0x39
	CALL SUBOPT_0xC
	CALL SUBOPT_0xC
	CALL SUBOPT_0xD
;    1203 	}
_0x39:
	__ADDWRN 16,17,1
	RJMP _0x31
_0x32:
;    1204 }
	CALL __LOADLOCR6
	ADIW R28,30
	RET
;    1205 
;    1206 // ================================== ڽ ׸ ==============================
;    1207 // [μ] int x1
;    1208 //	  int y1
;    1209 //	  int x2
;    1210 //	  int y2
;    1211 // Item1:  xǥ
;    1212 // Item2:  yǥ
;    1213 // Item3:  xǥ
;    1214 // Item4:  yǥ
;    1215 // -----------------------------------------------------------------------------
;    1216 void Rectangle(int x1,int y1,int x2,int y2)
;    1217 {
_Rectangle:
;    1218 	Line(x1,y1,x2,y1);
;	x1 -> Y+6
;	y1 -> Y+4
;	x2 -> Y+2
;	y2 -> Y+0
	CALL SUBOPT_0x7
	CALL SUBOPT_0x7
	CALL SUBOPT_0x7
	CALL SUBOPT_0x11
	CALL _Line
;    1219 	Line(x1,y1,x1,y2);
	CALL SUBOPT_0x7
	CALL SUBOPT_0x7
	CALL SUBOPT_0x11
	CALL SUBOPT_0x7
	CALL _Line
;    1220 	Line(x1,y2,x2,y2);
	CALL SUBOPT_0x7
	CALL SUBOPT_0x12
	CALL SUBOPT_0x7
	CALL _Line
;    1221 	Line(x2,y1,x2,y2);
	CALL SUBOPT_0x12
	CALL SUBOPT_0x7
	CALL SUBOPT_0x7
	CALL _Line
;    1222 }
	RJMP _0x15D
;    1223 
;    1224 // ============================== ä ڽ ׸ ===========================
;    1225 // [μ] int x1
;    1226 //	  int y1
;    1227 //	  int x2
;    1228 //	  int y2
;    1229 // Item1:  xǥ
;    1230 // Item2:  yǥ
;    1231 // Item3:  xǥ
;    1232 // Item4:  yǥ
;    1233 // -----------------------------------------------------------------------------
;    1234 void Rectanglefill(int x1,int y1,int x2,int y2)
;    1235 {
_Rectanglefill:
;    1236 	for( ; y1 <= y2; y1++) Line(x1,y1,x2,y1);
;	x1 -> Y+6
;	y1 -> Y+4
;	x2 -> Y+2
;	y2 -> Y+0
_0x3B:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CP   R30,R26
	CPC  R31,R27
	BRLT _0x3C
	CALL SUBOPT_0x7
	CALL SUBOPT_0x7
	CALL SUBOPT_0x7
	CALL SUBOPT_0x11
	CALL _Line
;    1237 }
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	RJMP _0x3B
_0x3C:
	RJMP _0x15D
;    1238 
;    1239 // ===============================  ׸ ===================================
;    1240 // [μ] int xx
;    1241 //	  int yy
;    1242 //	  float radius
;    1243 // Item1:  xǥ
;    1244 // Item2:  yǥ
;    1245 // Item3: 
;    1246 // -----------------------------------------------------------------------------
;    1247 void Circle(int xx,int yy,int radius)
;    1248 {
_Circle:
;    1249 int y = radius,d = 3-(y*2),x = 0;
;    1250 
;    1251 	while(x < y){
	CALL __SAVELOCR6
;	xx -> Y+10
;	yy -> Y+8
;	radius -> Y+6
;	y -> R16,R17
;	d -> R18,R19
;	x -> R20,R21
	LDI  R20,0
	LDI  R21,0
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	MOVW R16,R30
	MOVW R30,R16
	LSL  R30
	ROL  R31
	LDI  R26,LOW(3)
	LDI  R27,HIGH(3)
	CALL __SWAPW12
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	MOVW R18,R30
_0x3D:
	__CPWRR 20,21,16,17
	BRGE _0x3F
;    1252 		Putpixel(xx+x,yy+y,_screen_color);
	CALL SUBOPT_0x13
;    1253 		_Plotcircle(xx,yy,x,y);				// Ī Ŵ
	CALL SUBOPT_0x11
	CALL SUBOPT_0x11
	ST   -Y,R21
	ST   -Y,R20
	ST   -Y,R17
	ST   -Y,R16
	RCALL __Plotcircle
;    1254 		if(d < 0) d += (x*4+6);
	SUBI R18,0
	SBCI R19,0
	BRGE _0x40
	MOVW R30,R20
	CALL __LSLW2
	ADIW R30,6
	__ADDWRR 18,19,30,31
;    1255 		else{
	RJMP _0x41
_0x40:
;    1256 			d += ((x-y)*4+10);
	MOVW R26,R20
	SUB  R26,R16
	SBC  R27,R17
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CALL __MULW12
	ADIW R30,10
	__ADDWRR 18,19,30,31
;    1257 			y--;
	__SUBWRN 16,17,1
;    1258 		}
_0x41:
;    1259 		x++;
	__ADDWRN 20,21,1
;    1260 	}
	RJMP _0x3D
_0x3F:
;    1261 	if(x == y) Putpixel(xx+x,yy+y,_screen_color);
	__CPWRR 16,17,20,21
	BRNE _0x42
	CALL SUBOPT_0x13
;    1262 }
_0x42:
	RJMP _0x15E
;    1263 
;    1264 // ====================== ׸⿡ Ǵ Ī Լ ========================
;    1265 void _Plotcircle(int xx,int yy,int x,int y)
;    1266 {
__Plotcircle:
;    1267 	Putpixel(xx-x,yy+y,_screen_color);
;	xx -> Y+6
;	yy -> Y+4
;	x -> Y+2
;	y -> Y+0
	CALL SUBOPT_0x14
	CALL SUBOPT_0x15
	CALL SUBOPT_0x16
;    1268 	Putpixel(xx+x,yy-y,_screen_color);
	CALL SUBOPT_0x17
	CALL SUBOPT_0x18
	CALL SUBOPT_0x16
;    1269 	Putpixel(xx-x,yy-y,_screen_color);
	CALL SUBOPT_0x14
	CALL SUBOPT_0x18
	CALL SUBOPT_0x16
;    1270 	Putpixel(xx-y,yy+x,_screen_color);
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0x10
	CALL SUBOPT_0x19
	CALL SUBOPT_0x16
;    1271 	Putpixel(xx+y,yy-x,_screen_color);
	LD   R30,Y
	LDD  R31,Y+1
	CALL SUBOPT_0xF
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x16
;    1272 	Putpixel(xx-y,yy-x,_screen_color);
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0x10
	CALL SUBOPT_0x1A
	CALL SUBOPT_0x16
;    1273 	Putpixel(xx+y,yy+x,_screen_color);
	LD   R30,Y
	LDD  R31,Y+1
	CALL SUBOPT_0xF
	CALL SUBOPT_0x19
	CALL SUBOPT_0x16
;    1274 }
	RJMP _0x15D
;    1275 
;    1276 // ================================== Ÿ ׸ ===============================
;    1277 // [μ] int xx
;    1278 //	  int yy
;    1279 //	  int a0
;    1280 //	  int b0
;    1281 // Item1:  xǥ
;    1282 // Item2:  yǥ
;    1283 // Item3:  ݰ
;    1284 // Item4:  ݰ
;    1285 // -----------------------------------------------------------------------------
;    1286 void Ellipse(int xx,int yy,int a0,int b0)
;    1287 {
_Ellipse:
;    1288 int x = 0,y = b0;
;    1289 long a = a0,b = b0,a2 = a*a,a22 = 2*a2,b2 = b*b,b22 = 2*b2,d,dx,dy;
;    1290 
;    1291 	d = b2-a2*b+a2/4L;
	SBIW R28,36
	CALL __SAVELOCR4
;	xx -> Y+46
;	yy -> Y+44
;	a0 -> Y+42
;	b0 -> Y+40
;	x -> R16,R17
;	y -> R18,R19
;	a -> Y+36
;	b -> Y+32
;	a2 -> Y+28
;	a22 -> Y+24
;	b2 -> Y+20
;	b22 -> Y+16
;	d -> Y+12
;	dx -> Y+8
;	dy -> Y+4
	LDI  R16,0
	LDI  R17,0
	LDD  R30,Y+40
	LDD  R31,Y+40+1
	MOVW R18,R30
	LDD  R30,Y+42
	LDD  R31,Y+42+1
	CALL __CWD1
	__PUTD1S 36
	LDD  R30,Y+40
	LDD  R31,Y+40+1
	CALL __CWD1
	__PUTD1S 32
	__GETD1S 36
	__GETD2S 36
	CALL __MULD12
	__PUTD1S 28
	CALL SUBOPT_0x1B
	CALL __LSLD1
	__PUTD1S 24
	CALL SUBOPT_0x1C
	__GETD2S 32
	CALL __MULD12
	__PUTD1S 20
	CALL __LSLD1
	__PUTD1S 16
	CALL SUBOPT_0x1C
	__GETD2S 28
	CALL __MULD12
	CALL SUBOPT_0x1D
	CALL __SWAPD12
	CALL __SUBD12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD2S 28
	__GETD1N 0x4
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x1E
;    1292 	dx=0L;
	__CLRD1S 8
;    1293 	dy=a22*b;
	CALL SUBOPT_0x1C
	CALL SUBOPT_0x1F
	CALL __MULD12
	CALL SUBOPT_0x20
;    1294 	while(dx < dy){
_0x43:
	CALL SUBOPT_0x21
	CALL SUBOPT_0x22
	CALL __CPD21
	BRGE _0x45
;    1295 		symmetry4(xx,yy,x,y);
	CALL SUBOPT_0x23
	CALL SUBOPT_0x23
	CALL SUBOPT_0x24
;    1296 		if(d > 0){
	CALL __CPD02
	BRGE _0x46
;    1297 			y--;
	CALL SUBOPT_0x25
;    1298 			dy-=a22;
;    1299 			d-=dy;
	__GETD1S 12
	CALL __SUBD12
	__PUTD1S 12
;    1300 		}
;    1301 		x++;
_0x46:
	CALL SUBOPT_0x26
;    1302 		dx+=b22;
;    1303 		d+=b2+dx;
	CALL SUBOPT_0x1D
	CALL __ADDD12
	CALL SUBOPT_0x27
;    1304 	}
	RJMP _0x43
_0x45:
;    1305 	d+=(3*(a2-b2)/2L-(dx+dy))/2L;
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x1B
	CALL __SUBD12
	__GETD2N 0x3
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x28
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x21
	CALL SUBOPT_0x22
	CALL __ADDD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __SUBD21
	CALL SUBOPT_0x28
	CALL SUBOPT_0x27
;    1306 	while(y >= 0){
_0x47:
	SUBI R18,0
	SBCI R19,0
	BRLT _0x49
;    1307 		symmetry4(xx,yy,x,y);
	CALL SUBOPT_0x23
	CALL SUBOPT_0x23
	CALL SUBOPT_0x24
;    1308 		if(d < 0){
	CALL __CPD20
	BRGE _0x4A
;    1309 			x++;
	CALL SUBOPT_0x26
;    1310 			dx+=b22;
;    1311 			d+=dx;
	CALL SUBOPT_0x27
;    1312 		}
;    1313 		y--;
_0x4A:
	CALL SUBOPT_0x25
;    1314 		dy-=a22;
;    1315 		d+=a2-dy;
	CALL SUBOPT_0x1B
	CALL __SUBD12
	CALL SUBOPT_0x27
;    1316 	}
	RJMP _0x47
_0x49:
;    1317 }
	CALL __LOADLOCR4
	ADIW R28,48
	RET
;    1318 
;    1319 // ======================= Ÿ ׸⿡ Ǵ Ī Լ =====================
;    1320 void symmetry4(int xx,int yy,int x,int y)
;    1321 {
_symmetry4:
;    1322 	Putpixel(xx-x,yy+y,_screen_color);
;	xx -> Y+6
;	yy -> Y+4
;	x -> Y+2
;	y -> Y+0
	CALL SUBOPT_0x14
	CALL SUBOPT_0x15
	CALL SUBOPT_0x16
;    1323 	Putpixel(xx+x,yy-y,_screen_color);
	CALL SUBOPT_0x17
	CALL SUBOPT_0x18
	CALL SUBOPT_0x16
;    1324 	Putpixel(xx-x,yy-y,_screen_color);
	CALL SUBOPT_0x14
	CALL SUBOPT_0x18
	CALL SUBOPT_0x16
;    1325 	Putpixel(xx+x,yy+y,_screen_color);
	CALL SUBOPT_0x17
	CALL SUBOPT_0x15
	CALL SUBOPT_0x16
;    1326 }
	RJMP _0x15D
;    1327 
;    1328 // =============================== ȭ鿡   ============================
;    1329 // [μ] int x,int y,int color
;    1330 // Item1:  ũ(0 - 127)
;    1331 // Item2:  ũ(0 - 63)
;    1332 // Item3: (_WHITE,_BLACK)
;    1333 // -----------------------------------------------------------------------------
;    1334 void Putpixel(int x,int y,char color)
;    1335 {
_Putpixel:
;    1336 unsigned char uch;
;    1337 int page,port = LCD_CS1,x_addr = x;
;    1338 int mask_data = 0x01;
;    1339 
;    1340 // port  y address 
;    1341 	if(x >= 64){
	SBIW R28,4
	LDI  R24,2
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x4B*2)
	LDI  R31,HIGH(_0x4B*2)
	LDI  R22,BYTE3(_0x4B*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	x -> Y+13
;	y -> Y+11
;	color -> Y+10
;	uch -> R17
;	page -> R18,R19
;	port -> R20,R21
;	x_addr -> Y+8
;	mask_data -> Y+6
	LDI  R20,4
	LDI  R21,0
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0x4C
;    1342 		x_addr = x - 64;				// X address 
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	SUBI R30,LOW(64)
	SBCI R31,HIGH(64)
	STD  Y+8,R30
	STD  Y+8+1,R31
;    1343 		port = LCD_CS2;					// LCD CS2
	__GETWRN 20,21,8
;    1344 	}
;    1345 // page  BITġ 
;    1346 	page = y >> 3;						// page = y / 8
_0x4C:
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CALL __ASRW3
	MOVW R18,R30
;    1347 	mask_data = mask_data << (y & 0x07);			// mask_data = 1 << (y%8)
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ANDI R30,LOW(0x7)
	ANDI R31,HIGH(0x7)
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CALL SUBOPT_0x29
;    1348 
;    1349 // DD RAM ġ 
;    1350 	GLCD_Command(port,page | 0xb8);				// page set
;    1351 	GLCD_Command(port,x_addr | 0x40);			// Y address set
	CALL SUBOPT_0x2A
;    1352 //  
;    1353 	uch = GLCD_Dread(port);					//   dummy
	CALL SUBOPT_0x2B
;    1354 	uch = GLCD_Dread(port);					//  
;    1355 	if(color == _BLACK){
	LDD  R30,Y+10
	CPI  R30,0
	BRNE _0x4D
;    1356 		mask_data = ~mask_data;				// mask data  0000 0001 -> 1111 1110
	CALL SUBOPT_0x2C
	STD  Y+6,R30
	STD  Y+6+1,R31
;    1357 		uch = uch & mask_data;				// ش BIT 
	AND  R17,R30
;    1358 	}
;    1359 	else uch |= mask_data;
	RJMP _0x4E
_0x4D:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	OR   R17,R30
;    1360 
;    1361 // DD RAM ġ 
;    1362 	GLCD_Command(port,page | 0xb8);				// page set
_0x4E:
	CALL SUBOPT_0x2D
;    1363 	GLCD_Command(port,x_addr | 0x40);			// Y address set
	CALL SUBOPT_0x2A
;    1364 //  
;    1365 	GLCD_Dwrite(port,uch);					//  write
	ST   -Y,R17
	RCALL _GLCD_Dwrite
;    1366 }
	CALL __LOADLOCR6
	ADIW R28,15
	RET
;    1367 
;    1368 // ========================= ȭ ι 1BYTE  =======================
;    1369 // [μ] int x,int y,unsigned char data,char color
;    1370 // item1:  ũ(0 - 319)
;    1371 // item2:  ũ(0 - 239)
;    1372 // item3: Ÿ
;    1373 // item4: 
;    1374 // ------------------------------------------------------------------------------
;    1375 void Putpixelb(int x,int y,unsigned char datac,char color)
;    1376 {
_Putpixelb:
;    1377 unsigned char uch;
;    1378 int page,port = LCD_CS1,x_addr = x,s_cnt;
;    1379 unsigned mask_data = 0xff,datau;
;    1380 
;    1381 // port  y address 
;    1382 	if(x >= 64){
	SBIW R28,8
	LDI  R24,2
	LDI  R26,LOW(2)
	LDI  R27,HIGH(2)
	LDI  R30,LOW(_0x4F*2)
	LDI  R31,HIGH(_0x4F*2)
	LDI  R22,BYTE3(_0x4F*2)
	CALL __INITLOCB
	CALL __SAVELOCR6
;	x -> Y+18
;	y -> Y+16
;	datac -> Y+15
;	color -> Y+14
;	uch -> R17
;	page -> R18,R19
;	port -> R20,R21
;	x_addr -> Y+12
;	s_cnt -> Y+10
;	mask_data -> Y+8
;	datau -> Y+6
	LDI  R20,4
	LDI  R21,0
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	STD  Y+12,R30
	STD  Y+12+1,R31
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	BRLT _0x50
;    1383 		x_addr = x - 64;				// Y address 
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	SUBI R30,LOW(64)
	SBCI R31,HIGH(64)
	STD  Y+12,R30
	STD  Y+12+1,R31
;    1384 		port = LCD_CS2;					// LCD CS2
	__GETWRN 20,21,8
;    1385 	}
;    1386 // page  BITġ 
;    1387 	page = y >> 3;						// page = y / 8
_0x50:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	CALL __ASRW3
	MOVW R18,R30
;    1388 	s_cnt = y & 0x07;					// shift cnt = y%8
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ANDI R30,LOW(0x7)
	ANDI R31,HIGH(0x7)
	STD  Y+10,R30
	STD  Y+10+1,R31
;    1389 	mask_data = mask_data << s_cnt;				// mask data  0111 1101 -> 1111 1010
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CALL __LSLW12
	STD  Y+8,R30
	STD  Y+8+1,R31
;    1390 	datau = datac << s_cnt;					// ǥ  
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+15
	LDI  R27,0
	CALL SUBOPT_0x29
;    1391 
;    1392 // DD RAM ġ 
;    1393 	GLCD_Command(port,page | 0xb8);				// page set
;    1394 	GLCD_Command(port,x_addr | 0x40);			// Y address set
	CALL SUBOPT_0x2E
;    1395 
;    1396 //  
;    1397 	uch = GLCD_Dread(port);					//   dummy
	CALL SUBOPT_0x2B
;    1398 	uch = GLCD_Dread(port);					//  
;    1399 	if(color == _BLACK) uch = uch & ~datau;			// NEW  & ~
	LDD  R30,Y+14
	CPI  R30,0
	BRNE _0x51
	CALL SUBOPT_0x2C
	AND  R17,R30
;    1400 	else{
	RJMP _0x52
_0x51:
;    1401 		uch = uch & ~mask_data;				//  SKIP
	CALL SUBOPT_0x2F
;    1402 		uch = uch | datau;				// NEW  OR 
;    1403 	}
_0x52:
;    1404 // DD RAM ġ 
;    1405 	GLCD_Command(port,page | 0xb8);				// page set
	CALL SUBOPT_0x2D
;    1406 	GLCD_Command(port,x_addr | 0x40);			// Y address set
	CALL SUBOPT_0x2E
;    1407 //  
;    1408 	GLCD_Dwrite(port,uch);					//  write
	ST   -Y,R17
	RCALL _GLCD_Dwrite
;    1409 	if(s_cnt != 0){						// 1Byte  ǥ  ʰ
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SBIW R30,0
	BREQ _0x53
;    1410 		datau = datau >> 8;				//   ε
	LDD  R30,Y+7
	ANDI R31,HIGH(0x0)
	STD  Y+6,R30
	STD  Y+6+1,R31
;    1411 		mask_data = mask_data >> 8;			//  ũ ε
	LDD  R30,Y+9
	ANDI R31,HIGH(0x0)
	STD  Y+8,R30
	STD  Y+8+1,R31
;    1412 // DD RAM+1 ġ 
;    1413 		GLCD_Command(port,(page+1) | 0xb8);		// page+1 set
	CALL SUBOPT_0x30
;    1414 		GLCD_Command(port,x_addr | 0x40);		// Y address set
;    1415 //  
;    1416 		uch = GLCD_Dread(port);				//   dummy
	CALL SUBOPT_0x2B
;    1417 		uch = GLCD_Dread(port);				//  
;    1418 		if(color == _BLACK) uch = uch & ~datau;		// NEW  & ~
	LDD  R30,Y+14
	CPI  R30,0
	BRNE _0x54
	CALL SUBOPT_0x2C
	AND  R17,R30
;    1419 		else{
	RJMP _0x55
_0x54:
;    1420 			uch = uch & ~mask_data;			//  SKIP
	CALL SUBOPT_0x2F
;    1421 			uch = uch | datau;			// NEW  OR 
;    1422 		}
_0x55:
;    1423 // DD RAM+1 ġ 
;    1424 		GLCD_Command(port,(page+1) | 0xb8);		// page+1 set
	CALL SUBOPT_0x30
;    1425 		GLCD_Command(port,x_addr | 0x40);		// Y address set
;    1426 //  
;    1427 		GLCD_Dwrite(port,uch);				//  write
	ST   -Y,R17
	RCALL _GLCD_Dwrite
;    1428 	}
;    1429 }
_0x53:
	CALL __LOADLOCR6
	ADIW R28,20
	RET
;    1430 
;    1431 // ========================= Ʈ     =========================
;    1432 // [μ] unsigned int	c
;    1433 // Item1:  
;    1434 // ------------------------------------------------------------------------------
;    1435 void _Putch(unsigned int c)
;    1436 {
__Putch:
;    1437 unsigned char *image;
;    1438 int ch,i,curx1 = _screen_curx,cury1 = _screen_cury;
;    1439 
;    1440 	if(c & 0x8000){						// ѱ ڵ Ÿ
	SBIW R28,4
	CALL __SAVELOCR6
;	c -> Y+10
;	*image -> R16,R17
;	ch -> R18,R19
;	i -> R20,R21
;	curx1 -> Y+8
;	cury1 -> Y+6
	CALL SUBOPT_0x31
	CALL SUBOPT_0x32
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R30,Y+11
	ANDI R30,LOW(0x80)
	BREQ _0x56
;    1441 		image = _GetHanImage(c);			// ѱ  
	CALL SUBOPT_0x11
	RCALL __GetHanImage
	MOVW R16,R30
;    1442 		for(i = 0; i < 16; i++){
	__GETWRN 20,21,0
_0x58:
	__CPWRN 20,21,16
	BRGE _0x59
;    1443 			ch = *image++;				// ѱ  
	CALL SUBOPT_0x33
;    1444 			Putpixelb(curx1,cury1,ch,_screen_color);
;    1445 			if(curx1 < 127) curx1++;		// Ŀ   
	BRGE _0x5A
	CALL SUBOPT_0x34
;    1446 		}
_0x5A:
	__ADDWRN 20,21,1
	RJMP _0x58
_0x59:
;    1447 		cury1 = _screen_cury+8;				// Yǥ+8
	CALL SUBOPT_0x35
;    1448 		if(cury1 < 64){
	BRGE _0x5B
;    1449 			curx1 = _screen_curx;			// Xǥ 
	CALL SUBOPT_0x31
;    1450 			for(i = 0; i < 16; i++){
	__GETWRN 20,21,0
_0x5D:
	__CPWRN 20,21,16
	BRGE _0x5E
;    1451 				ch = *image++;			// Data Read
	CALL SUBOPT_0x33
;    1452 				Putpixelb(curx1,cury1,ch,_screen_color);
;    1453 				if(curx1 < 127) curx1++;	// Ŀ   
	BRGE _0x5F
	CALL SUBOPT_0x34
;    1454 			}
_0x5F:
	__ADDWRN 20,21,1
	RJMP _0x5D
_0x5E:
;    1455 		}
;    1456 		_screen_curx += 16;				// Ŀ   
_0x5B:
	LDS  R30,__screen_curx
	LDS  R31,__screen_curx+1
	ADIW R30,16
	CALL SUBOPT_0x36
;    1457 		if(_screen_curx >= 128){
	BRLT _0x60
;    1458 			_screen_curx = 0;
	CALL SUBOPT_0x37
;    1459 			_screen_cury += 16;			// Ŀ   
	CALL SUBOPT_0x38
;    1460 			if(_screen_cury >= 64) _screen_cury = 0;
	BRLT _0x61
	CALL SUBOPT_0x39
;    1461 		}
_0x61:
;    1462 	}
_0x60:
;    1463 	else{							//  ڵ Ÿ
	RJMP _0x62
_0x56:
;    1464 		if(c == 0x0a){
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,10
	BRNE _0x63
;    1465 			_screen_cury += 16;			// Ŀ   
	CALL SUBOPT_0x38
;    1466 			if(_screen_cury >= 64) _screen_cury = 0;// Ŀ   ˻
	BRLT _0x64
	CALL SUBOPT_0x39
;    1467 		}
_0x64:
;    1468 		else if(c == 0x0d) _screen_curx = 0;		// Carrage Return
	RJMP _0x65
_0x63:
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,13
	BRNE _0x66
	CALL SUBOPT_0x37
;    1469 		else{
	RJMP _0x67
_0x66:
;    1470 			image = _GetAscImage(c);		//   
	CALL SUBOPT_0x11
	RCALL __GetAscImage
	MOVW R16,R30
;    1471 			for(i = 0; i < 8; i++){
	__GETWRN 20,21,0
_0x69:
	__CPWRN 20,21,8
	BRGE _0x6A
;    1472 				ch = *image++;			// Data Read
	CALL SUBOPT_0x33
;    1473 				Putpixelb(curx1,cury1,ch,_screen_color);
;    1474 				if(curx1 < 127) curx1++;	// Ŀ   
	BRGE _0x6B
	CALL SUBOPT_0x34
;    1475 			}
_0x6B:
	__ADDWRN 20,21,1
	RJMP _0x69
_0x6A:
;    1476 			cury1 = _screen_cury+8;			// Yǥ+8
	CALL SUBOPT_0x35
;    1477 			if(cury1 < 64){
	BRGE _0x6C
;    1478 				curx1 = _screen_curx;		// Xǥ 
	CALL SUBOPT_0x31
;    1479 				for(i = 0; i < 8; i++){
	__GETWRN 20,21,0
_0x6E:
	__CPWRN 20,21,8
	BRGE _0x6F
;    1480 					ch = *image++;		// Data Read
	CALL SUBOPT_0x33
;    1481 					Putpixelb(curx1,cury1,ch,_screen_color);
;    1482 					if(curx1 < 127) curx1++;// Ŀ   
	BRGE _0x70
	CALL SUBOPT_0x34
;    1483 				}
_0x70:
	__ADDWRN 20,21,1
	RJMP _0x6E
_0x6F:
;    1484 			}
;    1485 			_screen_curx += 8;			// Ŀ   
_0x6C:
	LDS  R30,__screen_curx
	LDS  R31,__screen_curx+1
	ADIW R30,8
	CALL SUBOPT_0x36
;    1486 			if(_screen_curx >= 128){
	BRLT _0x71
;    1487 				_screen_curx = 0;
	CALL SUBOPT_0x37
;    1488 				_screen_cury += 16;		// Ŀ   
	CALL SUBOPT_0x38
;    1489 				if(_screen_cury >= 64) _screen_cury = 0;
	BRLT _0x72
	CALL SUBOPT_0x39
;    1490 			}
_0x72:
;    1491 		}
_0x71:
_0x67:
_0x65:
;    1492 	}
_0x62:
;    1493 }
_0x15E:
	CALL __LOADLOCR6
	ADIW R28,12
	RET
;    1494 
;    1495 // ======================== ѱ Ʈ Ÿ   ======================
;    1496 //  [μ] unsigned c
;    1497 //  Item1: ȯ Ÿ
;    1498 //   : ȯ  
;    1499 // ------------------------------------------------------------------------------
;    1500 void *_GetHanImage(unsigned c)
;    1501 {
__GetHanImage:
;    1502 unsigned h, h1, h2, h3, type1, type2, type3, pos;
;    1503 
;    1504 	static char idxtbl1[] = {				// ʼ ε ̺

	.DSEG
_idxtbl1_S1A:
;    1505 		 0,  0,  1,  2,  3,  4,  5,  6,
;    1506 		 7,  8,  9, 10, 11, 12, 13, 14,
;    1507 		15, 16, 17, 18, 19,  0,  0,  0,
;    1508 		 0,  0,  0,  0,  0,  0,  0,  0
;    1509 	};
	.BYTE 0x20

	.CSEG
;    1510 	static char idxtbl2[] = {				// ߼ ε ̺

	.DSEG
_idxtbl2_S1A:
;    1511 		 0,  0,  0,  1,  2,  3,  4,  5,
;    1512 		 0,  0,  6,  7,  8,  9, 10, 11,
;    1513 		 0,  0, 12, 13, 14, 15, 16, 17,
;    1514 		 0,  0, 18, 19, 20, 21,  0,  0
;    1515 	};
	.BYTE 0x20

	.CSEG
;    1516 	static char idxtbl3[] = {				//  ε ̺

	.DSEG
_idxtbl3_S1A:
;    1517 		 0,  0,  1,  2,  3,  4,  5,  6,
;    1518 		 7,  8,  9, 10, 11, 12, 13, 14,
;    1519 		15, 16,  0, 17, 18, 19, 20, 21,
;    1520 		22, 23, 24, 25, 26, 27,  0,  0
;    1521     };
	.BYTE 0x20

	.CSEG
;    1522 	static char type1tbl_no[]  = {				// ߼  ʼ /ħ 

	.DSEG
_type1tbl_no_S1A:
;    1523 		0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 3,
;    1524 		3, 3, 1, 2, 4, 4, 4, 2, 1, 3, 0
;    1525 	};
	.BYTE 0x16

	.CSEG
;    1526 	static char type1tbl_yes[] = {				// ߼  ʼ /ħ 

	.DSEG
_type1tbl_yes_S1A:
;    1527 		5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 7,
;    1528 		7, 7, 6, 6, 7, 7, 7, 6, 6, 7, 5
;    1529 	};
	.BYTE 0x16

	.CSEG
;    1530 	static char type3tbl[] = {				// ߼   

	.DSEG
_type3tbl_S1A:
;    1531 		0, 0, 2, 0, 2, 1, 2, 1, 2, 3, 0,
;    1532 		2, 1, 3, 3, 1, 2, 1, 3, 3, 1, 1
;    1533 	};
	.BYTE 0x16

	.CSEG
;    1534 
;    1535 	h1 = (c >> 10) & 0x1F;					// ʼ ڵ
	SBIW R28,10
	CALL __SAVELOCR6
;	c -> Y+16
;	h -> R16,R17
;	h1 -> R18,R19
;	h2 -> R20,R21
;	h3 -> Y+14
;	type1 -> Y+12
;	type2 -> Y+10
;	type3 -> Y+8
;	pos -> Y+6
	LDD  R30,Y+17
	LSR  R30
	LSR  R30
	ANDI R30,LOW(0x1F)
	ANDI R31,HIGH(0x1F)
	MOVW R18,R30
;    1536 	h2 = (c >> 5)  & 0x1F;					// ߼ ڵ
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	LDI  R30,LOW(5)
	CALL __LSRW12
	ANDI R30,LOW(0x1F)
	ANDI R31,HIGH(0x1F)
	MOVW R20,R30
;    1537 	h3 = c	       & 0x1F;					//  ڵ
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ANDI R30,LOW(0x1F)
	ANDI R31,HIGH(0x1F)
	STD  Y+14,R30
	STD  Y+14+1,R31
;    1538 
;    1539 	h1 = idxtbl1[h1];					// ʼ ε ڵ
	LDI  R26,LOW(_idxtbl1_S1A)
	LDI  R27,HIGH(_idxtbl1_S1A)
	ADD  R26,R18
	ADC  R27,R19
	LD   R18,X
	CLR  R19
;    1540 	h2 = idxtbl2[h2];					// ߼ ε ڵ
	LDI  R26,LOW(_idxtbl2_S1A)
	LDI  R27,HIGH(_idxtbl2_S1A)
	ADD  R26,R20
	ADC  R27,R21
	LD   R20,X
	CLR  R21
;    1541 	h3 = idxtbl3[h3];					//  ε ڵ
	SUBI R30,LOW(-_idxtbl3_S1A)
	SBCI R31,HIGH(-_idxtbl3_S1A)
	LD   R30,Z
	LDI  R31,0
	STD  Y+14,R30
	STD  Y+14+1,R31
;    1542 
;    1543 	type1 = h3 ? type1tbl_yes[h2] : type1tbl_no[h2];
	SBIW R30,0
	BREQ _0x79
	LDI  R26,LOW(_type1tbl_yes_S1A)
	LDI  R27,HIGH(_type1tbl_yes_S1A)
	RJMP _0x164
_0x79:
	LDI  R26,LOW(_type1tbl_no_S1A)
	LDI  R27,HIGH(_type1tbl_no_S1A)
_0x164:
	ADD  R26,R20
	ADC  R27,R21
	LD   R30,X
	LDI  R31,0
	STD  Y+12,R30
	STD  Y+12+1,R31
;    1544 	type2 = ((h1 == 0 || h1 == 1 || h1 == 16) ? 0 : 1) + (h3 ? 2 : 0);
	CLR  R0
	CP   R0,R18
	CPC  R0,R19
	BREQ _0x7C
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R18
	CPC  R31,R19
	BREQ _0x7C
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CP   R30,R18
	CPC  R31,R19
	BRNE _0x7E
_0x7C:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RJMP _0x7F
_0x7E:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
_0x7F:
	MOVW R26,R30
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SBIW R30,0
	BREQ _0x81
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	RJMP _0x82
_0x81:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
_0x82:
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
;    1545 	type3 = type3tbl[h2];
	LDI  R26,LOW(_type3tbl_S1A)
	LDI  R27,HIGH(_type3tbl_S1A)
	ADD  R26,R20
	ADC  R27,R21
	LD   R30,X
	LDI  R31,0
	STD  Y+8,R30
	STD  Y+8+1,R31
;    1546 
;    1547 	if(h1){
	MOV  R0,R18
	OR   R0,R19
	BREQ _0x84
;    1548 		h = h1-1;					// ʼ[8][19][32] -> ʼ[152][32]
	MOVW R30,R18
	SBIW R30,1
	CALL SUBOPT_0x3A
;    1549 		pos = type1*19;
	LDI  R30,LOW(19)
	CALL SUBOPT_0x3B
;    1550 		memcpyf(ib, HanFont1[pos+h], 32);
	CALL SUBOPT_0x3C
	SUBI R30,LOW(-_HanFont1*2)
	SBCI R31,HIGH(-_HanFont1*2)
	SBCI R22,BYTE3(-_HanFont1*2)
	CALL SUBOPT_0x3D
	CALL _memcpyf
;    1551 	}
;    1552 	else memset(ib, 0, 32);
	RJMP _0x85
_0x84:
	LDI  R30,LOW(_ib_G1)
	LDI  R31,HIGH(_ib_G1)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL SUBOPT_0x3E
	CALL _memset
;    1553 	if(h2){
_0x85:
	MOV  R0,R20
	OR   R0,R21
	BREQ _0x86
;    1554 		h = h2-1;
	MOVW R30,R20
	SBIW R30,1
	MOVW R16,R30
;    1555 		pos = type2*21;
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	LDI  R30,LOW(21)
	CALL SUBOPT_0x3B
;    1556 		_memor(ib, HanFont2[pos+h], 32);		// ߼[4][21][32] -> ߼[84][32]
	CALL SUBOPT_0x3C
	SUBI R30,LOW(-_HanFont2*2)
	SBCI R31,HIGH(-_HanFont2*2)
	SBCI R22,BYTE3(-_HanFont2*2)
	CALL SUBOPT_0x3D
	RCALL __memor
;    1557 	}
;    1558 	if(h3){
_0x86:
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	SBIW R30,0
	BREQ _0x87
;    1559 		h = h3-1;
	SBIW R30,1
	MOVW R16,R30
;    1560 		pos = type3*27;
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(27)
	CALL SUBOPT_0x3B
;    1561 		_memor(ib, HanFont3[pos+h], 32);		// [4][27][32] -> [108][32]
	CALL SUBOPT_0x3C
	SUBI R30,LOW(-_HanFont3*2)
	SBCI R31,HIGH(-_HanFont3*2)
	SBCI R22,BYTE3(-_HanFont3*2)
	CALL SUBOPT_0x3D
	RCALL __memor
;    1562 	}
;    1563 	return ib;
_0x87:
	LDI  R30,LOW(_ib_G1)
	LDI  R31,HIGH(_ib_G1)
	CALL __LOADLOCR6
	ADIW R28,18
	RET
;    1564 }
;    1565 
;    1566 // ======================  ѱ Ʈ Ѵ. ==========================
;    1567 //  [μ] unsigned char *s1
;    1568 //	   unsigned char flash *s2
;    1569 //	   int	len
;    1570 //  Item1:  
;    1571 //  Item2: ε 
;    1572 //  Item3: 
;    1573 // ------------------------------------------------------------------------------
;    1574 void _memor(unsigned char *s1,unsigned char flash *s2, int len)
;    1575 {
__memor:
;    1576 	do{
;	*s1 -> Y+6
;	*s2 -> Y+2
;	len -> Y+0
_0x89:
;    1577 		*s1++ |= *s2++;
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	MOVW R0,R30
	LD   R30,Z
	MOV  R26,R30
	__GETD1S 2
	CALL SUBOPT_0x3F
	__PUTD1S 2
	CALL SUBOPT_0x40
	OR   R30,R26
	MOVW R26,R0
	ST   X,R30
;    1578 	}while (--len);
	LD   R30,Y
	LDD  R31,Y+1
	SBIW R30,1
	ST   Y,R30
	STD  Y+1,R31
	BRNE _0x89
;    1579 }
_0x15D:
	ADIW R28,8
	RET
;    1580 
;    1581 // =======================  Ʈ  ε ===============================
;    1582 //  [μ] char c
;    1583 //  Item1: ȯ Ÿ
;    1584 //   : ȯ  
;    1585 // -----------------------------------------------------------------------------
;    1586 unsigned char* _GetAscImage(int c)
;    1587 {
__GetAscImage:
;    1588 int i;
;    1589 
;    1590         for(i = 0; i < 16; i++) ascii_fbuf[i] = AscFont16[c][i];
	ST   -Y,R17
	ST   -Y,R16
;	c -> Y+2
;	i -> R16,R17
	__GETWRN 16,17,0
_0x8C:
	__CPWRN 16,17,16
	BRGE _0x8D
	MOVW R30,R16
	SUBI R30,LOW(-_ascii_fbuf_G1)
	SBCI R31,HIGH(-_ascii_fbuf_G1)
	PUSH R31
	PUSH R30
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	CLR  R22
	CLR  R23
	__GETD2N 0x10
	CALL __MULD12U
	SUBI R30,LOW(-_AscFont16*2)
	SBCI R31,HIGH(-_AscFont16*2)
	SBCI R22,BYTE3(-_AscFont16*2)
	MOVW R26,R30
	MOVW R24,R22
	MOVW R30,R16
	CALL SUBOPT_0x41
	__GETBRPF 30
	POP  R26
	POP  R27
	ST   X,R30
;    1591 	return ascii_fbuf;
	__ADDWRN 16,17,1
	RJMP _0x8C
_0x8D:
	LDI  R30,LOW(_ascii_fbuf_G1)
	LDI  R31,HIGH(_ascii_fbuf_G1)
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x15B
;    1592 }
;    1593 
;    1594 // ===================== ϼ ڵ带  ȯ.=========================
;    1595 // [μ] char *buf
;    1596 // Item1: ȯ ڿ 
;    1597 //  : ȯ   -> han_conv_buf[101]
;    1598 // -----------------------------------------------------------------------------
;    1599 void Han_Conv(char *buf)
;    1600 {
_Han_Conv:
;    1601 unsigned char temp[2];
;    1602 int  i,j,len;
;    1603 unsigned lpos,code;
;    1604 
;    1605 	len = strlen(buf);
	SBIW R28,6
	CALL __SAVELOCR6
;	*buf -> Y+12
;	temp -> Y+10
;	i -> R16,R17
;	j -> R18,R19
;	len -> R20,R21
;	lpos -> Y+8
;	code -> Y+6
	CALL SUBOPT_0xC
	CALL _strlen
	CALL SUBOPT_0x42
;    1606 	for(i = j = 0; i < len; i++){
_0x8F:
	__CPWRR 16,17,20,21
	BRLT PC+3
	JMP _0x90
;    1607 		temp[0] = buf[i];
	MOVW R30,R16
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	STD  Y+10,R30
;    1608 		if(temp[0] >= 0xb0 && temp[0] <= 0xc8){
	LDD  R26,Y+10
	CPI  R26,LOW(0xB0)
	BRLO _0x92
	CPI  R26,LOW(0xC9)
	BRLO _0x93
_0x92:
	RJMP _0x91
_0x93:
;    1609 			temp[1] = buf[++i];
	CALL SUBOPT_0x43
	CALL SUBOPT_0x44
;    1610 			if(temp[1] >= 0xa1 && temp[1] <= 0xfe){
	LDD  R26,Y+11
	CPI  R26,LOW(0xA1)
	BRLO _0x95
	CPI  R26,LOW(0xFF)
	BRLO _0x96
_0x95:
	RJMP _0x94
_0x96:
;    1611 				lpos = (unsigned)(((unsigned)temp[0]-0xb0)*94 + ((unsigned)temp[1]-0xa1));
	CALL SUBOPT_0x45
;    1612 				code = Conv_Tbl[lpos];		// Data Read
;    1613 				han_conv_buf[j++] = (char)(code >> 8);
;    1614 				han_conv_buf[j++] = (char)(code & 0xff);
;    1615 			}
;    1616 		}
_0x94:
;    1617 		else if(temp[0] == 0xa3){
	RJMP _0x97
_0x91:
	LDD  R26,Y+10
	CPI  R26,LOW(0xA3)
	BRNE _0x98
;    1618 			temp[1] = buf[++i];
	CALL SUBOPT_0x43
	CALL SUBOPT_0x44
;    1619 			han_conv_buf[j++] = 0xda;
	CALL SUBOPT_0x46
	LDI  R26,LOW(218)
	STD  Z+0,R26
;    1620 			if(temp[1] >= 0xa1 && temp[1] <= 0xbf) han_conv_buf[j++] = temp[1] - 0x70;
	LDD  R26,Y+11
	CPI  R26,LOW(0xA1)
	BRLO _0x9A
	CPI  R26,LOW(0xC0)
	BRLO _0x9B
_0x9A:
	RJMP _0x99
_0x9B:
	CALL SUBOPT_0x46
	MOVW R26,R30
	LDD  R30,Y+11
	SUBI R30,LOW(112)
	RJMP _0x165
;    1621 			else if(temp[1] >= 0xc0 && temp[1] <= 0xdf) han_conv_buf[j++] = temp[1] - 0x70;
_0x99:
	LDD  R26,Y+11
	CPI  R26,LOW(0xC0)
	BRLO _0x9E
	CPI  R26,LOW(0xE0)
	BRLO _0x9F
_0x9E:
	RJMP _0x9D
_0x9F:
	CALL SUBOPT_0x46
	MOVW R26,R30
	LDD  R30,Y+11
	SUBI R30,LOW(112)
	RJMP _0x165
;    1622 			else if(temp[1] >= 0xe0 && temp[1] <= 0xee) han_conv_buf[j++] = temp[1] - 0x70;
_0x9D:
	LDD  R26,Y+11
	CPI  R26,LOW(0xE0)
	BRLO _0xA2
	CPI  R26,LOW(0xEF)
	BRLO _0xA3
_0xA2:
	RJMP _0xA1
_0xA3:
	CALL SUBOPT_0x46
	MOVW R26,R30
	LDD  R30,Y+11
	SUBI R30,LOW(112)
	RJMP _0x165
;    1623 			else if(temp[1] >= 0xef && temp[1] <= 0xfd) han_conv_buf[j++] = temp[1] - 0x5e;
_0xA1:
	LDD  R26,Y+11
	CPI  R26,LOW(0xEF)
	BRLO _0xA6
	CPI  R26,LOW(0xFE)
	BRLO _0xA7
_0xA6:
	RJMP _0xA5
_0xA7:
	CALL SUBOPT_0x46
	MOVW R26,R30
	LDD  R30,Y+11
	SUBI R30,LOW(94)
_0x165:
	ST   X,R30
;    1624 		}
_0xA5:
;    1625 		else if(temp[0] == 0xa1){
	RJMP _0xA8
_0x98:
	LDD  R26,Y+10
	CPI  R26,LOW(0xA1)
	BRNE _0xA9
;    1626 			temp[1] = buf[++i];
	CALL SUBOPT_0x43
	CALL SUBOPT_0x44
;    1627 			if(temp[1] == 0xa1){
	LDD  R26,Y+11
	CPI  R26,LOW(0xA1)
	BRNE _0xAA
;    1628 				han_conv_buf[j++] = 0xd9;
	CALL SUBOPT_0x46
	LDI  R26,LOW(217)
	STD  Z+0,R26
;    1629 				han_conv_buf[j++] = 0x31;
	CALL SUBOPT_0x46
	LDI  R26,LOW(49)
	RJMP _0x166
;    1630 			}
;    1631 			else{
_0xAA:
;    1632 				han_conv_buf[j++] = temp[0];
	CALL SUBOPT_0x46
	LDD  R26,Y+10
	STD  Z+0,R26
;    1633 				han_conv_buf[j++] = temp[1];
	CALL SUBOPT_0x46
	LDD  R26,Y+11
_0x166:
	STD  Z+0,R26
;    1634 			}
;    1635 		}
;    1636 		else han_conv_buf[j++] = temp[0];
	RJMP _0xAC
_0xA9:
	CALL SUBOPT_0x46
	LDD  R26,Y+10
	STD  Z+0,R26
;    1637 	}
_0xAC:
_0xA8:
_0x97:
	__ADDWRN 16,17,1
	RJMP _0x8F
_0x90:
;    1638 	han_conv_buf[j] = 0;					// ڿ  ǥ
	CALL SUBOPT_0x47
;    1639 }
	ADIW R28,14
	RET
;    1640 
;    1641 // =============== ϼ(FLASH) ڵ带 (SRAM) ȯ.==================
;    1642 // [μ] char flash *buf
;    1643 // Item1: ȯ ڿ  FLASH
;    1644 //  : ȯ   -> han_conv_buf[101]
;    1645 // -----------------------------------------------------------------------------
;    1646 void Han_Conv_f(char flash *buf)
;    1647 {
_Han_Conv_f:
;    1648 unsigned char temp[2];
;    1649 int  i,j,len;
;    1650 unsigned lpos,code;
;    1651 
;    1652 	len = strlenf(buf);
	SBIW R28,6
	CALL __SAVELOCR6
;	*buf -> Y+12
;	temp -> Y+10
;	i -> R16,R17
;	j -> R18,R19
;	len -> R20,R21
;	lpos -> Y+8
;	code -> Y+6
	__GETD1S 12
	CALL __PUTPARD1
	CALL _strlenf
	CALL SUBOPT_0x42
;    1653 	for(i = j = 0; i < len; i++){
_0xAE:
	__CPWRR 16,17,20,21
	BRLT PC+3
	JMP _0xAF
;    1654 		temp[0] = buf[i];
	MOVW R30,R16
	CALL SUBOPT_0x48
	__GETBRPF 0
	STD  Y+10,R0
;    1655 		if(temp[0] >= 0xb0 && temp[0] <= 0xc8){
	LDD  R26,Y+10
	CPI  R26,LOW(0xB0)
	BRLO _0xB1
	CPI  R26,LOW(0xC9)
	BRLO _0xB2
_0xB1:
	RJMP _0xB0
_0xB2:
;    1656 			temp[1] = buf[++i];
	CALL SUBOPT_0x49
	__GETBRPF 0
	STD  Y+11,R0
;    1657 			if(temp[1] >= 0xa1 && temp[1] <= 0xfe){
	LDD  R26,Y+11
	CPI  R26,LOW(0xA1)
	BRLO _0xB4
	CPI  R26,LOW(0xFF)
	BRLO _0xB5
_0xB4:
	RJMP _0xB3
_0xB5:
;    1658 				lpos = (unsigned)(((unsigned)temp[0]-0xb0)*94 + ((unsigned)temp[1]-0xa1));
	CALL SUBOPT_0x45
;    1659 				code = Conv_Tbl[lpos];		// Data Read
;    1660 				han_conv_buf[j++] = (char)(code >> 8);
;    1661 				han_conv_buf[j++] = (char)(code & 0xff);
;    1662 			}
;    1663 		}
_0xB3:
;    1664 		else if(temp[0] == 0xa3){
	RJMP _0xB6
_0xB0:
	LDD  R26,Y+10
	CPI  R26,LOW(0xA3)
	BRNE _0xB7
;    1665 			temp[1] = buf[++i];
	CALL SUBOPT_0x49
	__GETBRPF 0
	STD  Y+11,R0
;    1666 			han_conv_buf[j++] = 0xda;
	CALL SUBOPT_0x46
	LDI  R26,LOW(218)
	STD  Z+0,R26
;    1667 			if(temp[1] >= 0xa1 && temp[1] <= 0xbf) han_conv_buf[j++] = temp[1] - 0x70;
	LDD  R26,Y+11
	CPI  R26,LOW(0xA1)
	BRLO _0xB9
	CPI  R26,LOW(0xC0)
	BRLO _0xBA
_0xB9:
	RJMP _0xB8
_0xBA:
	CALL SUBOPT_0x46
	MOVW R26,R30
	LDD  R30,Y+11
	SUBI R30,LOW(112)
	RJMP _0x167
;    1668 			else if(temp[1] >= 0xc0 && temp[1] <= 0xdf) han_conv_buf[j++] = temp[1] - 0x70;
_0xB8:
	LDD  R26,Y+11
	CPI  R26,LOW(0xC0)
	BRLO _0xBD
	CPI  R26,LOW(0xE0)
	BRLO _0xBE
_0xBD:
	RJMP _0xBC
_0xBE:
	CALL SUBOPT_0x46
	MOVW R26,R30
	LDD  R30,Y+11
	SUBI R30,LOW(112)
	RJMP _0x167
;    1669 			else if(temp[1] >= 0xe0 && temp[1] <= 0xee) han_conv_buf[j++] = temp[1] - 0x70;
_0xBC:
	LDD  R26,Y+11
	CPI  R26,LOW(0xE0)
	BRLO _0xC1
	CPI  R26,LOW(0xEF)
	BRLO _0xC2
_0xC1:
	RJMP _0xC0
_0xC2:
	CALL SUBOPT_0x46
	MOVW R26,R30
	LDD  R30,Y+11
	SUBI R30,LOW(112)
	RJMP _0x167
;    1670 			else if(temp[1] >= 0xef && temp[1] <= 0xfd) han_conv_buf[j++] = temp[1] - 0x5e;
_0xC0:
	LDD  R26,Y+11
	CPI  R26,LOW(0xEF)
	BRLO _0xC5
	CPI  R26,LOW(0xFE)
	BRLO _0xC6
_0xC5:
	RJMP _0xC4
_0xC6:
	CALL SUBOPT_0x46
	MOVW R26,R30
	LDD  R30,Y+11
	SUBI R30,LOW(94)
_0x167:
	ST   X,R30
;    1671 		}
_0xC4:
;    1672 		else if(temp[0] == 0xa1){
	RJMP _0xC7
_0xB7:
	LDD  R26,Y+10
	CPI  R26,LOW(0xA1)
	BRNE _0xC8
;    1673 			temp[1] = buf[++i];
	CALL SUBOPT_0x49
	__GETBRPF 0
	STD  Y+11,R0
;    1674 			if(temp[1] == 0xa1){
	LDD  R26,Y+11
	CPI  R26,LOW(0xA1)
	BRNE _0xC9
;    1675 				han_conv_buf[j++] = 0xd9;
	CALL SUBOPT_0x46
	LDI  R26,LOW(217)
	STD  Z+0,R26
;    1676 				han_conv_buf[j++] = 0x31;
	CALL SUBOPT_0x46
	LDI  R26,LOW(49)
	RJMP _0x168
;    1677 			}
;    1678 			else{
_0xC9:
;    1679 				han_conv_buf[j++] = temp[0];
	CALL SUBOPT_0x46
	LDD  R26,Y+10
	STD  Z+0,R26
;    1680 				han_conv_buf[j++] = temp[1];
	CALL SUBOPT_0x46
	LDD  R26,Y+11
_0x168:
	STD  Z+0,R26
;    1681 			}
;    1682 		}
;    1683 		else han_conv_buf[j++] = temp[0];
	RJMP _0xCB
_0xC8:
	CALL SUBOPT_0x46
	LDD  R26,Y+10
	STD  Z+0,R26
;    1684 	}
_0xCB:
_0xC7:
_0xB6:
	__ADDWRN 16,17,1
	RJMP _0xAE
_0xAF:
;    1685 	han_conv_buf[j] = 0;					// ڿ  ǥ
	CALL SUBOPT_0x47
;    1686 }
	ADIW R28,16
	RET
;    1687 
;    1688 // ============================ ׷ LCD ʱȭ ==============================
;    1689 // [μ] void
;    1690 // [] 128*64
;    1691 // -----------------------------------------------------------------------------
;    1692 void Lcd_Init(void)
;    1693 {
_Lcd_Init:
;    1694 // ׷ LCD 
;    1695 	PORTE &= 0xdf;						// PORTE.5(RST\) = 0
	CBI  0x3,5
;    1696 	delay_ms(200);						// reset ð 
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;    1697 	PORTE |= 0x20;						// PORTE.5(RST\) = 1
	SBI  0x3,5
;    1698 
;    1699 	GLCD_Command(LCD_CS_ALL,0x3f);				// ȭ ǥ ON
	CALL SUBOPT_0x0
	LDI  R30,LOW(63)
	ST   -Y,R30
	RCALL _GLCD_Command
;    1700 	GLCD_Command(LCD_CS_ALL,0xc0);				// DISPLAY START LINE 0
	CALL SUBOPT_0x0
	LDI  R30,LOW(192)
	ST   -Y,R30
	RCALL _GLCD_Command
;    1701 
;    1702 	Cleardevice();						// LCD Clear
	CALL _Cleardevice
;    1703 }
	RET
;    1704 
;    1705 // =================================== BUSY Check ============================
;    1706 // [μ] int port
;    1707 // Item1: LCD CS(CS1,CS2,ALL)
;    1708 // ---------------------------------------------------------------------------
;    1709 void GLCD_Busy(int port)
;    1710 {
_GLCD_Busy:
;    1711 unsigned char i,ch;
;    1712 
;    1713 	ch = GLCD_CMD_RD[port] & 0x80;				// BUSY Check :: D7(1:busy,0:ready)
	ST   -Y,R17
	ST   -Y,R16
;	port -> Y+2
;	i -> R17
;	ch -> R16
	CALL SUBOPT_0x4A
;    1714 	while(ch == 0x80){
_0xCC:
	CPI  R16,128
	BRNE _0xCE
;    1715 		ch = GLCD_CMD_RD[port] & 0x80;
	CALL SUBOPT_0x4A
;    1716 		for(i = 0; i < 2; i++);
	LDI  R17,LOW(0)
_0xD0:
	CPI  R17,2
	BRSH _0xD1
	SUBI R17,-1
	RJMP _0xD0
_0xD1:
;    1717 	}
	RJMP _0xCC
_0xCE:
;    1718 }
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x15B
;    1719 
;    1720 // ============================== COMMAND  write =======================
;    1721 // [μ] int port,unsigned char uch
;    1722 // Item1: LCD CS(CS1,CS2,ALL)
;    1723 // Item2: 
;    1724 // ---------------------------------------------------------------------------
;    1725 void GLCD_Command(int port,unsigned char uch)
;    1726 {
_GLCD_Command:
;    1727 	GLCD_Busy(port);					// BUSY Check
;	port -> Y+1
;	uch -> Y+0
	CALL SUBOPT_0x4B
;    1728 	GLCD_CMD_WR[port] = uch;				//   write
	ADD  R30,R12
	ADC  R31,R13
	LD   R26,Y
	STD  Z+0,R26
;    1729 }
	RJMP _0x15C
;    1730 
;    1731 // ===================================  write ==========================
;    1732 // [μ] int port,unsigned char uch
;    1733 // Item1: LCD CS(CS1,CS2,ALL)
;    1734 // Item2: 
;    1735 // ---------------------------------------------------------------------------
;    1736 void GLCD_Dwrite(int port,unsigned char uch)
;    1737 {
_GLCD_Dwrite:
;    1738 	GLCD_Busy(port);					// BUSY Check
;	port -> Y+1
;	uch -> Y+0
	CALL SUBOPT_0x4B
;    1739 	GLCD_DATA_WR[port] = uch;				//  write
	ADD  R30,R8
	ADC  R31,R9
	LD   R26,Y
	STD  Z+0,R26
;    1740 }
_0x15C:
	ADIW R28,3
	RET
;    1741 
;    1742 // ===================================  read ===========================
;    1743 // [μ] int port
;    1744 // Item1: LCD CS(CS1,CS2,ALL)
;    1745 // [] (0-0xff)
;    1746 // ---------------------------------------------------------------------------
;    1747 unsigned char GLCD_Dread(int port)
;    1748 {
_GLCD_Dread:
;    1749 	GLCD_Busy(port);					// BUSY Check
;	port -> Y+0
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _GLCD_Busy
;    1750 	return(GLCD_DATA_RD[port]);				//  read
	LD   R30,Y
	LDD  R31,Y+1
	ADD  R30,R6
	ADC  R31,R7
	LD   R30,Z
	ADIW R28,2
	RET
;    1751 }
;    1752 
;    1753 // Լ 
;    1754 void main_menu_disp(void);						//  ޴ ǥ
;    1755 
;    1756 //  
;    1757 
;    1758 // ===============================  α׷ ==============================
;    1759 // [μ]: void
;    1760 // ---------------------------------------------------------------------------
;    1761 int main(void)
;    1762 {
_main:
;    1763 char buf[50];
;    1764 
;    1765 	cpu_setup();							// cpu ʱȭ
	SBIW R28,50
;	buf -> Y+0
	CALL _cpu_setup
;    1766 	Lcd_Init();							// LCD ʱȭ
	CALL _Lcd_Init
;    1767 	main_menu_disp();						//  ޴ ǥ
	RCALL _main_menu_disp
;    1768 	Putsxyt_f(1,1,"ϼ ѱ TEST");				// ׷ ǥ ڿ ǥ
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4C
	__POINTD1FN _0,0
	CALL SUBOPT_0x4D
;    1769 	Putsxyt_f(1,2,"www.cpuplaza.com");				// ׷ ǥ ڿ ǥ
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x4E
	__POINTD1FN _0,17
	CALL SUBOPT_0x4D
;    1770 	while(1){
_0xD2:
;    1771 		if(com1_rx_eflg){					// COM1  ˻
	TST  R4
	BRNE PC+3
	JMP _0xD5
;    1772 			if(com1_rx_data == '1') Clrscr();		// ȭ 
	LDI  R30,LOW(49)
	CP   R30,R5
	BRNE _0xD6
	CALL _Clrscr
;    1773 			else if(com1_rx_data == '2') Cleardevice();	// ȭ 
	RJMP _0xD7
_0xD6:
	LDI  R30,LOW(50)
	CP   R30,R5
	BRNE _0xD8
	CALL _Cleardevice
;    1774 			else if(com1_rx_data == '3') Putpixel(0,0,_WHITE);// ȼ ǥ
	RJMP _0xD9
_0xD8:
	LDI  R30,LOW(51)
	CP   R30,R5
	BRNE _0xDA
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x4F
	LDI  R30,LOW(15)
	ST   -Y,R30
	CALL _Putpixel
;    1775 			else if(com1_rx_data == '4') Putpixelb(0,1,0xff,_WHITE);// Ʈ  ǥ()
	RJMP _0xDB
_0xDA:
	LDI  R30,LOW(52)
	CP   R30,R5
	BRNE _0xDC
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x4C
	LDI  R30,LOW(255)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	CALL _Putpixelb
;    1776 			else if(com1_rx_data == '5') Putch('1');	// 1 ǥ
	RJMP _0xDD
_0xDC:
	LDI  R30,LOW(53)
	CP   R30,R5
	BRNE _0xDE
	LDI  R30,LOW(49)
	LDI  R31,HIGH(49)
	ST   -Y,R31
	ST   -Y,R30
	CALL _Putch
;    1777 			else if(com1_rx_data == '6') Putchxy(16,2,'2');	// ׷ ǥ 1 ǥ
	RJMP _0xDF
_0xDE:
	LDI  R30,LOW(54)
	CP   R30,R5
	BRNE _0xE0
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x4E
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	CALL _Putchxy
;    1778 			else if(com1_rx_data == '7') Putchxyt(8,3,'3');	// ؽƮ ǥ 1 ǥ
	RJMP _0xE1
_0xE0:
	LDI  R30,LOW(55)
	CP   R30,R5
	BRNE _0xE2
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	CALL SUBOPT_0x50
	LDI  R30,LOW(51)
	LDI  R31,HIGH(51)
	ST   -Y,R31
	ST   -Y,R30
	CALL _Putchxyt
;    1779 			else if(com1_rx_data == '8'){
	RJMP _0xE3
_0xE2:
	LDI  R30,LOW(56)
	CP   R30,R5
	BRNE _0xE4
;    1780 				sprintf(buf,"");			// ѱ ڿ
	CALL SUBOPT_0x51
	__POINTD1FN _0,34
	CALL SUBOPT_0x52
;    1781 				Puts(buf);				// ڿ ǥ
	CALL SUBOPT_0x51
	CALL _Puts
;    1782 				Puts_f("");				// CODE ڿ ǥ
	__POINTD1FN _0,34
	CALL __PUTPARD1
	CALL _Puts_f
;    1783 			}
;    1784 			else if(com1_rx_data == '9'){
	RJMP _0xE5
_0xE4:
	LDI  R30,LOW(57)
	CP   R30,R5
	BRNE _0xE6
;    1785 				sprintf(buf,"׽Ʈ1");
	CALL SUBOPT_0x51
	__POINTD1FN _0,37
	CALL SUBOPT_0x52
;    1786 				Putsxy(10,3,buf);			// ׷ ǥ ڿ ǥ
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL SUBOPT_0x50
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	CALL _Putsxy
;    1787 				Putsxy_f(10,20,"׽Ʈ1");		// ׷ ǥ CODE ڿ ǥ
	CALL SUBOPT_0x53
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	__POINTD1FN _0,37
	CALL __PUTPARD1
	CALL _Putsxy_f
;    1788 			}
;    1789 			else if(com1_rx_data == 'a'){
	RJMP _0xE7
_0xE6:
	LDI  R30,LOW(97)
	CP   R30,R5
	BRNE _0xE8
;    1790 				sprintf(buf,"׽Ʈ2");
	CALL SUBOPT_0x51
	__POINTD1FN _0,45
	CALL SUBOPT_0x52
;    1791 				Putsxyt(4,2,buf);			// ؽƮ ǥ ڿ ǥ
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x4E
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	CALL _Putsxyt
;    1792 				Putsxyt_f(4,3,"׽Ʈ2");		// ؽƮ ǥ ڿ ǥ
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CALL SUBOPT_0x50
	__POINTD1FN _0,45
	CALL SUBOPT_0x4D
;    1793 			}
;    1794 			else if(com1_rx_data == 'b'){			//  پϰ ׸
	RJMP _0xE9
_0xE8:
	LDI  R30,LOW(98)
	CP   R30,R5
	BRNE _0xEA
;    1795 				Line(0,0,127,0);			// 簢 ڽ
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x54
	CALL _Line
;    1796 				Line(127,0,127,63);
	CALL SUBOPT_0x54
	CALL SUBOPT_0x55
	CALL _Line
;    1797 				Line(127,63,0,63);
	CALL SUBOPT_0x55
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x56
;    1798 				Line(0,0,0,63);
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x56
;    1799 
;    1800 				Line(0,32,127,32);			// +
	CALL SUBOPT_0x3E
	LDI  R30,LOW(127)
	LDI  R31,HIGH(127)
	CALL SUBOPT_0x57
	CALL _Line
;    1801 				Line(64,0,64,63);
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	CALL SUBOPT_0x58
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x56
;    1802 
;    1803 				Line(0,0,127,63);			// 밢
	CALL SUBOPT_0x4F
	CALL SUBOPT_0x55
	CALL _Line
;    1804 				Line(0,63,127,0);
	CALL SUBOPT_0x4F
	LDI  R30,LOW(63)
	LDI  R31,HIGH(63)
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x54
	CALL _Line
;    1805 			}
;    1806 			else if(com1_rx_data == 'c') Rectangle(10,10,118,54);// 簢ڽ ׸
	RJMP _0xEB
_0xEA:
	LDI  R30,LOW(99)
	CP   R30,R5
	BRNE _0xEC
	CALL SUBOPT_0x53
	CALL SUBOPT_0x53
	CALL SUBOPT_0x59
	CALL _Rectangle
;    1807 			else if(com1_rx_data == 'd') Rectanglefill(10,10,118,54);// ä 簢ڽ ׸
	RJMP _0xED
_0xEC:
	LDI  R30,LOW(100)
	CP   R30,R5
	BRNE _0xEE
	CALL SUBOPT_0x53
	CALL SUBOPT_0x53
	CALL SUBOPT_0x59
	CALL _Rectanglefill
;    1808 			else if(com1_rx_data == 'e') Circle(64,32,10);	//  ׸
	RJMP _0xEF
_0xEE:
	LDI  R30,LOW(101)
	CP   R30,R5
	BRNE _0xF0
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	CALL SUBOPT_0x57
	CALL SUBOPT_0x53
	CALL _Circle
;    1809 			else if(com1_rx_data == 'f') Ellipse(64,32,20,10);// Ÿ ׸
	RJMP _0xF1
_0xF0:
	LDI  R30,LOW(102)
	CP   R30,R5
	BRNE _0xF2
	LDI  R30,LOW(64)
	LDI  R31,HIGH(64)
	CALL SUBOPT_0x57
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x53
	CALL _Ellipse
;    1810 			else if(com1_rx_data == 'g') Setcolor(_WHITE);	//   WHITE
	RJMP _0xF3
_0xF2:
	LDI  R30,LOW(103)
	CP   R30,R5
	BRNE _0xF4
	LDI  R30,LOW(15)
	ST   -Y,R30
	CALL _Setcolor
;    1811 			else if(com1_rx_data == 'h') Setcolor(_BLACK);	//   BLACK
	RJMP _0xF5
_0xF4:
	LDI  R30,LOW(104)
	CP   R30,R5
	BRNE _0xF6
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _Setcolor
;    1812 			else putchar(com1_rx_data);
	RJMP _0xF7
_0xF6:
	ST   -Y,R5
	CALL _putchar
;    1813 			com1_rx_eflg = 0;
_0xF7:
_0xF5:
_0xF3:
_0xF1:
_0xEF:
_0xED:
_0xEB:
_0xE9:
_0xE7:
_0xE5:
_0xE3:
_0xE1:
_0xDF:
_0xDD:
_0xDB:
_0xD9:
_0xD7:
	CLR  R4
;    1814 		}
;    1815 	}
_0xD5:
	RJMP _0xD2
;    1816 	return 0;
_0xF8:
	RJMP _0xF8
;    1817 }
;    1818 
;    1819 // =====================================  ޴ ǥ =======================
;    1820 // [μ] void
;    1821 // ---------------------------------------------------------------------------
;    1822 void main_menu_disp(void)
;    1823 {
_main_menu_disp:
;    1824 	printf("\r\n");
	__POINTD1FN _0,53
	CALL SUBOPT_0x5A
;    1825 	printf("========== LCD Test Main =========\r\n");
	__POINTD1FN _0,56
	CALL SUBOPT_0x5A
;    1826 	printf("- 1 : Clrscr                     -\r\n");
	__POINTD1FN _0,93
	CALL SUBOPT_0x5A
;    1827 	printf("- 2 : Cleardevice                -\r\n");
	__POINTD1FN _0,130
	CALL SUBOPT_0x5A
;    1828 	printf("- 3 : Putpixel                   -\r\n");
	__POINTD1FN _0,167
	CALL SUBOPT_0x5A
;    1829 	printf("- 4 : Putpixelb                  -\r\n");
	__POINTD1FN _0,204
	CALL SUBOPT_0x5A
;    1830 	printf("- 5 : Putch                      -\r\n");
	__POINTD1FN _0,241
	CALL SUBOPT_0x5A
;    1831 	printf("- 6 : Putchxy                    -\r\n");
	__POINTD1FN _0,278
	CALL SUBOPT_0x5A
;    1832 	printf("- 7 : Putchxyt                   -\r\n");
	__POINTD1FN _0,315
	CALL SUBOPT_0x5A
;    1833 	printf("- 8 : Puts                       -\r\n");
	__POINTD1FN _0,352
	CALL SUBOPT_0x5A
;    1834 	printf("- 9 : Putsxy                     -\r\n");
	__POINTD1FN _0,389
	CALL SUBOPT_0x5A
;    1835 	printf("- a : Putsxyt                    -\r\n");
	__POINTD1FN _0,426
	CALL SUBOPT_0x5A
;    1836 	printf("- b : Line                       -\r\n");
	__POINTD1FN _0,463
	CALL SUBOPT_0x5A
;    1837 	printf("- c : Rectangle                  -\r\n");
	__POINTD1FN _0,500
	CALL SUBOPT_0x5A
;    1838 	printf("- d : Rectanglefill              -\r\n");
	__POINTD1FN _0,537
	CALL SUBOPT_0x5A
;    1839 	printf("- e : Circle                     -\r\n");
	__POINTD1FN _0,574
	CALL SUBOPT_0x5A
;    1840 	printf("- f : Ellipse                    -\r\n");
	__POINTD1FN _0,611
	CALL SUBOPT_0x5A
;    1841 	printf("- g : Setcolor(_WHITE)           -\r\n");
	__POINTD1FN _0,648
	CALL SUBOPT_0x5A
;    1842 	printf("- h : Setcolor(_BLACK)           -\r\n");
	__POINTD1FN _0,685
	CALL SUBOPT_0x5A
;    1843 	printf("----------------------------------\r\n");
	__POINTD1FN _0,722
	CALL __PUTPARD1
	LDI  R24,0
	CALL _printf
_0x15B:
	ADIW R28,4
;    1844 }
	RET

_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0xF9
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0xFB
	__CPWRN 16,17,2
	BRLO _0xFC
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0xFB:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0xFC:
	RJMP _0xFD
_0xF9:
	LDD  R30,Y+6
	ST   -Y,R30
	CALL _putchar
_0xFD:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,8
	CALL __SAVELOCR6
	LDI  R17,0
_0xFE:
	__GETD1S 20
	CALL SUBOPT_0x3F
	__PUTD1S 20
	CALL SUBOPT_0x40
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x100
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x104
	CPI  R18,37
	BRNE _0x105
	LDI  R17,LOW(1)
	RJMP _0x106
_0x105:
	CALL SUBOPT_0x5B
_0x106:
	RJMP _0x103
_0x104:
	CPI  R30,LOW(0x1)
	BRNE _0x107
	CPI  R18,37
	BRNE _0x108
	CALL SUBOPT_0x5B
	RJMP _0x169
_0x108:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x109
	LDI  R16,LOW(1)
	RJMP _0x103
_0x109:
	CPI  R18,43
	BRNE _0x10A
	LDI  R20,LOW(43)
	RJMP _0x103
_0x10A:
	CPI  R18,32
	BRNE _0x10B
	LDI  R20,LOW(32)
	RJMP _0x103
_0x10B:
	RJMP _0x10C
_0x107:
	CPI  R30,LOW(0x2)
	BRNE _0x10D
_0x10C:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x10E
	ORI  R16,LOW(128)
	RJMP _0x103
_0x10E:
	RJMP _0x10F
_0x10D:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x103
_0x10F:
	CPI  R18,48
	BRLO _0x112
	CPI  R18,58
	BRLO _0x113
_0x112:
	RJMP _0x111
_0x113:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x103
_0x111:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x117
	CALL SUBOPT_0x5C
	LD   R30,X
	CALL SUBOPT_0x5D
	RJMP _0x118
_0x117:
	CPI  R30,LOW(0x73)
	BRNE _0x11A
	CALL SUBOPT_0x5C
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	CALL SUBOPT_0x7
	CALL _strlen
	MOV  R17,R30
	RJMP _0x11B
_0x11A:
	CPI  R30,LOW(0x70)
	BRNE _0x11D
	CALL SUBOPT_0x5C
	CALL __GETD1P
	CALL SUBOPT_0x5E
	CALL SUBOPT_0xA
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x11B:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x11E
_0x11D:
	CPI  R30,LOW(0x64)
	BREQ _0x121
	CPI  R30,LOW(0x69)
	BRNE _0x122
_0x121:
	ORI  R16,LOW(4)
	RJMP _0x123
_0x122:
	CPI  R30,LOW(0x75)
	BRNE _0x124
_0x123:
	__POINTD1FN _tbl10_G2,0
	CALL SUBOPT_0x5E
	LDI  R17,LOW(5)
	RJMP _0x125
_0x124:
	CPI  R30,LOW(0x58)
	BRNE _0x127
	ORI  R16,LOW(8)
	RJMP _0x128
_0x127:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x159
_0x128:
	__POINTD1FN _tbl16_G2,0
	CALL SUBOPT_0x5E
	LDI  R17,LOW(4)
_0x125:
	SBRS R16,2
	RJMP _0x12A
	CALL SUBOPT_0x5C
	CALL __GETW1P
	STD  Y+12,R30
	STD  Y+12+1,R31
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,0
	BRGE _0x12B
	CALL __ANEGW1
	STD  Y+12,R30
	STD  Y+12+1,R31
	LDI  R20,LOW(45)
_0x12B:
	CPI  R20,0
	BREQ _0x12C
	SUBI R17,-LOW(1)
	RJMP _0x12D
_0x12C:
	ANDI R16,LOW(251)
_0x12D:
	RJMP _0x12E
_0x12A:
	CALL SUBOPT_0x5C
	CALL __GETW1P
	STD  Y+12,R30
	STD  Y+12+1,R31
_0x12E:
_0x11E:
	SBRC R16,0
	RJMP _0x12F
_0x130:
	CP   R17,R21
	BRSH _0x132
	SBRS R16,7
	RJMP _0x133
	SBRS R16,2
	RJMP _0x134
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x135
_0x134:
	LDI  R18,LOW(48)
_0x135:
	RJMP _0x136
_0x133:
	LDI  R18,LOW(32)
_0x136:
	CALL SUBOPT_0x5B
	SUBI R21,LOW(1)
	RJMP _0x130
_0x132:
_0x12F:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x137
_0x138:
	CPI  R19,0
	BREQ _0x13A
	SBRS R16,3
	RJMP _0x13B
	__GETD1S 6
	CALL SUBOPT_0x3F
	CALL SUBOPT_0x5E
	CALL SUBOPT_0x40
	RJMP _0x16A
_0x13B:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x16A:
	ST   -Y,R30
	CALL SUBOPT_0x5F
	CPI  R21,0
	BREQ _0x13D
	SUBI R21,LOW(1)
_0x13D:
	SUBI R19,LOW(1)
	RJMP _0x138
_0x13A:
	RJMP _0x13E
_0x137:
_0x140:
	LDI  R18,LOW(48)
	__GETD1S 6
	__SUBD1N -2
	CALL SUBOPT_0x5E
	SBIW R30,2
	SBCI R22,0
	SBCI R23,0
	CALL __GETW1PF
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x142:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x144
	SUBI R18,-LOW(1)
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+12,R30
	STD  Y+12+1,R31
	RJMP _0x142
_0x144:
	CPI  R18,58
	BRLO _0x145
	SBRS R16,3
	RJMP _0x146
	SUBI R18,-LOW(7)
	RJMP _0x147
_0x146:
	SUBI R18,-LOW(39)
_0x147:
_0x145:
	SBRC R16,4
	RJMP _0x149
	CPI  R18,49
	BRSH _0x14B
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,1
	BRNE _0x14A
_0x14B:
	RJMP _0x16B
_0x14A:
	CP   R21,R19
	BRLO _0x14F
	SBRS R16,0
	RJMP _0x150
_0x14F:
	RJMP _0x14E
_0x150:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x151
	LDI  R18,LOW(48)
_0x16B:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x152
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x5F
	CPI  R21,0
	BREQ _0x153
	SUBI R21,LOW(1)
_0x153:
_0x152:
_0x151:
_0x149:
	CALL SUBOPT_0x5B
	CPI  R21,0
	BREQ _0x154
	SUBI R21,LOW(1)
_0x154:
_0x14E:
	SUBI R19,LOW(1)
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,2
	BRLO _0x141
	RJMP _0x140
_0x141:
_0x13E:
	SBRS R16,0
	RJMP _0x155
_0x156:
	CPI  R21,0
	BREQ _0x158
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x5D
	RJMP _0x156
_0x158:
_0x155:
_0x159:
_0x118:
_0x169:
	LDI  R17,LOW(0)
_0x103:
	RJMP _0xFE
_0x100:
	CALL __LOADLOCR6
	ADIW R28,24
	RET
_sprintf:
	PUSH R15
	CALL SUBOPT_0x60
	MOVW R26,R28
	ADIW R26,8
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	CALL SUBOPT_0x61
	CALL __print_G2
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RJMP _0x15A
_printf:
	PUSH R15
	CALL SUBOPT_0x60
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	CALL SUBOPT_0x61
	CALL __print_G2
_0x15A:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET
_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	STS  __screen_cury,R30
	STS  __screen_cury+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	STS  __screen_curx,R30
	STS  __screen_curx+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3:
	ST   -Y,R31
	ST   -Y,R30
	JMP  __Putch

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x4:
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	CALL _Gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	CALL _Gotoxyt
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x7:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8:
	MOVW R30,R20
	__ADDWRN 20,21,1
	SUBI R30,LOW(-_han_conv_buf_G1)
	SBCI R31,HIGH(-_han_conv_buf_G1)
	LD   R30,Z
	MOV  R16,R30
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x9:
	MOV  R31,R17
	LDI  R30,LOW(0)
	MOVW R26,R30
	MOV  R30,R16
	LDI  R31,0
	OR   R30,R26
	OR   R31,R27
	MOVW R18,R30
	ST   -Y,R19
	ST   -Y,R18
	CALL __Putch
	LDI  R17,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	__GETD1S 6
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xB:
	__GETD1S 0
	CALL __PUTPARD1
	JMP  _Puts_f

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xC:
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:39 WORDS
SUBOPT_0xD:
	LDS  R30,__screen_color
	ST   -Y,R30
	JMP  _Putpixel

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xE:
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0xF:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x10:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x11:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x13:
	MOVW R30,R20
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R16
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	ADD  R30,R26
	ADC  R31,R27
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x14:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x15:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x16:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x18:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1A:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1B:
	__GETD1S 28
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	__GETD1S 32
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	__GETD2S 20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x1E:
	CALL __ADDD12
	__PUTD1S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	__GETD2S 24
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x21:
	__GETD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x22:
	__GETD2S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x23:
	LDD  R30,Y+46
	LDD  R31,Y+46+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x24:
	ST   -Y,R17
	ST   -Y,R16
	ST   -Y,R19
	ST   -Y,R18
	CALL _symmetry4
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x25:
	__SUBWRN 18,19,1
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x21
	CALL __SUBD12
	RCALL SUBOPT_0x20
	__GETD2S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x26:
	__ADDWRN 16,17,1
	__GETD1S 16
	RCALL SUBOPT_0x22
	CALL __ADDD12
	__PUTD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x27:
	__GETD2S 12
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	__GETD1N 0x2
	CALL __DIVD21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x29:
	CALL __LSLW12
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R21
	ST   -Y,R20
	MOVW R30,R18
	ORI  R30,LOW(0xB8)
	ST   -Y,R30
	CALL _GLCD_Command
	ST   -Y,R21
	ST   -Y,R20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2A:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ORI  R30,0x40
	ST   -Y,R30
	CALL _GLCD_Command
	ST   -Y,R21
	ST   -Y,R20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2B:
	CALL _GLCD_Dread
	MOV  R17,R30
	ST   -Y,R21
	ST   -Y,R20
	CALL _GLCD_Dread
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2C:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	COM  R30
	COM  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2D:
	ST   -Y,R21
	ST   -Y,R20
	MOVW R30,R18
	ORI  R30,LOW(0xB8)
	ST   -Y,R30
	CALL _GLCD_Command
	ST   -Y,R21
	ST   -Y,R20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x2E:
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	ORI  R30,0x40
	ST   -Y,R30
	CALL _GLCD_Command
	ST   -Y,R21
	ST   -Y,R20
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2F:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	COM  R30
	COM  R31
	AND  R17,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	OR   R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x30:
	ST   -Y,R21
	ST   -Y,R20
	MOVW R30,R18
	ADIW R30,1
	ORI  R30,LOW(0xB8)
	ST   -Y,R30
	CALL _GLCD_Command
	ST   -Y,R21
	ST   -Y,R20
	RJMP SUBOPT_0x2E

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x31:
	LDS  R30,__screen_curx
	LDS  R31,__screen_curx+1
	STD  Y+8,R30
	STD  Y+8+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x32:
	LDS  R30,__screen_cury
	LDS  R31,__screen_cury+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:66 WORDS
SUBOPT_0x33:
	MOVW R26,R16
	__ADDWRN 16,17,1
	LD   R18,X
	CLR  R19
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R18
	LDS  R30,__screen_color
	ST   -Y,R30
	CALL _Putpixelb
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x7F)
	LDI  R30,HIGH(0x7F)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x34:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x35:
	RCALL SUBOPT_0x32
	ADIW R30,8
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x36:
	RCALL SUBOPT_0x2
	LDS  R26,__screen_curx
	LDS  R27,__screen_curx+1
	CPI  R26,LOW(0x80)
	LDI  R30,HIGH(0x80)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x37:
	LDI  R30,0
	STS  __screen_curx,R30
	STS  __screen_curx+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x38:
	RCALL SUBOPT_0x32
	ADIW R30,16
	RCALL SUBOPT_0x1
	LDS  R26,__screen_cury
	LDS  R27,__screen_cury+1
	CPI  R26,LOW(0x40)
	LDI  R30,HIGH(0x40)
	CPC  R27,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x39:
	LDI  R30,0
	STS  __screen_cury,R30
	STS  __screen_cury+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3A:
	MOVW R16,R30
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x3B:
	CALL __MULB1W2U
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(_ib_G1)
	LDI  R31,HIGH(_ib_G1)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R16
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x3C:
	CLR  R22
	CLR  R23
	__GETD2N 0x20
	CALL __MULD12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3D:
	CALL __PUTPARD1
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3E:
	LDI  R30,LOW(32)
	LDI  R31,HIGH(32)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3F:
	__SUBD1N -1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x40:
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	__GETBRPF 30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x41:
	CLR  R22
	CLR  R23
	CALL __ADDD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x42:
	MOVW R20,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	MOVW R18,R30
	MOVW R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x43:
	MOVW R30,R16
	ADIW R30,1
	RJMP SUBOPT_0x3A

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x44:
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	STD  Y+11,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:52 WORDS
SUBOPT_0x45:
	LDD  R30,Y+10
	LDI  R31,0
	SUBI R30,LOW(176)
	SBCI R31,HIGH(176)
	LDI  R26,LOW(94)
	LDI  R27,HIGH(94)
	CALL __MULW12U
	MOVW R26,R30
	LDD  R30,Y+11
	LDI  R31,0
	SUBI R30,LOW(161)
	SBCI R31,HIGH(161)
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDI  R26,LOW(_Conv_Tbl*2)
	LDI  R27,HIGH(_Conv_Tbl*2)
	LDI  R24,BYTE3(_Conv_Tbl*2)
	CLR  R22
	CLR  R23
	CALL __LSLD1
	CALL __ADDD12
	CALL __GETW1PF
	STD  Y+6,R30
	STD  Y+6+1,R31
	MOVW R30,R18
	__ADDWRN 18,19,1
	SUBI R30,LOW(-_han_conv_buf_G1)
	SBCI R31,HIGH(-_han_conv_buf_G1)
	MOVW R26,R30
	LDD  R30,Y+7
	ANDI R31,HIGH(0x0)
	ST   X,R30
	MOVW R30,R18
	__ADDWRN 18,19,1
	SUBI R30,LOW(-_han_conv_buf_G1)
	SBCI R31,HIGH(-_han_conv_buf_G1)
	MOVW R26,R30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ANDI R31,HIGH(0xFF)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES, CODE SIZE REDUCTION:73 WORDS
SUBOPT_0x46:
	MOVW R30,R18
	__ADDWRN 18,19,1
	SUBI R30,LOW(-_han_conv_buf_G1)
	SBCI R31,HIGH(-_han_conv_buf_G1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x47:
	LDI  R26,LOW(_han_conv_buf_G1)
	LDI  R27,HIGH(_han_conv_buf_G1)
	ADD  R26,R18
	ADC  R27,R19
	LDI  R30,LOW(0)
	ST   X,R30
	CALL __LOADLOCR6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x48:
	__GETD2S 12
	RJMP SUBOPT_0x41

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x49:
	MOVW R30,R16
	ADIW R30,1
	MOVW R16,R30
	RJMP SUBOPT_0x48

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4A:
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ADD  R30,R10
	ADC  R31,R11
	LD   R30,Z
	ANDI R30,LOW(0x80)
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4B:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _GLCD_Busy
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4C:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4D:
	CALL __PUTPARD1
	JMP  _Putsxyt_f

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4E:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x4F:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x50:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x51:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x52:
	CALL __PUTPARD1
	LDI  R24,0
	CALL _sprintf
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x53:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x54:
	LDI  R30,LOW(127)
	LDI  R31,HIGH(127)
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x4F

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x55:
	LDI  R30,LOW(127)
	LDI  R31,HIGH(127)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(63)
	LDI  R31,HIGH(63)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x56:
	LDI  R30,LOW(63)
	LDI  R31,HIGH(63)
	ST   -Y,R31
	ST   -Y,R30
	CALL _Line
	RJMP SUBOPT_0x4F

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x57:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x3E

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x58:
	ST   -Y,R31
	ST   -Y,R30
	RJMP SUBOPT_0x4F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x59:
	LDI  R30,LOW(118)
	LDI  R31,HIGH(118)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(54)
	LDI  R31,HIGH(54)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:69 WORDS
SUBOPT_0x5A:
	CALL __PUTPARD1
	LDI  R24,0
	CALL _printf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x5B:
	ST   -Y,R18
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x5C:
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	SBIW R26,4
	STD  Y+18,R26
	STD  Y+18+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x5D:
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5E:
	__PUTD1S 6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5F:
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x60:
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x61:
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETD1P
	CALL __PUTPARD1
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,8
	RJMP SUBOPT_0x58

_memcpyf:
	ldd  r25,y+1
	ld   r24,y
	adiw r24,0
	breq __memcpyf1
	ldd  r27,y+7
	ldd  r26,y+6
	ldd  r22,y+4
	ldd  r31,y+3
	ldd  r30,y+2
	out  rampz,r22
__memcpyf0:
	elpm r0,z+
	st   x+,r0
	sbiw r24,1
	brne __memcpyf0
__memcpyf1:
	ldd  r31,y+7
	ldd  r30,y+6
	adiw r28,8
	ret

_memset:
	ldd  r27,y+1
	ld   r26,y
	adiw r26,0
	breq __memset1
	ldd  r31,y+4
	ldd  r30,y+3
	ldd  r22,y+2
__memset0:
	st   z+,r22
	sbiw r26,1
	brne __memset0
__memset1:
	ldd  r30,y+3
	ldd  r31,y+4
	adiw r28,5
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
	ld   r22,y+
	ld   r23,y+
	out  rampz,r22
__strlenf0:
	elpm r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__SUBD12:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	RET

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__LSLD1:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULB1W2U:
	MOV  R22,R30
	MUL  R22,R26
	MOVW R30,R0
	MUL  R22,R27
	ADD  R31,R0
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETW1PF:
	OUT  RAMPZ,R22
	ELPM R0,Z+
	ELPM R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD20:
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
	OUT  RAMPZ,R22
__INITLOC0:
	ELPM R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
